/*
 * ArrayDimensions.java
 *
 * Created on January 30, 2002, 9:24 PM
 */

//package panelsAndTools;

import java.lang.*;
import java.io.*;

/**
 *
 * @author  _
 * @version 
 */


public class ArrayDimensions implements Cloneable, Serializable {
    public ArrayDimensions() {
        iXSize = 1;
        iYSize = 1;
    }
    
    public Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6        
        try {
            ArrayDimensions adObject = (ArrayDimensions)super.clone();
            return adObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of ArrayDimensions is not supported." );
            return null;
        }
    }
    
    public Status setArrayDimensions( int iThisXSize, int iThisYSize ) {
        Status statInformation;
        String stMessage;
        
        if ( iThisXSize >= 1 ) {            
            if ( iThisYSize >= 1 ) {
                iXSize = iThisXSize;
                iYSize = iThisYSize;
                statInformation = new Status( I_OK );
            }
            else {
                stMessage = "Array width must be 1 or greater.";
                statInformation = new Status( I_ILLEGAL_Y, stMessage );
            }
        }
        else {
            stMessage = "Array length must be 1 or greater.";
            statInformation = new Status( I_ILLEGAL_X, stMessage );
        }
        
        return statInformation;
    }
    
    public ArrayDimensions getArrayDimensions() {       
        return (ArrayDimensions)this.clone();
    }
    
    public int getXDimension() {
        return iXSize;
    }
        
    public int getYDimension() {
        return iYSize;
    }
    
    
    // instance variables
    private int iXSize;
    private int iYSize;
    
    // class variables
    public static final int I_UNDEFINED = -8888;
    
    // error code
    public static final int I_OK = 0;
    public static final int I_ILLEGAL_X = -1;
    public static final int I_ILLEGAL_Y = -2;
}