/*
 * DataObjectPropertyTextView.java
 *
 * Created on April 2, 2002, 9:45 AM
 */

import java.util.ArrayList;

/**
 *
 * @author  _
 * @version 
 */

public class DataObjectPropertyTextView {
    
    public static String getRestrictionName( int iRestriction) {
        String stRestrictionName;
        
        switch( iRestriction ) {            
            case DataObject.I_RESTRICTION_VARIABLE:
                stRestrictionName = "Variable";
                break;
                
            case DataObject.I_RESTRICTION_CONSTANT:
                stRestrictionName = "Constant";
                break;
                
            case DataObject.I_RESTRICTION_LITERAL:
                stRestrictionName = "Literal";
                break;
                                
            default:
                stRestrictionName = "None";
                break;
        }      
        
        return stRestrictionName;
    }        

    public static String getStructureName( int iStructure ) {
        String stStructureName;

        switch( iStructure ) {            
            case DataObject.I_STRUCTURE_SINGLE_VALUE:
                stStructureName = "Single Value";
                break;
                
            case DataObject.I_STRUCTURE_1D_ARRAY:
                stStructureName = "1-D Array";
                break;
                
            case DataObject.I_STRUCTURE_2D_ARRAY:
                stStructureName = "2-D Array";
                break;
                                
            default:
                stStructureName = "None";
                break;
        }      
        
        return stStructureName;
    }

    public static String getTypeName( int iType ) {
        String stTypeName;
              
        switch( iType ) {            
            case DataObject.I_SYSTEM_TYPE_KEYBOARD:
                stTypeName = "Keyboard";
                break;
                
            case DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER:
                stTypeName = "Single Register";
                break;
                
            case DataObject.I_SYSTEM_TYPE_DOUBLE_REGISTER:
                stTypeName = "Double Register";
                break;
                
            case DataObject.I_SYSTEM_TYPE_CONDITION_CODE:
                stTypeName = "Condition Code";
                break;
                
            case DataObject.I_SYSTEM_TYPE_DISPLAY:
                stTypeName = "Display";
                break;
                
            case DataObject.I_TYPE_LABEL:
                stTypeName = "Label";
                break;
                
            case DataObject.I_TYPE_CHARACTER:
                stTypeName = "Charactrer";
                break;
                
            case DataObject.I_TYPE_INTEGER:
                stTypeName = "Integer";
                break;
                
            case DataObject.I_TYPE_DECIMAL:
                stTypeName = "Decimal";
                break;
                
            case DataObject.I_TYPE_RECORD:
                stTypeName = "Record";
                break;
                
            default:
                stTypeName = "None";
                break;
        }      
        
        return stTypeName;
    }
    
    public static ArrayList getRestrictionNamesList() {
        ArrayList alList;
        int iIndex;
        
        alList = new ArrayList( 2 );

        for ( iIndex = DataObject.I_FIRST_RESTRICTION_INDEX; 
              iIndex <= DataObject.I_LAST_RESTRICTION_INDEX - 1; iIndex++ ) {
            alList.add( getRestrictionName( iIndex ) );
        }                
        return alList;
    }
    
    public static ArrayList getStructureNamesList() {
        ArrayList alList;
        int iIndex;
        
        alList = new ArrayList( 2 );
        
        for ( iIndex = DataObject.I_FIRST_STRUCTURE_INDEX; 
              iIndex <= DataObject.I_LAST_STRUCTURE_INDEX; iIndex++ ) {
            alList.add( getStructureName( iIndex ) );
        }
        return alList;
    }
    
    public static ArrayList getTypeNamesList() {
        ArrayList alList;
        int iIndex;
        
        alList = new ArrayList( 4 );
        
        for ( iIndex = DataObject.I_FIRST_NON_SYSTEM_TYPE_INDEX; 
              iIndex <= DataObject.I_LAST_NON_SYSTEM_TYPE_INDEX; iIndex++ ) {
            alList.add( getTypeName( iIndex ) );
        }
        return alList;
    }    
}