/*
 * DataObjectRenderer.java
 *
 * Created on April 25, 2002, 6:54 PM
 */

import javax.swing.*;
import java.awt.*;

/**
 *
 * @author  _
 * @version 
 */

public class DataObjectRenderer {
    public static void setColorScheme( JComponent jcThisComponent, int iColorScheme ) {
        jcThisComponent.setOpaque( true );
        
        if ( iColorScheme == I_COLOR_USER ) {
            jcThisComponent.setBackground( colorDarkBlue );
            jcThisComponent.setForeground( Color.white );
        }
        else if ( iColorScheme == I_COLOR_SYSTEM ) {
            jcThisComponent.setBackground( Color.white );
            jcThisComponent.setForeground( Color.black );
            jcThisComponent.setBorder( BorderFactory.createLineBorder( Color.black, 1 ) );
        }
        else {
            jcThisComponent.setOpaque( false );
            jcThisComponent.setBorder( BorderFactory.createLineBorder( Color.black, 0 ) );
        }
    }
        
    public static void renderOperand( int iOpcode, Operand operThisOperand, 
        JLabel jlIcon, JLabel jlText, JLabel jlArrayText, PaintableLabel plUnderline, 
        int iXLocation, int iYLocation, boolean bView, JTextArea jtaMoveInformation ) {

        NameAndDataObjectWrapper nadowOperand;
        DataObject doTemp;
        String stText, stStartingIndex, stEndingIndex, stIndex;
        int iType, iRestriction, iStructure, iIndexSetting;
        Rectangle rectArea;

/*        System.out.println( "BEFORE DataObjectRenderer.renderOperand: " );
        System.out.println( "jlArrayText: " + jlArrayText.getText() );
        System.out.println( "jlArrayText opaque: " + jlArrayText.isOpaque() );
        System.out.println( "jlText: " + jlText.getText() );
        System.out.println( "jlText opaque: " + jlText.isOpaque() );
        System.out.println( "underline y: " + plUnderline.getBounds().getY() );*/
        
        jlText.setOpaque( false );
        jlText.setText( "" );
        jlArrayText.setOpaque( false );
        jlArrayText.setText( "" );
        //jtaMoveInformation.setOpaque( false );
        //jtaMoveInformation.setText( "" );
        
        nadowOperand = operThisOperand.getOperandData();
        doTemp = nadowOperand.getObject();
        iType = doTemp.getType();
        iRestriction = doTemp.getRestriction();
        iStructure = doTemp.getStructure();
        iIndexSetting = operThisOperand.getArrayElementIndexSetting();
                
        // adjust to accomodate space for array dimension that will result
        // in 2 rows of text instead of 1 which will move the "restriction" line
        // down when appearing ONLY in the program listing 
        if ( iRestriction != DataObject.I_RESTRICTION_LITERAL ) {
            stText = nadowOperand.getName();
            jlText.setText( stText );
        }
        else {
            stText = (String)doTemp.getValue();
            //System.out.println( "DOR: literal = " + stText );
            jlText.setText( stText );            
        }

        if ( bView == B_PROGRAM_LISTING )  {
            if ( iIndexSetting != Operand.I_UNDEFINED ) {
                System.out.println( "Array...move underline down!" );
                plUnderline.setDimensions( iXLocation, 
                    InstructionTableCellRenderer.I_ICON_LINE_STARTING_HEIGHT + 14, /* was 20 */ 
                    I_ICON_LINE_WIDTH, I_ICON_LINE_HEIGHT );
            }
            else {
                plUnderline.setDimensions( iXLocation, 
                    InstructionTableCellRenderer.I_ICON_LINE_STARTING_HEIGHT, 
                    I_ICON_LINE_WIDTH, I_ICON_LINE_HEIGHT );
            }                
        }
        /*else if ( bView == B_PANEL ) {
            if ( iStructure == DataObject.I_STRUCTURE_1D_ARRAY ) {
                rectArea = jlIcon.getBounds();
                rectArea.setLocation( (int)rectArea.getX(), (int)rectArea.getY() - 2 );
                jlIcon.setBounds( rectArea );

                rectArea = jlText.getBounds();
                rectArea.setLocation( (int)rectArea.getX(), (int)rectArea.getY() - 3 );
                jlText.setBounds( rectArea );                
                
                rectArea = jlArrayText.getBounds();
                rectArea.setLocation( (int)rectArea.getX(), (int)rectArea.getY() - 7 );
                jlArrayText.setBounds( rectArea );
            }
        }*/
                
        if ( iRestriction == DataObject.I_RESTRICTION_VARIABLE ) {
            if ( bView == B_PROGRAM_LISTING ) {
                plUnderline.setGraphicsType( PaintableLabel.I_DOTTED_LINE );
            }
            else {
                plUnderline.setGraphicsType( PaintableLabel.I_DOTTED_BORDER );
            }
        }
        else if ( iRestriction == DataObject.I_UNDEFINED ) {
            plUnderline.setGraphicsType( PaintableLabel.I_NONE );
            plUnderline.setOpaque( false );
        }
        else {
            if ( bView == B_PROGRAM_LISTING ) {
                plUnderline.setGraphicsType( PaintableLabel.I_SOLID_LINE );        
            }
            else {
                plUnderline.setGraphicsType( PaintableLabel.I_SOLID_BORDER );
            }
        }        

        if ( ( iType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  ||
             ( iType == DataObject.I_SYSTEM_TYPE_DOUBLE_REGISTER )  ||
             ( iType == DataObject.I_SYSTEM_TYPE_KEYBOARD )  ||
             ( iType == DataObject.I_SYSTEM_TYPE_DISPLAY ) ) {
            setColorScheme( jlText, I_COLOR_SYSTEM );
            setColorScheme( jlArrayText, I_COLOR_UNDEFINED );
            jlIcon.setOpaque( true );
            jlIcon.setIcon( doTemp.getIcon() );
        }
        else if ( iType != DataObject.I_UNDEFINED ) {
            setColorScheme( jlText, I_COLOR_USER );
            
            if ( iIndexSetting == Operand.I_ARRAY_INDEX_NUMBER ) {
                jlArrayText.setText( "[" + Integer.toString( 
                    operThisOperand.getArrayElementIndex() ) + "]" );
                setColorScheme( jlArrayText, I_COLOR_USER );
            }
            else if ( ( iIndexSetting == Operand.I_ARRAY_INDEX_DATA_OBJECT )  ||
                      ( iIndexSetting == Operand.I_ARRAY_INDEX_REGISTER ) ) {
                jlArrayText.setText( "[" + operThisOperand.getArrayElementDataObject()
                    + "]" );
                setColorScheme( jlArrayText, I_COLOR_USER );
            }
            else if ( ( iIndexSetting == Operand.I_ARRAY_INDEX_RANGE )  &&
                      ( bView == B_PROGRAM_LISTING ) ) {
                jlArrayText.setText( "[" + operThisOperand.getStartingArrayIndex() 
                    + "-" + operThisOperand.getEndingArrayIndex() + "]" );
                setColorScheme( jlArrayText, I_COLOR_USER );
            }
            else if ( iIndexSetting == Operand.I_UNDEFINED ) {
                jlArrayText.setText( "" );
                setColorScheme( jlArrayText, I_COLOR_UNDEFINED );                    
            }

            jlIcon.setOpaque( true );
            jlIcon.setIcon( doTemp.getIcon() );
        }
        else {
            setColorScheme( jlText, I_COLOR_UNDEFINED );
            setColorScheme( jlArrayText, I_COLOR_UNDEFINED );            
            jlIcon.setOpaque( false );
            
            if ( bView == B_PANEL ) {
                jlIcon.setIcon( doTemp.getIcon() );    
            }
        }
        //System.out.println( "Rendering " + nadowOperand.getName() + " with restriction = " + doTemp.getRestriction() );
        //System.out.println( "DOR:OPCODE = " + iOpcode );
                
        //System.out.println( "DOR...rest. received = " + iRestriction + " or " 
        //    + DataObjectPropertyTextView.getRestrictionName( iRestriction ) );
        
                
/*        System.out.println( "AFTER DataObjectRenderer.renderOperand: " );
        System.out.println( "jlArrayText: " + jlArrayText.getText() );
        System.out.println( "jlArrayText opaque: " + jlArrayText.isOpaque() );
        System.out.println( "jlText: " + jlText.getText() );
        System.out.println( "jlText opaque: " + jlText.isOpaque() );
        System.out.println( "underline y: " + plUnderline.getBounds().getY() );*/
    }
    
    // only renders label types
    public static void renderLabel( NameAndDataObjectWrapper nadowLabel, JLabel jlIcon,
        JLabel jlText ) {
            
        DataObject doTemp;
        String stText;
        
        stText = nadowLabel.getName();
                
        if ( stText.equals( "" ) == false ) {
            jlText.setOpaque( true );
            doTemp = nadowLabel.getObject();            
            jlIcon.setIcon( doTemp.getIcon() );
            jlText.setText( stText );
            jlText.setToolTipText( stText );
            setColorScheme( jlText, I_COLOR_USER );
        }
        else {
            jlText.setText( "" );
            jlText.setToolTipText( "" );
            jlText.setOpaque( false );
            jlIcon.setIcon( new ImageIcon( "" ) );
        }
    }            
            
    private static String formatNumber( int iNumber ) {
        String stNumber;
        
        stNumber = String.valueOf( iNumber );
            
        if ( stNumber.length() == 2 ) {
            stNumber = "0" + stNumber;
        }
        else if ( stNumber.length() == 1 ) {
            stNumber = "00" + stNumber;
        }
        return stNumber;
    }
    
    // constants
    public static final Color colorDarkBlue;
    public static final int I_ICON_TEXT_WIDTH = 80;
    public static final int I_ICON_TEXT_HEIGHT = 18;
    public static final int I_ICON_LINE_WIDTH = 80;
    public static final int I_ICON_LINE_HEIGHT = 4;    
        
    public static final int I_COLOR_UNDEFINED = -1000;
    public static final int I_COLOR_USER = 1;
    public static final int I_COLOR_SYSTEM = 2;
    
    public static final boolean B_PROGRAM_LISTING = true;
    public static final boolean B_PANEL = false;
    
    static {
        colorDarkBlue = new Color( 0, 0, 128 );
    }
}