/*
 * Code.java
 *
 * Created on January 19, 2002, 7:39 PM
 */

//package panelsAndTools;
import java.io.*;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */

public class Instruction implements Cloneable, Serializable {    
    public Instruction() {
        nadowLabel = new NameAndDataObjectWrapper();
        opOpcode = new Opcode();
        operLeftOperand = new Operand();
        operRightOperand = new Operand();
        operBranchLabelOperand = new Operand();
        stComments = "";
        stPseudocode = "";
        bValidInstruction = false;
    }
    
    protected Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6
        System.err.println( "Cloning Instruction..." );
        try {
            System.err.println( "-1-" );
            Instruction inThisInstruction = (Instruction)super.clone();
            System.err.println( "-2-" );
            inThisInstruction.nadowLabel = (NameAndDataObjectWrapper)this.nadowLabel.clone();                
            System.err.println( "-3-" );
            inThisInstruction.opOpcode = (Opcode)this.opOpcode.clone();
            System.err.println( "-4-" );
            inThisInstruction.operLeftOperand = 
                (Operand)this.operLeftOperand.clone();
            System.err.println( "-5-" );
            inThisInstruction.operRightOperand = (Operand)this.operRightOperand.clone();
            System.err.println( "-6-" );
            inThisInstruction.operBranchLabelOperand = 
                (Operand)this.operBranchLabelOperand.clone();
            System.err.println( "-7-" );
            inThisInstruction.stPseudocode = new String( this.stPseudocode );
            return inThisInstruction;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of Instruction is not supported." );
            return null;
        }
    }    
    
    public void setLabel( NameAndDataObjectWrapper nadowLabelObject ) {
        nadowLabel = nadowLabelObject;
        bValidInstruction = false;
    }
    
    public NameAndDataObjectWrapper getLabel() {
        return (NameAndDataObjectWrapper)nadowLabel.clone();
    }
    
    public void setOpcode( Opcode opThisOpcode ) {
        opOpcode = opThisOpcode;
        bValidInstruction = false;
    }
    
    public Opcode getOpcode() {
        //return (Opcode)SerializedClone.cloneObject( opOpcode );
        return (Opcode)opOpcode.clone();
    }
    
    public void setLeftOperand( Operand operThisOperand ) {
        operLeftOperand = operThisOperand;
    }
    
    public Operand getLeftOperand() {
        return (Operand)operLeftOperand.clone();
    }
    
    public void setRightOperand( Operand operThisOperand ) {
        operRightOperand = operThisOperand;
    }
        
    public Operand getRightOperand() {
        return (Operand)operRightOperand.clone();
    }

    public void setBranchLabelOperand( Operand operThisOperand ) {
        operBranchLabelOperand = operThisOperand;
    }    

    public Operand getBranchLabelOperand() {
        return (Operand)operBranchLabelOperand.clone();
    }
            
    public Status setComments( String stTheseComments ) {
        int iLength;
        Status statInformation;
        String stMessage;
        
        stComments = stTheseComments;
        statInformation = new Status( I_OK );
        //bValidInstruction = false;
        return statInformation;
    }
    
    public String getComments() {
        return new String( stComments );
    }
    
    public Status validateInstruction() {
        Status statInformation;
        String stMessage;
        int iOpcode;
        
        iOpcode = opOpcode.getOpcode();
        
        if ( iOpcode != Opcode.I_OPCODE__IGNORE ) {
            if ( iOpcode != Opcode.I_OPCODE__COMMENTS ) {
                if ( nadowLabel.getObject().getType() == DataObject.I_TYPE_LABEL ) {
                    System.out.println( "Branch/compare operand type = " + operBranchLabelOperand.getOperandType() );
                    statInformation = opOpcode.validateOperands( operLeftOperand, 
                        operRightOperand, operBranchLabelOperand );

                    if ( statInformation.getStatusNumber() == I_OK ) {
                        bValidInstruction = true;
                    }
                    else {
                        bValidInstruction = false;
                    }
                }
                else {
                    bValidInstruction = false;
                    stMessage = "The object named " + nadowLabel.getName() + " is not "
                        + "a valid label type.";
                    statInformation = new Status( I_INVALID_LABEL, stMessage );
                }
            }
            else {
                // labels are not used with section comments
                bValidInstruction = true;
                statInformation = new Status( I_OK );
            }
        }
        else {
            // "nothing" instruction...so valid
            bValidInstruction = true;
            statInformation = new Status( I_OK );
        }
        
        ///////
        generatePseudocodeInstruction( statInformation.getStatusMessage() );
        ///////
        
        System.out.println( "Instruction is " + bValidInstruction );
        System.out.println( "Status message = " +statInformation.getStatusMessage() );
        return statInformation;
    }
    
    public boolean isValidInstruction() {
        return bValidInstruction;
    }
    
    public Vector exportState() {
        Vector vData;
        
        vData = new Vector();
        vData.setSize( I_TOTAL_FIELD_COUNT );
        vData.set( I_LABEL, nadowLabel.exportState() );
        //System.out.println( "INSTRUCTION:  nadowLabel.exportState()=" + nadowLabel.exportState() );
        vData.set( I_OPCODE, new Integer( opOpcode.getOpcode() ) );
        //System.out.println( "INSTRUCTION:  opOpcode.getOpcode()=" + opOpcode.getOpcode() );
        vData.set( I_COMMENTS, stComments );
        //System.out.println( "INSTRUCTION:  stComments=" + stComments );
        vData.set( I_VALID, new Boolean( bValidInstruction ) );
        //System.out.println( "INSTRUCTION:  bValidInstruction=" + bValidInstruction );
        vData.set( I_OPERAND_LEFT, operLeftOperand.exportState() );
        //System.out.println( "INSTRUCTION:  operLeftOperand=" + operLeftOperand );
        vData.set( I_OPERAND_RIGHT, operRightOperand.exportState() );
        //System.out.println( "INSTRUCTION:  operRightOperand=" + operRightOperand );
        vData.set( I_OPERAND_BRANCH_LABEL, operBranchLabelOperand.exportState() );
        //System.out.println( "INSTRUCTION:  operBranchLabelOperand=" + operBranchLabelOperand );
        //System.out.println( "INSTRUCTION:  vData=" + vData );
        vData.set( I_PSEUDOCODE_MESSAGE, stPseudocode );
        return vData;
    }
    
    public void importState( Vector vData ) {
        nadowLabel.importState( (Vector)vData.get( I_LABEL ) );
        opOpcode.setOpcode( ((Integer)vData.get( I_OPCODE )).intValue() );
        stComments = (String)vData.get( I_COMMENTS );
        bValidInstruction = ((Boolean)vData.get( I_VALID )).booleanValue();
        operLeftOperand.importState( (Vector)vData.get( I_OPERAND_LEFT ) );
        operRightOperand.importState( (Vector)vData.get( I_OPERAND_RIGHT ) );
        operBranchLabelOperand.importState( (Vector)vData.get( I_OPERAND_BRANCH_LABEL ) );
        stPseudocode = (String)vData.get( I_PSEUDOCODE_MESSAGE );
        
        ///////
        //generatePseudocodeInstruction();
        ///////        
    }
    
    public String getPseudocode() {
        return stPseudocode;
    }
    
    /////////////////////// PRIVATE METHOD \\\\\\\\\\\\\\\\\\\\\\\    
    private void generatePseudocodeInstruction( String stErrorMessage ) {
        String stLeft, stRight, stLabel, stPhrase1, stPharse2, stPhrase3;
        int iOpcode, iLeftStructure, iRightStructure, iLeftType, iRightType,
            iLeftStart, iRightStart, iLeftEnd, iRightEnd;
        Object objTemp;
        boolean bLeftCharacterArray, bRightCharacterArray;

        if ( bValidInstruction == false ) {
            stPseudocode = "Error: " + stErrorMessage;
        }
        else {
            // EXCEPT FOR BRANCH/COMPARE...left side/source = right operand
            // right side/destination = left operand                
            iOpcode = opOpcode.getOpcode();

            if ( ( iOpcode >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                 ( iOpcode <= Opcode.I_OPCODE__BRANCH_LAST ) ) {        
                stLeft = getProperOperandName( operLeftOperand, B_USE_LITERAL_PHRASE );
                stRight = getProperOperandName( operRightOperand, B_USE_LITERAL_PHRASE );
            }
            else {
                stLeft = getProperOperandName( operRightOperand, B_USE_LITERAL_PHRASE );
                stRight = getProperOperandName( operLeftOperand, B_USE_LITERAL_PHRASE );        
            }
            objTemp = operBranchLabelOperand.getOperandName();        
            if ( objTemp instanceof String ) {
                stLabel = (String)objTemp;
            }
            else {
                stLabel = "";
            }

            if ( ( iOpcode >= Opcode.I_OPCODE__MATH_FIRST )  &&
                 ( iOpcode <= Opcode.I_OPCODE__MATH_LAST ) ) {
                stPhrase3 = " and put the result in " + stRight + ".";
                if ( iOpcode == Opcode.I_OPCODE__MATH_ADD ) {
                    stPseudocode = "Add " + stLeft + " to " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__MATH_SUBTRACT ) {
                    stPseudocode = "Subtract " + stLeft + " from " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__MATH_MULTIPLY ) {
                    stPseudocode = "Multiply " + stRight + " by " + stLeft + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__MATH_DIVIDE ) {
                    stPseudocode = "Divide " + stRight + " by " + stLeft + stPhrase3;  
                }
                else if ( iOpcode == Opcode.I_OPCODE__MATH_MODULUS ) {
                    stPseudocode = "Get the value of " + stLeft + " modulus " + stRight
                        + stPhrase3;
                }            
                else {
                    stPseudocode = "";
                }
            }
            else if ( ( iOpcode >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                      ( iOpcode <= Opcode.I_OPCODE__BRANCH_LAST ) ) {
                stPhrase3 = ", then begin execution at the line with label " + stLabel + ".";
                if ( iOpcode == Opcode.I_OPCODE__BRANCH_LESS_THAN ) {
                    stPseudocode = "If " + stLeft + " is less than " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_LESS_THAN_OR_EQUAL ) {
                    stPseudocode = "If " + stLeft + " is less than or equal to " 
                        + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_EQUAL ) {
                    stPseudocode = "If " + stLeft + " is equal to " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_GREATER_THAN ) {
                    stPseudocode = "If " + stLeft + " is greater than " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_GREATER_THAN_OR_EQUAL ) {
                    stPseudocode = "If " + stLeft + " is greater than or equal to " 
                        + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_NOT_EQUAL ) {
                    stPseudocode = "If " + stLeft + " is not equal to " + stRight + stPhrase3;
                }
                else if ( iOpcode == Opcode.I_OPCODE__BRANCH_ALWAYS ) {
                    stPseudocode = "Begin execution at the line with label " + stLabel + ".";
                }
                else {
                    stPseudocode = "";
                }
            }
            else if ( iOpcode == Opcode.I_OPCODE__MOVE_ALL ) {
                iLeftType = operRightOperand.getOperandType();
                iRightType = operLeftOperand.getOperandType();

                if ( iLeftType == DataObject.I_SYSTEM_TYPE_KEYBOARD ) {
                    stPseudocode = "Store input from the keyboard into " + stRight + ".";
                }
                else if ( iRightType == DataObject.I_SYSTEM_TYPE_DISPLAY ) {
                    stPseudocode = "Display the contents of " + stLeft + " to the screen.";
                }
                else if ( ( ( AssemblyProgramView.isCharacterType( iLeftType ) )  &&
                            ( AssemblyProgramView.isCharacterType( iRightType ) ) )  ||
                          ( ( AssemblyProgramView.isIntegerType( iLeftType ) )  &&
                            ( AssemblyProgramView.isIntegerType( iRightType ) ) ) ) {
                    stPseudocode = "Copy the contents of " + stLeft + " into " + stRight + ".";
                }
                else {                
                    stPseudocode = "Copy the contents of " + stLeft + " into " + stRight
                        + " and convert the contents to the correct type.";
                }
            }
            else if ( iOpcode == Opcode.I_OPCODE__MOVE_PARTS ) {
                iLeftType = operRightOperand.getOperandType();
                iRightType = operLeftOperand.getOperandType();
                iLeftStructure = operRightOperand.getOperandStructure();
                iRightStructure = operLeftOperand.getOperandStructure();
                bLeftCharacterArray = 
                    AssemblyProgramView.isCharacterArray( iRightType, iRightStructure );
                bRightCharacterArray = 
                    AssemblyProgramView.isCharacterArray( iLeftType, iLeftStructure );
                iLeftStart = operRightOperand.getStartingArrayIndex();
                iRightStart = operLeftOperand.getStartingArrayIndex(); 

                if ( ( bLeftCharacterArray == true )  &&  ( bRightCharacterArray == true ) ) {
                    iLeftEnd = operRightOperand.getEndingArrayIndex();
                    iRightEnd = operLeftOperand.getEndingArrayIndex();

                    stPseudocode = "Copy character array elements " 
                        + iLeftStart + "-" + iLeftEnd + " in " + stLeft + " to "
                        + "character array elements " + iRightStart + "-" + iRightEnd
                        + " in " + stRight + ".";
                }
                else if ( ( bRightCharacterArray == true )  &&  
                          ( bLeftCharacterArray == false ) ) {
                    stPseudocode = "Copy character array element " + iLeftStart
                        + " in " + stLeft + " to the value of the character named "
                        + stRight + ".";
                }
                else if ( ( bRightCharacterArray == false )  &&  
                          ( bLeftCharacterArray == true ) ) {
                    stPseudocode = "Copy the value of the character named " + stLeft
                        + " into character array element " + iRightStart + " in "
                        + stRight + ".";
                }
                else {
                    stPseudocode = "";
                }
            }
            else {  // ignore comments
                stPseudocode = "";
            }
        } // end of non-error pseudocode
    }
    
    public static String getProperOperandName( Operand operThisOperand,
        boolean bPrintLiteralPhrase ) {
            
        String stName, stTemp;
        int iRestriction, iStructure, iArraySetting;
        Object objTemp;
        
        iRestriction = operThisOperand.getOperandRestriction();
        iStructure = operThisOperand.getOperandStructure();
        
        if ( iRestriction == DataObject.I_RESTRICTION_LITERAL ) {
            objTemp = operThisOperand.getOperandValue();            
            if ( objTemp instanceof String ) {
                stTemp = (String)objTemp;
                
                if ( stTemp.length() > 18 ) {
                    stTemp = '"' + stTemp.substring( 0, 18 ) + "..." + '"';
                }
                else {
                    stTemp = '"' + stTemp + '"';
                }

                if ( bPrintLiteralPhrase == true ) {                    
                    stName = "the literal " + stTemp;
                }
                else {
                    stName = stTemp;
                }
            }
            else {
                stName = "";
            }
        }
        else if ( iStructure == DataObject.I_STRUCTURE_1D_ARRAY ) {
            stName = operThisOperand.getOperandName();
            iArraySetting = operThisOperand.getArrayElementIndexSetting();
            
            if ( iArraySetting != Operand.I_UNDEFINED ) {
                if ( iArraySetting == Operand.I_ARRAY_INDEX_NUMBER ) {
                    stName = stName + '[' + Integer.toString( 
                        operThisOperand.getArrayElementIndex() ) + ']';
                }
                else if ( ( iArraySetting == Operand.I_ARRAY_INDEX_DATA_OBJECT )  ||
                          ( iArraySetting == Operand.I_ARRAY_INDEX_REGISTER ) ) {
                    stName = stName + '[' + 
                        operThisOperand.getArrayElementDataObject() + ']';
                }
            }
        }
        else {
            stName = operThisOperand.getOperandName();
        }
        return stName;
    }
    
    
    // instance variables
    private NameAndDataObjectWrapper nadowLabel;
    private Opcode opOpcode;
    private String stComments, stPseudocode;
    private boolean bValidInstruction;
    
    // follow this convention:
    // source operand is RIGHT operand, destination operand is LEFT operand
    private Operand operLeftOperand, operRightOperand, operBranchLabelOperand;
          
        // class constants
        private final static int I_LABEL = 0;
        private final static int I_OPCODE = 1;
        private final static int I_COMMENTS = 2;
        private final static int I_VALID = 3;
        private final static int I_OPERAND_LEFT = 4;
        private final static int I_OPERAND_RIGHT = 5;
        private final static int I_OPERAND_BRANCH_LABEL = 6;
        private final static int I_PSEUDOCODE_MESSAGE = 7;
        private final static int I_TOTAL_FIELD_COUNT = 8;

        public final static boolean B_USE_LITERAL_PHRASE = true;
        public final static boolean B_NO_LITERAL_PHRASE = true;        
        
        // error codes
        public final static int I_OK = 0;
        public final static int I_INVALID_LABEL = -1;
        
        //public final static int I_UNSPECIFIED_OPERAND_SIDE = -1;
        //public final static int I_COMMENTS_LONG = -2;
}