import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;


class InstructionRenderer extends JPanel
    implements TableCellRenderer {

    public InstructionRenderer() {
        super();
        thisInstruction = new Instruction2();
        coMyColor = new Color(0);
        coDarkGreen = new Color( 255, 0, 0);
        coDarkTurquoise = new Color( 60, 100, 100 );
        
        thisInstruction.stComments="nothing";
    }

    public void paint (Graphics gGr) {
        super.paint( gGr );
        
        g2dG = ( Graphics2D )gGr;
        
        if ( !bHasFocus && bSelected )
        {
            g2dG.setColor( coDarkTurquoise );
            g2dG.fillRect( 0, 0, 695, 86 );
        }
        else
        {
            gGr.setColor( coMyColor );        
            gGr.fillRect( 0, 0, 695, 86 );
        }

        if ( bHasFocus )
        {
            g2dG.setColor( coDarkGreen );
            g2dG.setStroke( new BasicStroke( 2.0f ) );
            g2dG.drawRect( 0, 0, 695, 86  );
        }
                       
        g2dG.setColor( Color.white );
        g2dG.drawString( thisInstruction.stComments, 10, 10 );       
    }
	
    public Component getTableCellRendererComponent(
        JTable table, Object instruction, 
        boolean isSelected, boolean hasFocus,
        int row, int column) {

        thisInstruction = (Instruction2)instruction;
        bHasFocus = hasFocus;
        bSelected = isSelected;
        
        if ( row % 2 == 0 )
            coMyColor = Color.darkGray;
        else
            coMyColor = Color.gray;
        
        this.repaint();
          
        return this;
    }
    
    private Instruction2 thisInstruction;
    
    private Graphics2D g2dG;
    private Color coMyColor;
    private static Color coDarkGreen;
    private static Color coDarkTurquoise;
    private BasicStroke bsPen;
    
    private boolean bSelected;
    private boolean bHasFocus;
}
    