/*
 * InstructionTableCellRenderer.java
 *
 * Created on April 21, 2002, 11:17 AM
 */

import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import DataObjectRenderer;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */

public class InstructionTableCellRenderer extends JPanel
    implements TableCellRenderer {

    public InstructionTableCellRenderer() {
        super();  
        bEditingMode = false;
        iCurrentLine = I_UNDEFINED;       
        createCell();
    }
        
    public void setCurrentRow( int iRow ) {
        iCurrentLine = iRow;
    }

    public void setEditingMode( boolean bMode ) {
        bEditingMode = bMode;
    }        
    
    public void setComponentToolTip( JComponent jcComponent, 
        Point pThisCellLocation, Instruction instCurrentInstruction ) {
            
        String stToolTip, stDescription, stPseudocode;
        ImageIcon iiIcon;
        int iOpcode;
        Operand operOperand;

        stPseudocode = instCurrentInstruction.getPseudocode();
        iOpcode = instCurrentInstruction.getOpcode().getOpcode();

        if ( ( rectLeftOperandIconBounds.contains( pThisCellLocation ) )  ||
             ( rectLeftOperandTextBounds.contains( pThisCellLocation ) )  ||
             ( rectLeftOperandArrayTextBounds.contains( pThisCellLocation ) )  ||
             ( rectLeftOperandLineBounds.contains( pThisCellLocation ) ) ) {
            System.out.println( "jlLeftOperandText" );
            
            if ( ( iOpcode >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                 ( iOpcode <= Opcode.I_OPCODE__BRANCH_LAST - 1 ) ) {
                operOperand = instCurrentInstruction.getLeftOperand();
                stToolTip = Instruction.getProperOperandName( operOperand,
                    Instruction.B_NO_LITERAL_PHRASE );
            }
            else {
                stToolTip = "";
            }
        }
        else if ( ( rectMiddleOperandIconBounds.contains( pThisCellLocation ) )  ||
                  ( rectMiddleOperandTextBounds.contains( pThisCellLocation ) )  ||
                  ( rectMiddleOperandArrayTextBounds.contains( pThisCellLocation ) )  ||
                  ( rectMiddleOperandLineBounds.contains( pThisCellLocation ) ) ) {
            System.out.println( "jlMiddleOperandText" );

            if ( ( iOpcode != Opcode.I_OPCODE__COMMENTS )  &&
                 ( iOpcode != Opcode.I_OPCODE__BRANCH_ALWAYS ) ) {
                operOperand = instCurrentInstruction.getRightOperand();            
                stToolTip = Instruction.getProperOperandName( operOperand,
                    Instruction.B_NO_LITERAL_PHRASE );
            }
            else {
                stToolTip = "";
            }
        }
        else if ( ( rectRightOperandTextBounds.contains( pThisCellLocation ) )  ||
                  ( rectRightOperandIconBounds.contains( pThisCellLocation ) )  ||
                  ( rectRightOperandArrayTextBounds.contains( pThisCellLocation ) )  ||        
                  ( rectRightOperandLineBounds.contains( pThisCellLocation ) ) ) {
            System.out.println( "jlRightOperandText" );
            if ( ( iOpcode >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                 ( iOpcode <= Opcode.I_OPCODE__BRANCH_LAST ) ) {
                operOperand = instCurrentInstruction.getBranchLabelOperand();
                stToolTip = Instruction.getProperOperandName( operOperand,
                    Instruction.B_NO_LITERAL_PHRASE );
            }
            else if ( iOpcode != Opcode.I_OPCODE__COMMENTS ) { // left operand is "destination operand"
                operOperand = instCurrentInstruction.getLeftOperand();
                stToolTip = Instruction.getProperOperandName( operOperand,
                    Instruction.B_NO_LITERAL_PHRASE );
            }
            else {
                stToolTip = "";
            }            
        }
        else if ( rectSelectedButtonIconBounds.contains( pThisCellLocation ) ) {
            iiIcon = (ImageIcon)jlSelectedButtonIcon.getIcon();
            stDescription = iiIcon.getDescription();
            System.out.println( "jlSelectedButtonIcon" );
            if ( stDescription.equals( "" ) == false ) {
                stToolTip = stDescription;
            }
            else {
                stToolTip = "";
            }
        }
        else if ( rectCommentsIconBounds.contains( pThisCellLocation ) ) {
            System.out.println( "jlCommentsIcon" );
            stToolTip = instCurrentInstruction.getComments();
        }
        else {
            System.out.println( "Other" );
            if ( stPseudocode.equals( "" ) ) {
                stPseudocode = "";
                stToolTip = "";
            }
            else {
                stToolTip = stPseudocode;
            }
        }

        if ( stToolTip.equals( "" ) ) {
            this.setToolTipText( stPseudocode );
        }
        else {
            System.out.println( "Opaque = " + jcComponent.isOpaque() );
            if ( jcComponent.isOpaque() == true ) {
                // component is visible
                System.out.println( "VISIBLE: " + stToolTip );
                this.setToolTipText( stToolTip );
            }
            else {
                System.out.println( "inVISIBLE" );
                this.setToolTipText( stPseudocode );
            }
        }
    }  // end of mouseEntered event

    // usued MouseListener event implementations
    public void mouseClicked( MouseEvent meEvent ) {}
    public void mousePressed( MouseEvent meEvent ) {}
    public void mouseExited( MouseEvent meEvent ) {}
                    
    //------------- TableCellRenderer Implementation ----------------\\
    public Component getTableCellRendererComponent( JTable jtTable, 
        Object objInstruction, boolean bIsSelected, boolean bHasFocus,
        int iRow, int iColumn ) {            
        
        NameAndDataObjectWrapper nadowObject;
        String stText;
        DataObject doTemp;
        ImageIcon iiIcon;
        Opcode opThisOpcode;
        int iOpcodeNumber, iPosition;
        Operand operOperand;
        Instruction instInstruction;
        Color colorCurrent;
        
        //System.out.println( "OK, the table tried to render..." );
        instInstruction = (Instruction)objInstruction;
/*        System.out.println( "...Rendering this instruction at row " + iRow + "..." );
        System.out.println( "LABEL = " + instInstruction.getLabel().getName() );
        System.out.println( "OPCODE = " + instInstruction.getOpcode().getOpcode() );
        System.out.println( "LEFT = " + instInstruction.getLeftOperand().getOperandName() );
        System.out.println( "RIGHT = " + instInstruction.getRightOperand().getOperandName() );
        System.out.println( "COMMENTS = " + instInstruction.getComments() );*/
        
        //System.out.println( "CURRENT = " + iCurrentLine + "   RENDER ROW = " + iRow );
     
        System.out.println( "Current row = " + iCurrentLine + "   row = " + iRow );
        if ( iRow % 2 == 1 ) {
            colorCurrent = colorOddRow;
            //this.setBackground( colorOddRow );
        }
        else {
            colorCurrent = colorEvenRow;
            //this.setBackground( colorEvenRow );
        }

        if ( bIsSelected == true ) {
            colorCurrent = mixColors( colorHighlightBackground, colorCurrent );
            //this.setBackground( colorHighlightBackground );            
        }
        
        //System.out.println( "1" );            
        if ( iCurrentLine == iRow ) {
            if ( bEditingMode == Code.B_MODE_INSERT ) {  // creates a line
                this.setBorder( BorderFactory.createMatteBorder( 0, 0, 5, 0, 
                    colorHighlightBorder ) );
            }
            else {  // overwrite mode
                this.setBorder( BorderFactory.createLineBorder( colorHighlightBorder, 5 ) );
            }
        }
        else {
            this.setBorder( BorderFactory.createLineBorder( colorHighlightBorder, 0 ) );
        }
        
        // error highlighting
        if ( instInstruction.isValidInstruction() == false ) {
            colorCurrent = mixColors( colorErrorBorder, colorCurrent );
            //this.setBorder( BorderFactory.createLineBorder( colorErrorBorder, 5 ) );
            System.out.println( "line = " + iRow + " has an error." );
        }
        else {
            System.out.println( "line = " + iRow + " is OK." );
        }

        this.setBackground( colorCurrent );
        //System.out.println( "2" );
        //System.out.println( "3" );
        
        // render Instruction
        clearPanel();

        //------------------ Opcode ----------------\\
        opThisOpcode = instInstruction.getOpcode();
        iiIcon = opThisOpcode.getGroupFunctionIcon();
        
        jlInstructionIcon.setIcon( iiIcon );
        //DataObjectRenderer.setColorScheme( jtaInstructionText, 
        //    DataObjectRenderer.I_COLOR_SYSTEM );
        stText = iiIcon.getDescription();
        iOpcodeNumber = opThisOpcode.getOpcode();
        iPosition = stText.indexOf( '\r' );
        
        if ( iPosition == I_NOT_FOUND ) {
            // single line
            jlInstructionText2.setOpaque( false );
            jlInstructionText1.setOpaque( true );
            jlInstructionText1.setBackground( Color.white );
            jlInstructionText1.setForeground( Color.black );
            jlInstructionText1.setBorder( BorderFactory.createLineBorder( Color.black, 1 ) );
            jlInstructionText1.setText( stText );
        }
        else {
            // double line            
            jlInstructionText1.setOpaque( true );
            jlInstructionText1.setBackground( Color.white );
            jlInstructionText1.setForeground( Color.black );
            jlInstructionText1.setBorder( BorderFactory.createMatteBorder( 1, 1, 0, 1, 
                Color.black ) );
            jlInstructionText1.setText( stText.substring( 0, iPosition ) );
            jlInstructionText2.setOpaque( true );
            jlInstructionText2.setBackground( Color.white );
            jlInstructionText2.setForeground( Color.black );
            jlInstructionText2.setBorder( BorderFactory.createMatteBorder( 0, 1, 1, 1, 
                Color.black ) );
            jlInstructionText2.setText( stText.substring( iPosition + 1 ) );
        }
               
        if ( iOpcodeNumber == Opcode.I_OPCODE__COMMENTS ) {
            //jtaInstructionText.setOpaque( true );
            nadowObject = instInstruction.getLabel();
            DataObjectRenderer.renderLabel( nadowObject, jlLabelIcon, jlLabelText );
            //operOperand = instInstruction.getLeftOperand();            
            DataObjectRenderer.setColorScheme( jtaAllComments, DataObjectRenderer.I_COLOR_USER );
            jtaAllComments.setOpaque( true );
            jtaAllComments.setText( instInstruction.getComments() ); 
            //jspCommentsArea.setVisible( true );
            //operOperand.getTextInformation() );                        
            //System.out.println( "5A" );
        }
        else if ( iOpcodeNumber == Opcode.I_OPCODE__IGNORE ) {
            clearPanel();
            //System.out.println( "CLEARING PANEL...ignore!!!" );
        }
        else { // not comments
            //jtaInstructionText.setOpaque( true );
            //System.out.println( "**5A" );
            //System.out.println( "**5B" );

            //----------------- Label ---------------\\
            //System.out.println( "5C" );
            nadowObject = instInstruction.getLabel();
            DataObjectRenderer.renderLabel( nadowObject, jlLabelIcon, jlLabelText );
            //System.out.println( "6" );
            //-------------- Left Operand -------------------\\
            if ( ( iOpcodeNumber >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                 ( iOpcodeNumber <= Opcode.I_OPCODE__BRANCH_LAST - 1 ) ) {
                operOperand = instInstruction.getLeftOperand();
                jlLeftOperandIcon.setOpaque( true );
                jlLeftOperandText.setOpaque( true );
                plLeftOperandLine.setOpaque( true );
                DataObjectRenderer.renderOperand( iOpcodeNumber, operOperand, 
                    jlLeftOperandIcon, jlLeftOperandText, jlLeftOperandArrayText,
                    plLeftOperandLine, I_ICON_TEXT_LEFT_OPERAND_X_POSITION, 
                    I_ICON_STARTING_HEIGHT, DataObjectRenderer.B_PROGRAM_LISTING,
                    new JTextArea() );
                //System.out.println( "7" );
            }
            
            //-------------------- Button --------------------\\
            iiIcon = opThisOpcode.getThisFunctionIcon();

            if ( iiIcon.getDescription().equals( "" ) == false ) {
                jlSelectedButtonIcon.setIcon( iiIcon );
                //jlSelectedButtonIcon.setToolTipText( iiIcon.getDescription() );
                //System.out.println( "9" );
            }
            
            //----------------- Middle Operand ---------------\\
            if ( ( iOpcodeNumber != Opcode.I_OPCODE__COMMENTS )  &&
                 ( iOpcodeNumber != Opcode.I_OPCODE__BRANCH_ALWAYS ) ) {
                operOperand = instInstruction.getRightOperand();            

                jlMiddleOperandIcon.setOpaque( true );
                jlMiddleOperandText.setOpaque( true );
                plMiddleOperandLine.setOpaque( true );
                
                DataObjectRenderer.renderOperand( iOpcodeNumber, operOperand, 
                    jlMiddleOperandIcon, jlMiddleOperandText, jlMiddleOperandArrayText,
                    plMiddleOperandLine, I_ICON_TEXT_MIDDLE_OPERAND_X_POSITION,
                    I_ICON_STARTING_HEIGHT, DataObjectRenderer.B_PROGRAM_LISTING, 
                    new JTextArea() );
                //System.out.println( "11" );
            }

            //------------------ Triangle ----------------------\\
            if ( iOpcodeNumber != Opcode.I_OPCODE__COMMENTS ) {
                jlTriangle.setIcon( iiRightTriangle );
            }
            
            //---------------- Right Operand ------------------\\
            if ( ( iOpcodeNumber >= Opcode.I_OPCODE__BRANCH_FIRST )  &&
                 ( iOpcodeNumber <= Opcode.I_OPCODE__BRANCH_LAST ) ) {
                nadowObject = instInstruction.getBranchLabelOperand().getOperandData();
                DataObjectRenderer.renderLabel( nadowObject, jlRightOperandIcon, 
                    jlRightOperandText );                        
                //System.out.println( "13" );
            }
            else if ( iOpcodeNumber != Opcode.I_OPCODE__COMMENTS ) { // left operand is "destination operand"
                operOperand = instInstruction.getLeftOperand();
                jlRightOperandIcon.setOpaque( true );
                jlRightOperandText.setOpaque( true );
                plRightOperandLine.setOpaque( true );
                
                DataObjectRenderer.renderOperand( iOpcodeNumber, operOperand, 
                    jlRightOperandIcon, jlRightOperandText, jlRightOperandArrayText,
                    plRightOperandLine, I_ICON_TEXT_RIGHT_OPERAND_X_POSITION,
                    I_ICON_STARTING_HEIGHT, DataObjectRenderer.B_PROGRAM_LISTING,
                    new JTextArea() );
                //System.out.println( "14" );
            }
            
            //------------------- Comments -----------------\\
            stText = instInstruction.getComments();

            if ( ( iOpcodeNumber == Opcode.I_OPCODE__COMMENTS )  || 
                 ( stText.equals( "" ) == true ) ) {
                //System.out.println( "***NO COMMENTS*** " );
                //jlCommentsIcon.setIcon( new ImageIcon( "" ) );
                //jlCommentsIcon.setToolTipText( "WELL, HOW 'BOUT THAT?!" );
                //this.setToolTipText( "WELL, HOW 'BOUT THAT?!" );
                //System.out.println( "17" );
            }
            else {
                //System.out.println( "Comments added to code." );
                jlCommentsIcon.setIcon( iiComments );
                //jlCommentsIcon.setToolTipText( stText );
                //System.out.println( "Comments in tooltip = " + stText );
                //this.setToolTipText( "Comments::" + stText );
                //System.out.println( "16" );
            }                
        }        
        return this;
    }

    ////////////////// PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\
    private void createCell() {        
        this.setLayout( null );
        this.setSize( 100, 100 );
        this.setBackground( Color.magenta );
        this.setVisible( true );
        
        // all icons assumed to have single line of text        
        jlLabelIcon = createAndAddLabel( 72, I_ICON_STARTING_HEIGHT, I_ICON_SIZE,
            I_ICON_SIZE );
        jlLabelText = createAndAddLabel( 48, I_ICON_TEXT_STARTING_HEIGHT, 
            DataObjectRenderer.I_ICON_TEXT_WIDTH, DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        
        jlInstructionIcon = createAndAddLabel( 202, I_ICON_STARTING_HEIGHT, 
            I_ICON_SIZE, I_ICON_SIZE ); 
        jlInstructionText1 = createAndAddLabel( 168, I_ICON_TEXT_STARTING_HEIGHT, 
            DataObjectRenderer.I_ICON_TEXT_WIDTH + 20, DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        jlInstructionText2 = createAndAddLabel( 168, I_ICON_TEXT_STARTING_HEIGHT + 14, /* was 18 */
            DataObjectRenderer.I_ICON_TEXT_WIDTH + 20, DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        
        jlLeftOperandIcon = createAndAddLabel( 357, I_ICON_STARTING_HEIGHT, 
            I_ICON_SIZE, I_ICON_SIZE );  
        rectLeftOperandIconBounds = jlLeftOperandIcon.getBounds();        
        jlLeftOperandText = createAndAddLabel( I_ICON_TEXT_LEFT_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT, DataObjectRenderer.I_ICON_TEXT_WIDTH, 
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        jlLeftOperandArrayText = createAndAddLabel( I_ICON_TEXT_LEFT_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT + 14, DataObjectRenderer.I_ICON_TEXT_WIDTH, /* was 18 */
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        rectLeftOperandTextBounds = jlLeftOperandText.getBounds();
        rectLeftOperandArrayTextBounds = jlLeftOperandArrayText.getBounds();
        
        plLeftOperandLine = new PaintableLabel( I_ICON_TEXT_LEFT_OPERAND_X_POSITION,
            I_ICON_LINE_STARTING_HEIGHT, DataObjectRenderer.I_ICON_LINE_WIDTH, 
            DataObjectRenderer.I_ICON_LINE_HEIGHT );
        rectLeftOperandLineBounds = plLeftOperandLine.getBounds();
        this.add( plLeftOperandLine );
        
        jlSelectedButtonIcon = createAndAddLabel( 410, I_ICON_STARTING_HEIGHT,
            I_ICON_SIZE, I_ICON_SIZE );
        rectSelectedButtonIconBounds = jlSelectedButtonIcon.getBounds();
      
        jlMiddleOperandIcon = createAndAddLabel( 463, I_ICON_STARTING_HEIGHT, 
            I_ICON_SIZE, I_ICON_SIZE );
        rectMiddleOperandIconBounds = jlMiddleOperandIcon.getBounds();
        jlMiddleOperandText = createAndAddLabel( I_ICON_TEXT_MIDDLE_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT, DataObjectRenderer.I_ICON_TEXT_WIDTH, 
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        jlMiddleOperandArrayText = createAndAddLabel( I_ICON_TEXT_MIDDLE_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT + 14, DataObjectRenderer.I_ICON_TEXT_WIDTH, /* was 18 */
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        rectMiddleOperandTextBounds = jlMiddleOperandText.getBounds();
        rectMiddleOperandArrayTextBounds = jlMiddleOperandArrayText.getBounds();

        plMiddleOperandLine = new PaintableLabel( I_ICON_TEXT_MIDDLE_OPERAND_X_POSITION,
            I_ICON_LINE_STARTING_HEIGHT, DataObjectRenderer.I_ICON_LINE_WIDTH, 
            DataObjectRenderer.I_ICON_LINE_HEIGHT );
        rectMiddleOperandLineBounds = plMiddleOperandLine.getBounds();
        this.add( plMiddleOperandLine );        
        
//        jtaMiddleOperandMoveInfo = createAndAddTextArea( 
//            410, I_ICON_STARTING_HEIGHT, I_ICON_MOVE_INFO_WIDTH, I_ICON_MOVE_INFO_HEIGHT );

        jlTriangle = new JLabel( iiRightTriangle );
        jlTriangle.setBounds( 524, 18, 16, 16 );
        this.add( jlTriangle );

        jlRightOperandIcon = createAndAddLabel( 569, I_ICON_STARTING_HEIGHT, 
            I_ICON_SIZE, I_ICON_SIZE );
        rectRightOperandIconBounds = jlRightOperandIcon.getBounds();
        jlRightOperandText = createAndAddLabel( I_ICON_TEXT_RIGHT_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT, DataObjectRenderer.I_ICON_TEXT_WIDTH,
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        jlRightOperandArrayText = createAndAddLabel( I_ICON_TEXT_RIGHT_OPERAND_X_POSITION,
            I_ICON_TEXT_STARTING_HEIGHT + 14, DataObjectRenderer.I_ICON_TEXT_WIDTH, /* was 18 */
            DataObjectRenderer.I_ICON_TEXT_HEIGHT );
        rectRightOperandTextBounds = jlRightOperandText.getBounds();
        rectRightOperandArrayTextBounds = jlRightOperandArrayText.getBounds();

        plRightOperandLine = new PaintableLabel( I_ICON_TEXT_RIGHT_OPERAND_X_POSITION,
            I_ICON_LINE_STARTING_HEIGHT, DataObjectRenderer.I_ICON_LINE_WIDTH, 
            DataObjectRenderer.I_ICON_LINE_HEIGHT );
        rectRightOperandLineBounds = plRightOperandLine.getBounds();
        this.add( plRightOperandLine );

//        jtaRightOperandMoveInfo = 
//            createAndAddTextArea( 599, I_ICON_STARTING_HEIGHT, I_ICON_MOVE_INFO_WIDTH, 
//            I_ICON_MOVE_INFO_HEIGHT );
        
        jlCommentsIcon = createAndAddLabel( 697, I_ICON_STARTING_HEIGHT, 27, 26 );
        rectCommentsIconBounds = jlCommentsIcon.getBounds();
        jtaAllComments = createAndAddTextArea( 301, 10, 423, 65 );     // add scroll pane
/*        this.remove( jtaAllComments );
        jspCommentsArea = new JScrollPane( jtaAllComments );
        jspCommentsArea.setBounds( 301, 10, 423, 71 );
        jspCommentsArea.setPreferredSize( new Dimension( 0, 0 ) );
        this.add( jspCommentsArea );        */
    }
        
    private JLabel createAndAddLabel( int iXLocation, int iYLocation, int iWidth, 
        int iHeight ) {
            
        JLabel jlNewLabel;
        
        jlNewLabel = new JLabel( "", SwingConstants.CENTER );
        jlNewLabel.setBounds( iXLocation, iYLocation, iWidth, iHeight );
        jlNewLabel.setFont( foFont );
        this.add( jlNewLabel );
        return jlNewLabel;
    }       
    
    private JTextArea createAndAddTextArea( int iXLocation, int iYLocation,
        int iWidth, int iHeight ) {
        JTextArea jtaNewTextArea;
        
        jtaNewTextArea = new JTextArea( "", 2, 9 );
        jtaNewTextArea.setWrapStyleWord( true );
        jtaNewTextArea.setLineWrap( true );
        jtaNewTextArea.setEditable( false );
        jtaNewTextArea.setBounds( iXLocation, iYLocation, iWidth, iHeight );
        jtaNewTextArea.setFont( foFont );
        this.add( jtaNewTextArea );
        return jtaNewTextArea;    
    }
    
    private void clearLabel( JLabel jlThisLabel ) {
        jlThisLabel.setText( "" );
        jlThisLabel.setOpaque( false );
        jlThisLabel.setBorder( null );    
    }
    
    private void clearTextArea( JTextArea jtaThisTextArea ) {
        jtaThisTextArea.setText( "" );
        jtaThisTextArea.setOpaque( false );
        jtaThisTextArea.setBorder( null );    
    }
    
    private void clearIcon( JLabel jlThisLabelIcon ) {
        jlThisLabelIcon.setIcon( new ImageIcon( "" ) );
        jlThisLabelIcon.setOpaque( false );
    }

    private void clearLine( PaintableLabel plThisLine ) {
        plThisLine.setOpaque( false );
        plThisLine.setGraphicsType( PaintableLabel.I_NONE );
    }
            
    private void clearPanel() {        
        // move information will be broken up into three labels
        //jspCommentsArea.setVisible( false );
        clearLabel( jlInstructionText1 );
        clearLabel( jlInstructionText2 );
        clearTextArea( jtaAllComments );
        clearIcon( jlCommentsIcon );
        clearIcon( jlTriangle );

        clearLabel( jlLabelText );
        clearIcon( jlLabelIcon );

        clearIcon( jlLeftOperandIcon );
        clearLabel( jlLeftOperandText );
        clearLabel( jlLeftOperandArrayText );

        clearIcon( jlSelectedButtonIcon );

        clearIcon( jlMiddleOperandIcon );
        clearLabel( jlMiddleOperandText );
        clearLabel( jlMiddleOperandArrayText );

        clearIcon( jlRightOperandIcon );
        clearLabel( jlRightOperandText );
        clearLabel( jlRightOperandArrayText );

        clearLine( plLeftOperandLine );
        clearLine( plMiddleOperandLine );
        clearLine( plRightOperandLine );
    }
    
    private Color mixColors( Color color1, Color color2 ) {
        int iMixRed, iMixGreen, iMixBlue;
        Color colorMix;
        
        iMixRed = ( color1.getRed() + color2.getRed() ) / 2;
        iMixGreen = ( color1.getGreen() + color2.getGreen() ) / 2;
        iMixBlue = ( color1.getBlue() + color2.getBlue() ) / 2;
        
        colorMix = new Color( iMixRed, iMixGreen, iMixBlue );
        
        return colorMix;
    }
        
        
        

    
    // instance variables
    private JLabel jlLabelIcon, jlLabelText, jlInstructionIcon, jlInstructionText,
        jlLeftOperandIcon, jlLeftOperandText, jlLeftOperandArrayText, 
        jlSelectedButtonIcon, jlMiddleOperandIcon, jlMiddleOperandText, 
        jlMiddleOperandArrayText, jlRightOperandIcon, jlRightOperandText, 
        jlRightOperandArrayText, jlCommentsIcon, jlAllComments, jlTriangle,
        jlInstructionText1, jlInstructionText2;
    private Rectangle rectLeftOperandIconBounds, rectLeftOperandTextBounds, 
        rectLeftOperandArrayTextBounds, rectSelectedButtonIconBounds, 
        rectMiddleOperandIconBounds, rectMiddleOperandTextBounds, 
        rectMiddleOperandArrayTextBounds, rectRightOperandIconBounds, 
        rectRightOperandTextBounds, rectRightOperandArrayTextBounds,
        rectCommentsIconBounds, rectLeftOperandLineBounds, rectMiddleOperandLineBounds, 
        rectRightOperandLineBounds;
    private JTextArea jtaRightOperandMoveInfo, jtaMiddleOperandMoveInfo,
        jtaAllComments, jtaInstructionText;
    private PaintableLabel plLeftOperandLine, plMiddleOperandLine, plRightOperandLine;
    private boolean bEditingMode;
    private int iCurrentLine;
    private JScrollPane jspCommentsArea;
    
    // class variables
    private static final Color colorHighlightBackground, colorOddRow, colorEvenRow, 
        colorHighlightBorder, colorErrorBorder;
    private static final Font foFont;
    
    private static final int I_UNDEFINED = -9999999;
    private static final int I_ICON_SIZE = 32;
    private static final int I_ICON_STARTING_HEIGHT = 10;
    private static final int I_ICON_TEXT_LEFT_OPERAND_X_POSITION = 333;
    private static final int I_ICON_TEXT_MIDDLE_OPERAND_X_POSITION = 439;
    private static final int I_ICON_TEXT_RIGHT_OPERAND_X_POSITION = 545;
    private static final int I_ICON_TEXT_STARTING_HEIGHT = 43;    

    public static final int I_ICON_LINE_STARTING_HEIGHT = 63;
    //private static final int I_ICON_MOVE_INFO_WIDTH = 74;
    //private static final int I_ICON_MOVE_INFO_HEIGHT = 26;
    private static final String ST_HOME_DIRECTORY = "";
        /*"D:\\forte4j\\Development\\panelsAndTools\\";    */
    private static final ImageIcon iiRightTriangle = 
        new ImageIcon( ST_HOME_DIRECTORY + "right-arrow.jpg" );
    private static final ImageIcon iiComments = 
        new ImageIcon( ST_HOME_DIRECTORY + "section_comments-icon.jpg" );
    
    private static final int I_NOT_FOUND = -1;
    
    // class initializer
    static {
        colorHighlightBackground = new Color( 204, 204, 255 );
        colorHighlightBorder = DataObjectRenderer.colorDarkBlue;
        colorErrorBorder = new Color( 160, 54, 63 );
        colorOddRow = new Color( 218, 218, 218 );
        colorEvenRow = new Color( 190, 190, 190 );        
        foFont = new Font( "Monospaced", Font.BOLD, 14 );
    }          
}                   