import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LabelDraw extends JFrame {
    
    public LabelDraw() {
        this.setTitle( "Test" );
        this.setSize( 100,100 );
        JPanel jp = new JPanel();        
        jp.setLayout( null );
        PaintableLabel pl = new PaintableLabel( 0, 0, 150 ,150 );
        pl.setGraphicsType( PaintableLabel.I_TRIANGLE );
        jp.add( pl );
        Container c = this.getContentPane();
        c.add( jp );
        
        addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent we ) {
                System.exit( 0 );
            }
        });               
    }        
    
    public static void main( String args[] ) {
        LabelDraw ld = new LabelDraw();
        ld.show();        
    }
    
    private PaintableLabel pl;
    private JFrame jf;
    private JPanel jp;

    protected class PaintableLabel extends JLabel {
        public PaintableLabel( int iXLocation, int iYLocation, int iWidth, 
            int iHeight ) {

            float[] fDashStyle = { 5.0f, 5.0f, 5.5f, 5.0f };
            bsStandardPen = new BasicStroke( 12.0f );
            bsRestrictionPen = new BasicStroke( 3.0f, BasicStroke.CAP_SQUARE, 
                BasicStroke.JOIN_MITER, 5.0f, fDashStyle, 0.0f );

            this.setToolTipText( "Cool tip!" );            
            iXPosition = iXLocation;
            iYLocation = iYPosition;
            iThisWidth = iWidth;
            iThisHeight = iHeight;            
            this.setBounds( iXPosition, iYLocation, iThisWidth, iThisHeight );
            this.setBorder( BorderFactory.createLineBorder( Color.orange ) );
        }
        
        public void setGraphicsType( int iGraphicsType ) {
            iDrawingType = iGraphicsType;
            this.repaint();
        }
        
        public void paintComponent( Graphics grDrawingArea ) {
            super.paintComponent( grDrawingArea );
            gph2dDrawingArea = (Graphics2D)grDrawingArea;
            gph2dDrawingArea.setColor( Color.black );
            
            switch( iDrawingType ) {
                case I_DOTTED_LINE:
                    System.out.println( "Dashed line." );
                    gph2dDrawingArea.setStroke( bsRestrictionPen );
                    gph2dDrawingArea.drawLine( 0, 10, 50, 10);
                    break;
                    
                case I_SOLID_LINE:
                    System.out.println( "Solid line." );
                    gph2dDrawingArea.setStroke( bsStandardPen );
                    gph2dDrawingArea.drawLine( 0, 0, 32, 0 );
                    break;
                    
                case I_TRIANGLE:
                    Polygon poTriangle = new Polygon();
                poTriangle.addPoint( 0, 0 );    
                poTriangle.addPoint( 0, 19 ); 
                poTriangle.addPoint( 13, 9 );                
                    
                    /*poTriangle.addPoint( 100, 100 );    
                    poTriangle.addPoint( 100, 119 );
                    poTriangle.addPoint( 113, 109 );                    */
                    gph2dDrawingArea.fillPolygon( poTriangle );
                    break;
            }
        }
        
        
        // instance variables
        int iXPosition, iYPosition, iThisWidth, iThisHeight, iDrawingType;
        Graphics2D gph2dDrawingArea;
        
        // class constants
        public static final int I_DOTTED_LINE = 0;
        public static final int I_SOLID_LINE = 1;
        public static final int I_TRIANGLE = 2;
        private final BasicStroke bsStandardPen, bsRestrictionPen;
        private Polygon poTriangle;
    }        
}