/*
 * MainFrame.java
 *
 * Created on September 14, 2001, 2:13 PM
 */

//package panelsAndTools;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;

/**
 *
 * @author  family
 * @version 
 */
public class MainFrame extends JFrame {
    public MainFrame() {  
        DataObject doTemp;
        Dimension diTableSize;
        JScrollPane jspScrollPane;
        
        ssTitle = new SplashScreen();
        ssTitle.show();

        this.setTitle( "Panels :: Tools :: Views" );
        this.setBounds( 0, 0, 800, 600 );
        
        deDeclarations = new Declarations();
        progThisProgram = new Program();
        progThisProgram.setDeclarations( deDeclarations );
        progThisProgram.setParentFrame( this );
        codeThisCode = progThisProgram.getCode();
        
        vctCodeTable = new VisualCodeTable( codeThisCode, new VisualCodeTableModel() );
        vctCodeTable.setSize( 800, 300 );
        jspScrollPane = new JScrollPane( vctCodeTable );
        diTableSize = new Dimension( 800, 150 );
        //vctCodeTable.setPreferredScrollableViewportSize( diTableSize );
        progThisProgram.setVisualCodeTable( vctCodeTable );  // also sets Code in program
                
        mainPanel = new MainPanel( this, progThisProgram );
        mainPanel.setSize( 800, 300 );
        jspSplitPanel = new JSplitPane( JSplitPane.VERTICAL_SPLIT, true, 
                                        mainPanel, jspScrollPane );
        jspSplitPanel.setSize( 800, 600 );
        jspSplitPanel.setDividerLocation( 300 );
        Container mainPanelContent = getContentPane();
        mainPanelContent.add( "Center", jspSplitPanel );
        ssTitle.dispose();
        
        this.addWindowListener( new WindowAdapter () {
            public void windowClosing ( WindowEvent weEvent ) {
                System.out.println( "Closing window..." );
                progThisProgram.performMenuItemExit();
            }
        } );
        
        this.setDefaultCloseOperation( WindowConstants.DO_NOTHING_ON_CLOSE );
    }

    
    // instance variables
    private VisualCodeTable vctCodeTable;
    private Program progThisProgram;
    private Code codeThisCode;
    private Declarations deDeclarations;
    private JSplitPane jspSplitPanel;
    private MainPanel mainPanel;
    private Declarations deObjectModel;
    private SplashScreen ssTitle;        
}