/*
 * MathPanel.java
 *
 * Created on June 9, 2002, 2:51 PM
 */

import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.awt.*;

/**
 *
 * @author  _
 * @version 
 */
public class MathPanel extends PTVPanel 
    implements ActionListener, DataObjectAreaListener {
        
    public MathPanel( JFrame jfParentFrame, String stDialogTitle, 
        Dimension diPanelSize, Program progThisProgram, 
        SortableDeclarationsTableModel sdtmModel ) {
            
        super( jfParentFrame, stDialogTitle, diPanelSize, progThisProgram, sdtmModel );
        
        super.setActionListener( this );
        super.setDataObjectAreaListener( this );
        
        createObjects();
        drawPanel();
        finishPanelConfiguration();
    }
    
    public void setInstruction( Instruction instInstruction ) {
        int iOpcodeID;
        
        instThisInstruction = (Instruction)instInstruction.clone();        
        opMathOpcode = instThisInstruction.getOpcode();
        iOpcodeID = opMathOpcode.getOpcode();
        operDestination = instThisInstruction.getLeftOperand();
        operSource = instThisInstruction.getRightOperand();

        // set up the panel appropriately
        dataObjectAreaChanged( iDestinationOperandID, operDestination );
        super.updateDataObjectArea( iDestinationOperandID, operDestination );
        dataObjectAreaChanged( iSourceOperandID, operSource );
        super.updateDataObjectArea( iSourceOperandID, operSource );        
        jlLabelText.setText( instThisInstruction.getLabel().getName() );
        jtaComments.setText( instThisInstruction.getComments() );
        setCorrectButton( iOpcodeID ); 
        
        System.out.println( "Setting instruction in math panel..." );
        System.out.println( "LABEL = " + instThisInstruction.getLabel().getName() );
        System.out.println( "OPCODE = " + instThisInstruction.getOpcode().getOpcode() );
        System.out.println( "LEFT = " + instThisInstruction.getLeftOperand().getOperandName() );
        System.out.println( "RIGHT = " + instThisInstruction.getRightOperand().getOperandName() );
        System.out.println( "COMMENTS = " + instThisInstruction.getComments() );        
    }
    
    //------------------ ActionListener Implementation --------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objActionSource, objTemp;
        JToggleButton jtbThisButton;
        boolean bFound;
        int iIndex, iCurrentLine, iLabelUsedStatus;
        String stTemp;
        DataObject doThisDataObject;
        Status statInformation;

        iLabelUsedStatus = super.I_OK;
        objActionSource = aeEvent.getSource();        
        System.out.println( "MathPanel: ActionPerformed by" + aeEvent.getActionCommand() + "." );
        
        if ( objActionSource == jbApply ) {
            // since the Instruction parts were likely defined legally, it is
            // not necessary to do error checking...unless in "debugging mode"            
            System.out.println( "MATH PANEL: Apply pressed." );
            
            //System.out.println( "1" );
            if ( opMathOpcode.getOpcode() != Opcode.I_OPCODE__UNDEFINED ) {
                //System.out.println( "2" );
                stTemp = this.getLabel().getText();

                if ( stTemp.equals( "" ) == false ) {
                    statInformation = super.isLabelUsed( stTemp );
                    iLabelUsedStatus = statInformation.getStatusNumber();
                    
                    if ( iLabelUsedStatus == super.I_OK ) {
                        objTemp = (DataObject)deDeclarations.getDeclaration( stTemp );

                        if ( objTemp instanceof DataObject ) {
                            doThisDataObject = (DataObject)objTemp;
                            instThisInstruction.setLabel( 
                                new NameAndDataObjectWrapper( stTemp, doThisDataObject ) );
                        }
                    }
                    else {
                        JOptionPane.showMessageDialog( this, 
                            statInformation.getStatusMessage(), 
                            ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                    }                    
                }
                else {
                    doThisDataObject = new DataObject();
                    doThisDataObject.setType( DataObject.I_TYPE_LABEL );
                    instThisInstruction.setLabel( 
                        new NameAndDataObjectWrapper( "", doThisDataObject ) );
                }

                
                stTemp = this.getComments().getText();

                if ( stTemp.equals( "" ) == false ) {
                    instThisInstruction.setComments( stTemp );
                }
                //  else, ignore

                if ( iLabelUsedStatus == super.I_OK ) {
                    if ( operDestination.getOperandType() != DataObject.I_UNDEFINED ) {
    //                    System.out.println( "12" );
                        instThisInstruction.setLeftOperand( operDestination );
    //                    System.out.println( "13" );
                        if ( operSource.getOperandType() != DataObject.I_UNDEFINED ) {
    //                        System.out.println( "14" );
                            instThisInstruction.setRightOperand( operSource );
    //                        System.out.println( "15" );
                            statInformation = instThisInstruction.validateInstruction();

                            if ( statInformation.getStatusNumber() == Instruction.I_OK ) {
    //                            System.out.println( "16" );
                                iCurrentLine = vctCodeTable.getCurrentRow();                            
    //                            System.out.println( "Current code row = " + iCurrentLine );
    //                            System.out.println( "17" );

                                if ( codeThisCode.getEditingMode() == Code.B_MODE_INSERT ) {
    //                                System.out.println( "18" );
                                    statInformation = codeThisCode.insertSingleLine( 
                                        iCurrentLine, instThisInstruction );
    //                                System.out.println( "19" );
                                }
                                else {  // overwrite
                                    statInformation = codeThisCode.changeSingleLine( 
                                        iCurrentLine, instThisInstruction );
    //                                System.out.println( "20" );
                                }

    //                            System.out.println( "21" );
                                if ( statInformation.getStatusNumber() != Instruction.I_OK ) {
    //                                System.out.println( "22" );
    //                                System.out.println( "CODE NOT ADDED" );
    //                                System.out.println( "23" );
                                    JOptionPane.showMessageDialog( this, 
                                        statInformation.getStatusMessage(), 
                                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
    //                                System.out.println( "24" );
                                }
                                else {
    //                                System.out.println( "25" );
                                    clearAll();
                                }                            
                            }
                            else {
    //                            System.out.println( "INVALID INST" );
                                JOptionPane.showMessageDialog( this, 
                                    statInformation.getStatusMessage(),
                                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
    //                            System.out.println( "28" );
                            }                           
                        }
                        else {
                            JOptionPane.showMessageDialog( this, 
                                "A source operand is required for this instruction.", 
                                ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
    //                        System.out.println( "29" );
                        }
                    }
                    else {
                        JOptionPane.showMessageDialog( this, 
                            "A destination operand is required for this instruction.", 
                            ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
    //                    System.out.println( "30" );
                    }
                }
            }  // opcode found
            else {
                JOptionPane.showMessageDialog( this, "A function button must be "
                    + "pressed for the instruction to be valid.", 
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
//                System.out.println( "31" );
            }
        }
        else {
//            System.out.println( "32" );
            // check button panel buttons
            bFound = false;
//            System.out.println( "33" );
            iIndex = I_JBUTTON_ADD;
//            System.out.println( "34" );
                        
            do {
//                System.out.println( "35" );
                objTemp = alGroupButtons.get( iIndex );
//                System.out.println( "36" );
//                System.out.println( "objTemp (should be button) = " + objTemp );
//                System.out.println( "37" );
                if ( objTemp instanceof JToggleButton ) {
//                    System.out.println( "38" );
                    jtbThisButton = (JToggleButton)objTemp;
//                    System.out.println( "39" );
//                    System.out.println( "Index = " + iIndex + "   Button = " + jtbThisButton.getToolTipText() );
//                    System.out.println( "40" );
                    if ( objActionSource == jtbThisButton ) {
//                        System.out.println( "41" );
                        bFound = true;
                    }
                    else {
//                        System.out.println( "42" );
                        iIndex++;
                    }
                }
                else {
//                    System.out.println( "43" );
                    iIndex++;
                }
            }
            while ( ( bFound == false )  &&  ( iIndex < I_JBUTTON_LAST_BUTTON ) );
//            System.out.println( "44" );
            if ( bFound == true ) {                
                switch ( iIndex ) {
                    case I_JBUTTON_ADD:
                        opMathOpcode.setOpcode( Opcode.I_OPCODE__MATH_ADD );                        
//                        System.out.println( "45" );
                        break;
                        
                    case I_JBUTTON_SUBTRACT:
                        opMathOpcode.setOpcode( Opcode.I_OPCODE__MATH_SUBTRACT );
//                        System.out.println( "46" );
                        break;
                        
                    case I_JBUTTON_MULTIPLY:
                        opMathOpcode.setOpcode( Opcode.I_OPCODE__MATH_MULTIPLY );
//                        System.out.println( "47" );
                        break;
                        
                    case I_JBUTTON_DIVIDE:
                        opMathOpcode.setOpcode( Opcode.I_OPCODE__MATH_DIVIDE );
//                        System.out.println( "48" );
                        break;
                        
                    case I_JBUTTON_MODULUS:
                        opMathOpcode.setOpcode( Opcode.I_OPCODE__MATH_MODULUS );
//                        System.out.println( "49" );
                        break;
                }
                instThisInstruction.setOpcode( (Opcode)opMathOpcode.clone() );
//                System.out.println( "50" );
            }
            else {
                // try superclass PTVPanel
//                System.out.println( "51" );
                super.actionPerformed( aeEvent );
//                System.out.println( "52" );
                
                if ( objActionSource == super.jbClear ) {
                    clearAll();
                }
            }
        }
    }
    
    //------------------ DataObjectAreaListener Implementation --------------\\
    public void dataObjectAreaChanged( int iID, Operand operData ) {
        if ( iID == iDestinationOperandID ) {
            operDestination = operData;
            instThisInstruction.setLeftOperand( operDestination );
        }
        else if ( iID == iSourceOperandID ) {
            operSource = operData;
            instThisInstruction.setRightOperand( operSource );
        }
        // else ignore
    }
    
    //////////////////////// PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\\\\\
    public void createObjects() {
        ptvhdHelp = new PTVHelpDialog( jfParentFrame, "Help >> Panel >> Math" );
        ptvhdHelp.setHelpFile( "help_panel_math.html" );
        super.setHelpDialog( ptvhdHelp );
        
        jbApply = super.getApplyInstructionButton();
        jbApply.addActionListener( this );
        
        bsDestinationOpRestrictionFlags = super.getNewDataObjectAreaRestrictionList();
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_SINGLE );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
                
        bsSourceOpRestrictionFlags = super.getNewDataObjectAreaRestrictionList();
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CONSTANT );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_LITERAL );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_SINGLE );        
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
        
        alGroupButtons = new ArrayList( 5 );
        
        alGroupButtons.add( I_JBUTTON_ADD, createButton( "plus-icon.jpg", 
            "inv-plus-icon.jpg", "Add" ) );
        alGroupButtons.add( I_JBUTTON_SUBTRACT, createButton( "minus-icon.jpg", 
            "inv-minus-icon.jpg", "Subtract" ) );
        alGroupButtons.add( I_JBUTTON_MULTIPLY, createButton( "multiply-icon.jpg", 
            "inv-multiply-icon.jpg", "Multiply" ) );
        alGroupButtons.add( I_JBUTTON_DIVIDE, createButton( "divide-icon.jpg", 
            "inv-divide-icon.jpg", "Divide" ) );
        alGroupButtons.add( I_JBUTTON_MODULUS, createButton( "percent-icon.jpg", 
            "inv-percentage-icon.jpg", "Modulus" ) );
        
        operDestination = new Operand();
        operSource = new Operand();
        opMathOpcode = new Opcode();
        instThisInstruction = new Instruction();
    }
    
    public void finishPanelConfiguration() {
        // assume that everything worked ok...since IDs should be valid
        super.setDataObjectAreaRestrictionList( iDestinationOperandID, 
            bsDestinationOpRestrictionFlags );
        super.setDataObjectAreaRestrictionList( iSourceOperandID, 
            bsSourceOpRestrictionFlags );
    }
    
    public void drawPanel() {
        iDestinationOperandID = super.drawDataObjectArea( new Point( 8, 5 ), operDestination );
        iSourceOperandID = super.drawDataObjectArea( new Point( 295, 5 ), operSource );
        super.drawButtonPanel( new Point( 190, 5 ), alGroupButtons );
        super.drawLabelAndCommentsAndActionButtons();
        super.drawLine( new Rectangle( 150, 38, 25, 3 ) );  // Destination line
        super.drawLine( new Rectangle( 271, 38, 21, 3 ) );  // Source line
        super.drawRectangle( new Rectangle( 175, 32, 12, 15 ) );  // Destination rectangle
        super.drawRectangle( new Rectangle( 259, 32, 12, 15 ) );  // Source rectangle 
        super.drawLine( new Rectangle( 221, 87, 3, 33 ) );  // vertical line from button panel
        super.drawLine( new Rectangle( 92, 117, 129, 3 ) );  // horiz. line from button panel
        super.drawLine( new Rectangle( 91, 108, 3, 12 ) );  // vertical line to arrowhead
        super.drawArrowhead( new Rectangle( 78, 88, 30, 30 ), PTVPanel.I_UP_TRIANGLE );  // 270
    }

    public JToggleButton createButton( String stStandardIconFile, String stPressedIconFile,
        String stButtonDescription ) {
            
        JToggleButton jtbThisButton;
        
        jtbThisButton = new JToggleButton( "", new ImageIcon( 
            ST_HOME_DIRECTORY + stStandardIconFile ) );
        jtbThisButton.setPressedIcon( new ImageIcon( 
            ST_HOME_DIRECTORY + stPressedIconFile ) );
        jtbThisButton.setSelectedIcon( new ImageIcon( 
            ST_HOME_DIRECTORY + stPressedIconFile ) );
        jtbThisButton.setToolTipText( stButtonDescription );
        jtbThisButton.addActionListener( this );
        
        return jtbThisButton;
    }
    
    ////////////////////////// PRIVATE METHOD \\\\\\\\\\\\\\\\\\\\\\
    private void setCorrectButton( int iOpcodeID ) {
        JToggleButton jtbButtonToPress;
        boolean bContinue;

        bContinue = true;
        
        switch ( iOpcodeID ) {
            case Opcode.I_OPCODE__MATH_ADD:
                jtbButtonToPress = (JToggleButton)alGroupButtons.get( I_JBUTTON_ADD );
                break;
                
            case Opcode.I_OPCODE__MATH_SUBTRACT:
                jtbButtonToPress = (JToggleButton)alGroupButtons.get( I_JBUTTON_SUBTRACT );
                break;
                
            case Opcode.I_OPCODE__MATH_MULTIPLY:
                jtbButtonToPress = (JToggleButton)alGroupButtons.get( I_JBUTTON_MULTIPLY );
                break;
                
            case Opcode.I_OPCODE__MATH_DIVIDE:
                jtbButtonToPress = (JToggleButton)alGroupButtons.get( I_JBUTTON_DIVIDE );
                break;
                
            case Opcode.I_OPCODE__MATH_MODULUS:
                jtbButtonToPress = (JToggleButton)alGroupButtons.get( I_JBUTTON_MODULUS );
                break;
                
            default:
                bContinue = false;
                jtbButtonToPress = new JToggleButton();
        }
        
        if ( bContinue == true ) {
            jtbButtonToPress.setSelected( true );
        }        
    }
    
    private void clearAll() {
        instThisInstruction = new Instruction();
        super.clearForm();        
    }

    
    
    // instance variables
    private Instruction instThisInstruction;
    private Opcode opMathOpcode;
    private Operand operDestination, operSource;
    private JButton jbApply;
    private ArrayList alGroupButtons;
    private int iDestinationOperandID, iSourceOperandID;
    private BitSet bsDestinationOpRestrictionFlags, bsSourceOpRestrictionFlags;
    private PTVHelpDialog ptvhdHelp;
    
    // constants
    private final int I_JBUTTON_ADD = 0;
    private final int I_JBUTTON_SUBTRACT = 1;
    private final int I_JBUTTON_MULTIPLY = 2;
    private final int I_JBUTTON_DIVIDE = 3;
    private final int I_JBUTTON_MODULUS = 4;
    private final int I_JBUTTON_LAST_BUTTON = 5;
}