/*
 * MoveAllPanel.java
 *
 * Created on June 14, 2002, 3:30 PM
 */

import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.awt.*;

/**
 *
 * @author  _
 * @version 
 */
public class MoveAllPanel extends PTVPanel 
    implements ActionListener, DataObjectAreaListener {

    public MoveAllPanel( JFrame jfParentFrame, String stDialogTitle, 
        Dimension diPanelSize, Program progThisProgram, 
        SortableDeclarationsTableModel sdtmModel ) {

        super( jfParentFrame, stDialogTitle, diPanelSize, progThisProgram, sdtmModel );

        iFirstClickedOperandID = I_UNDEFINED;
        super.setActionListener( this );
        super.setDataObjectAreaListener( this );
        
        createObjects();
        drawPanel();
        finishPanelConfiguration();                    
    }
    
    public void setInstruction( Instruction instInstruction ) {
        instThisInstruction = (Instruction)instInstruction.clone();        
        operDestination = instThisInstruction.getLeftOperand();
        operSource = instThisInstruction.getRightOperand();

        // set up the panel appropriately
        dataObjectAreaChanged( iDestinationOperandID, operDestination );
        super.updateDataObjectArea( iDestinationOperandID, operDestination );        
        dataObjectAreaChanged( iSourceOperandID, operSource );
        super.updateDataObjectArea( iSourceOperandID, operSource );        
        jlLabelText.setText( instThisInstruction.getLabel().getName() );
        jtaComments.setText( instThisInstruction.getComments() );
    }

    //------------------ ActionListener Implementation -----------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objActionSource, objTemp;
        JButton jbThisButton;
        boolean bFound;
        int iIndex, iCurrentLine, iLabelUsedStatus;
        String stTemp;
        DataObject doThisDataObject;
        Status statInformation;
        
        iLabelUsedStatus = super.I_OK;
        objActionSource = aeEvent.getSource();        
        statInformation = new Status( iLabelUsedStatus );
        
        if ( objActionSource == jbApply ) {
            // since the Instruction parts were likely defined legally, it is
            // not necessary to do error checking...unless in "debugging mode"            
            stTemp = this.getLabel().getText();

            if ( stTemp.equals( "" ) == false ) {
                statInformation = super.isLabelUsed( stTemp );
                iLabelUsedStatus = statInformation.getStatusNumber();

                if ( iLabelUsedStatus == super.I_OK ) {
                    objTemp = deDeclarations.getDeclaration( stTemp );

                    if ( objTemp instanceof DataObject ) {
                        doThisDataObject = (DataObject)objTemp;
                        instThisInstruction.setLabel( 
                            new NameAndDataObjectWrapper( stTemp, doThisDataObject ) );
                    }
                }
                else {
                    JOptionPane.showMessageDialog( this, 
                        statInformation.getStatusMessage(), 
                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                }                                                                
            }
            else {
                doThisDataObject = new DataObject();
                doThisDataObject.setType( DataObject.I_TYPE_LABEL );
                instThisInstruction.setLabel( 
                    new NameAndDataObjectWrapper( "", doThisDataObject ) );
            }


            stTemp = this.getComments().getText();

            if ( stTemp.equals( "" ) == false ) {
                instThisInstruction.setComments( stTemp );
            }
            //  else, ignore

            if ( iLabelUsedStatus == super.I_OK ) {
                // operands are updated as the panel is clicked
                if ( operDestination.getOperandType() != DataObject.I_UNDEFINED ) {
                    instThisInstruction.setLeftOperand( operDestination );

                    if ( operSource.getOperandType() != DataObject.I_UNDEFINED ) {
                        if ( ( operSource.getOperandRestriction() == 
                                DataObject.I_RESTRICTION_LITERAL )  &&
                             ( operSource.getOperandType() == 
                                DataObject.I_TYPE_CHARACTER )  && 
                             ( operSource.getOperandStructure() ==
                                DataObject.I_STRUCTURE_1D_ARRAY ) ) {
                            if ( ( operDestination.getOperandType() == 
                                DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  ||
                                 ( operDestination.getOperandType() == 
                                    DataObject.I_TYPE_INTEGER ) ) {
                                statInformation = verifySourceOperand();
                            }
                            else {
                                statInformation = new Status( I_OK );
                            }
                        }
                        // else, nothing
                            
                        if ( statInformation.getStatusNumber() == I_OK ) {                            
                            instThisInstruction.setRightOperand( operSource );
                            statInformation = instThisInstruction.validateInstruction();

                            if ( statInformation.getStatusNumber() == Instruction.I_OK ) {
                                iCurrentLine = vctCodeTable.getCurrentRow();

                                if ( codeThisCode.getEditingMode() == Code.B_MODE_INSERT ) {
                                    statInformation = codeThisCode.insertSingleLine( 
                                        iCurrentLine, instThisInstruction );
                                }
                                else {  // overwrite
                                    statInformation = codeThisCode.changeSingleLine( 
                                        iCurrentLine, instThisInstruction );
                                }

                                if ( statInformation.getStatusNumber() != Instruction.I_OK ) {
                                    JOptionPane.showMessageDialog( this, 
                                        statInformation.getStatusMessage(), 
                                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                                }
                                else {
                                    clearAll();
                                }
                            }
                            else {
                                JOptionPane.showMessageDialog( this, 
                                    statInformation.getStatusMessage(),
                                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                            }
                        }
                        else {
                            JOptionPane.showMessageDialog( this, 
                                statInformation.getStatusMessage(),
                                ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                        }                            
                    }
                    else {
                        JOptionPane.showMessageDialog( this, 
                            "A source operand is required for this instruction.", 
                            ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                    }
                }
                else {
                    JOptionPane.showMessageDialog( this, 
                        "A destination operand is required for this instruction.", 
                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                }
            }
        }
        else {
            super.actionPerformed( aeEvent );
            
            if ( objActionSource == super.jbClear ) {
                clearAll();
            }
        }
    }
    
    //------------- DataObjectAreaListener Implementation ------------\\
    public void dataObjectAreaChanged( int iID, Operand operData ) {
        if ( iID == iDestinationOperandID ) {
            operDestination = operData;
            updateRestrictionFlags( iID );
            instThisInstruction.setLeftOperand( operDestination );
        }
        else if ( iID == iSourceOperandID ) {
            operSource = operData;
            updateRestrictionFlags( iID );
            instThisInstruction.setRightOperand( operSource );
        }
        // else ignore
    }
    
    //////////////////////// PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\\\\\
    private void createObjects() {
        ptvhdHelp = new PTVHelpDialog( jfParentFrame, "Help >> Panel >> Move" );
        ptvhdHelp.setHelpFile( "help_panel_move.html" );
        super.setHelpDialog( ptvhdHelp );
        
        jbApply = super.getApplyInstructionButton();
        jbApply.addActionListener( this );
        
        bsDestinationOpRestrictionFlags = super.getNewDataObjectAreaRestrictionList();
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_SINGLE );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
        bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );
                                       
        bsSourceOpRestrictionFlags = super.getNewDataObjectAreaRestrictionList();
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CONSTANT );        
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_LITERAL );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_SINGLE );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_KEYBOARD_INPUT );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
        bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );
        
        bsDestinationOpBackupRestrictionFlags = (BitSet)bsDestinationOpRestrictionFlags.clone();
        bsSourceOpBackupRestrictionFlags = (BitSet)bsSourceOpRestrictionFlags.clone();
                        
        operDestination = new Operand();
        operSource = new Operand();
        opMoveAllOpcode = new Opcode();
        opMoveAllOpcode.setOpcode( Opcode.I_OPCODE__MOVE_ALL );
        instThisInstruction = new Instruction();
        instThisInstruction.setOpcode( opMoveAllOpcode );
    }
    
    private void finishPanelConfiguration() {
        // assume that everything worked ok...since IDs should be valid
        super.setDataObjectAreaRestrictionList( iDestinationOperandID, bsDestinationOpRestrictionFlags );
        super.setDataObjectAreaRestrictionList( iSourceOperandID, bsSourceOpRestrictionFlags );
    }
    
    private void drawPanel() {
        iSourceOperandID = super.drawDataObjectArea( new Point( 6, 6 ), operSource );
        iDestinationOperandID = super.drawDataObjectArea( new Point( 192, 6 ), operDestination );

        super.drawLabelAndCommentsAndActionButtons();
        super.drawLine( new Rectangle( 149, 38, 25, 3 ) );  // line from Destination operand
        super.drawArrowhead( new Rectangle( 174, 32, 15, 14 ), PTVPanel.I_RIGHT_TRIANGLE );
    }
    
    private void updateRestrictionFlags( int iClickedID ) {
        Operand operClickedOperand;
        int iOperandType, iOperandStructure, iOperandRestriction, 
            iOperandArrayElement;
        
        // BEFORE CLICK: one operand blank; AFTER CLICK: both operands blank
        if ( ( operDestination.getOperandType() == DataObject.I_UNDEFINED )  && 
             ( operSource.getOperandType() == DataObject.I_UNDEFINED ) ) {
            iFirstClickedOperandID = I_UNDEFINED;
            bsDestinationOpRestrictionFlags = (BitSet)
                bsDestinationOpBackupRestrictionFlags.clone();
            bsSourceOpRestrictionFlags = (BitSet)bsSourceOpBackupRestrictionFlags.clone();
            super.setDataObjectAreaRestrictionList( iDestinationOperandID, 
                bsDestinationOpRestrictionFlags );
            super.setDataObjectAreaRestrictionList( iSourceOperandID, 
                bsSourceOpRestrictionFlags );            
        }
        else {
            if ( iFirstClickedOperandID == I_UNDEFINED ) {
                iFirstClickedOperandID = iClickedID;
            }

            // clicked operand affects the unclicked operand
            if ( iFirstClickedOperandID == iClickedID ) {
                if ( iClickedID == iDestinationOperandID ) {
                    iOperandType = operDestination.getOperandType();
                    iOperandStructure = operDestination.getOperandStructure();
                    iOperandRestriction = operDestination.getOperandRestriction();
                    iOperandArrayElement = operDestination.getArrayElementIndexSetting();
                    
                    bsSourceOpRestrictionFlags = 
                        super.getNewDataObjectAreaRestrictionList();
                    bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
                    bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_CONSTANT );
                    bsSourceOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_LITERAL );
                    
                    switch ( iOperandType ) {
                        case DataObject.I_SYSTEM_TYPE_DISPLAY:
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_SINGLE );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );
                            break;
                        
                        case DataObject.I_TYPE_CHARACTER:                        
                            if ( iOperandStructure == DataObject.I_STRUCTURE_1D_ARRAY ) {
                                if ( iOperandArrayElement == Operand.I_UNDEFINED ) {
                                    bsSourceOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_INT_SINGLE );
                                    bsSourceOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_KEYBOARD_INPUT );
                                    bsSourceOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
                                }
                                else {  // treat as single character
                                    bsSourceOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );
                                    bsSourceOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );                                
                                }
                            }
                            else if ( iOperandStructure == 
                                DataObject.I_STRUCTURE_SINGLE_VALUE ) {
                                bsSourceOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );
                                bsSourceOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );                                
                                bsSourceOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_KEYBOARD_INPUT );
                            }
                            break;
                            
                        case DataObject.I_TYPE_INTEGER:
                        case DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER:
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_KEYBOARD_INPUT );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_SINGLE );
                            bsSourceOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
                            break;                            
                    }
                    super.setDataObjectAreaRestrictionList( iSourceOperandID, 
                        bsSourceOpRestrictionFlags );                    
                }
                else if ( iClickedID == iSourceOperandID ) {
                    iOperandType = operSource.getOperandType();
                    iOperandStructure = operSource.getOperandStructure();
                    iOperandRestriction = operSource.getOperandRestriction();
                    iOperandArrayElement = operSource.getArrayElementIndexSetting();

                    bsDestinationOpRestrictionFlags = 
                        super.getNewDataObjectAreaRestrictionList();
                    bsDestinationOpRestrictionFlags.set( AllPurposeMenu.I_FLAG_VARIABLE );
                    
                    switch ( iOperandType ) {
                        case DataObject.I_SYSTEM_TYPE_KEYBOARD:
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_SINGLE );
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );                            
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );                            
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );                            
                            break;
                        
                        case DataObject.I_TYPE_CHARACTER:
                            if ( iOperandStructure == DataObject.I_STRUCTURE_1D_ARRAY ) {
                                if ( iOperandArrayElement == Operand.I_UNDEFINED ) {
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_INT_SINGLE );
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT );
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );
                                }
                                else {  // treat as a single character
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );                            
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT );
                                    bsDestinationOpRestrictionFlags.set( 
                                        AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );                            
                                }
                            }
                            else if ( iOperandStructure == 
                                DataObject.I_STRUCTURE_SINGLE_VALUE ) {
                                bsDestinationOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_CHARACTER_SINGLE );                            
                                bsDestinationOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT );
                                bsDestinationOpRestrictionFlags.set( 
                                    AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT );                            
                            }
                            break;
                            
                        case DataObject.I_TYPE_INTEGER:
                        case DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER:
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_SINGLE );
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT );
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_CHARACTER_ARRAY );
                            bsDestinationOpRestrictionFlags.set( 
                                AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT );                            
                            break;                            
                    }                    
                    super.setDataObjectAreaRestrictionList( iDestinationOperandID, 
                        bsDestinationOpRestrictionFlags );                                        
                }  // end of source operand
            } // else, no restriction change...ignore
        }  // end of else        
    }
    
    private Status verifySourceOperand() {
        int iSize, iIndex;
        Object objThisObject;
        boolean bValid;
        char chThisChar;
        String stTemp, stMessage;
        Status statInformation;
        
        objThisObject = operSource.getOperandValue();
        
        if ( objThisObject instanceof Status ) {
            statInformation = (Status)objThisObject;
        }
        else {
            stTemp = (String)objThisObject;
            iSize = stTemp.length();
            bValid = true;
            iIndex = 0;
            
            do {
                chThisChar = stTemp.charAt( iIndex );
                
                if ( Character.isDigit( chThisChar ) == true ) {
                    iIndex++;
                }
                else {
                    if ( ( iIndex == 0 )  &&  ( chThisChar == '-' ) ) {
                        iIndex++;
                    }
                    else if ( ( iIndex == 0 )  &&  ( chThisChar == '+' ) ) {
                        iIndex++;
                    }
                    else {
                        bValid = false;
                    }
                }
            }
            while ( ( iIndex < iSize )  &&  ( bValid == true ) );
            
            if ( bValid == false ) {
                stMessage = "The literal " + stTemp + " must have all digits if " 
                    + "stored as a number.";
                statInformation = new Status( I_LOGICALLY_ILLEGAL_LITERAL, stMessage );                
            }
            else {
                statInformation = new Status( I_OK );
            }
        }
        return statInformation;
    }

    private void clearAll() {
        instThisInstruction = new Instruction();
        instThisInstruction.setOpcode( opMoveAllOpcode );
        super.clearForm();        
    }
        
    
    // instance variables
    private Instruction instThisInstruction;
    private Opcode opMoveAllOpcode;
    private Operand operDestination, operSource;
    private JButton jbApply;
    private int iDestinationOperandID, iSourceOperandID, iFirstClickedOperandID;
    private BitSet bsDestinationOpRestrictionFlags, bsDestinationOpBackupRestrictionFlags,
        bsSourceOpRestrictionFlags, bsSourceOpBackupRestrictionFlags;
    private PTVHelpDialog ptvhdHelp;
    
    // class constants
    private static final int I_OK = 0;
    private static final int I_LOGICALLY_ILLEGAL_LITERAL = -1;
}