/*
 * NameAndDataObjectWrapper.java
 *
 * Created on February 5, 2002, 4:02 PM
 */

//package panelsAndTools;
import java.io.*;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */

public class NameAndDataObjectWrapper implements Cloneable, Serializable {
    public NameAndDataObjectWrapper( String stThisName, DataObject doThisObject ) {
        stObjectName = stThisName;
        doObject = doThisObject;
        //System.out.println( "Called NameAndDataObjectWrapper with PARAMETERS.  " + stThisName + " says hi!" );
    }
    
    public NameAndDataObjectWrapper() {
        stObjectName = new String( "" );
        doObject = new DataObject();
    }
    
    protected Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6        
        try {
            NameAndDataObjectWrapper nadowObject = 
                (NameAndDataObjectWrapper)super.clone();
            nadowObject.doObject = (DataObject)this.doObject.clone();
            nadowObject.stObjectName = new String( this.stObjectName );
            
            return nadowObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of NameAndDataObjectWrapper is not supported." );
            return null;
        }
    }
        
    public String getName() {
        return new String( stObjectName );
    }
    
    public DataObject getObject() {
        return (DataObject)doObject.clone();
    }
    
    ////////////////////////////// FILE I/O METHODS \\\\\\\\\\\\\\\\\\
    public Vector exportState() {
        Vector vData;
        
        vData = new Vector();
        vData.setSize( I_TOTAL_FIELD_COUNT );        
        vData.set( I_NAME, stObjectName );
        vData.set( I_DATA_OBJECT, doObject.exportState() );
        return vData;
    }
    
    public void importState( Vector vData ) {
        stObjectName = (String)vData.get( I_NAME );
        doObject.importState( (Vector)vData.get( I_DATA_OBJECT )  );
        
        if ( doObject.getRestriction() == DataObject.I_RESTRICTION_LITERAL ) {
            doObject.validateValue();
        }
    }
    
    // class constants
    private static final int I_NAME = 0;
    private static final int I_DATA_OBJECT = 1;
    private static final int I_TOTAL_FIELD_COUNT = 2;
    
    // instance variables
    private String stObjectName;
    private DataObject doObject;
}