/*
 * ObjectEditorPanel.java
 *
 * Created on April 11, 2002, 2:27 PM
 */

//package panelsAndTools;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author  family
 * @version 
 */

public class ObjectEditorPanel extends JDialog {
    public ObjectEditorPanel( JFrame jfParentFrame, String stDialogTitle, 
        Dimension diPanelSize, Program progThisProgram, 
        SortableDeclarationsTableModel sdtmModel ) {
        
        super( jfParentFrame, stDialogTitle, false );

        String stHomeDirectory;
        Declarations deDeclarations;
        
        setSize( diPanelSize );
        //setResizable( false );

        deDeclarations = progThisProgram.getDeclarations();
        // remove later
        deDeclarations.addDefaultDeclarations();
        
        
        rotObjectTable = new RecordObjectTable( deDeclarations, sdtmModel );
                
        ofepObjectFormEditor = new ObjectFormEditorPanel( progThisProgram, 
            rotObjectTable, jfParentFrame );
        rotObjectTable.setRecordTableListener( ofepObjectFormEditor );
        JScrollPane jspScrollPane = new JScrollPane( rotObjectTable );
        
        Container c = getContentPane();
        c.setLayout( new BorderLayout() );
        c.add( jspScrollPane, "North" );
        c.add( ofepObjectFormEditor, "South" );
                
        addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent weEvent ) {
                setVisible( false );
            }
        });
    }               
    
    public void showDialog( int iXLocation, int iYLocation ) {
        this.setBounds( iXLocation, iYLocation, this.getWidth(), this.getHeight() );
        this.show();
    }
    
    private RecordObjectTable rotObjectTable;
    private ObjectFormEditorPanel ofepObjectFormEditor;
}