/*
 * Opcode.java
 *
 * Created on April 16, 2002, 9:20 AM
 */

//package panelsAndTools;

import java.util.*;
import java.io.*;
import javax.swing.*;

/**
 *
 * @author  _
 * @version 
 */
   
public class Opcode implements Cloneable, Serializable {
    public Opcode() {
        iOpcodeNumber = I_OPCODE__UNDEFINED;
        iiGroupFunctionIcon = new ImageIcon( "", "none" );
        iiThisFunctionIcon = new ImageIcon( "", "none" );
        stGroupFunctionIconFileName = "";
        stGroupFunctionDescription = "";
        stThisFunctionIconFileName = "";
        stThisFunctionDescription = "";
    }
    
    protected Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6
        try {
            Opcode opObject = (Opcode)super.clone();
            opObject.iiGroupFunctionIcon = this.getGroupFunctionIcon();
            opObject.iiThisFunctionIcon = this.getThisFunctionIcon();
            opObject.stGroupFunctionIconFileName = 
                new String( this.stGroupFunctionIconFileName );
            opObject.stThisFunctionIconFileName = 
                new String( this.stThisFunctionIconFileName );
            opObject.stGroupFunctionDescription = 
                new String( this.stGroupFunctionDescription );            
            opObject.stThisFunctionDescription = 
                new String( this.stThisFunctionDescription );
            
            return opObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of Opcode is not supported." );
            return null;
        }
    }    
    
    public Status setOpcode( int iOpcode ) {
        Status statInformation;
        String stMessage, stDescription;
        boolean bValid;
        
        bValid = true;
        System.out.println( "OPCODE: setOpcode:: received " + iOpcode );
     
        if ( ( iOpcode >= I_OPCODE__MATH_FIRST )  &&  
             ( iOpcode <= I_OPCODE__MATH_LAST ) ) {
            stGroupFunctionIconFileName = "math-icon.jpg";
            stGroupFunctionDescription = "MATH";

            switch ( iOpcode ) {                    
                case I_OPCODE__MATH_ADD:
                    stThisFunctionIconFileName = "plus-icon.jpg";
                    stThisFunctionDescription = "Add";
                    break;

                case I_OPCODE__MATH_SUBTRACT:
                    stThisFunctionIconFileName = "minus-icon.jpg";
                    stThisFunctionDescription = "Subtract";
                    break;

                case I_OPCODE__MATH_MULTIPLY:
                    stThisFunctionIconFileName = "multiply-icon.jpg";
                    stThisFunctionDescription = "Multiply";
                    break;

                case I_OPCODE__MATH_DIVIDE:
                    stThisFunctionIconFileName = "divide-icon.jpg";
                    stThisFunctionDescription = "Divide";
                    break;

                case I_OPCODE__MATH_MODULUS:
                    stThisFunctionIconFileName = "percent-icon.jpg";
                    stThisFunctionDescription = "Modulus";
                    break;
            }
        }
        else if ( ( iOpcode >= I_OPCODE__COMPARE_FIRST )  &&  
                  ( iOpcode <= I_OPCODE__BRANCH_LAST  ) ) {

            if ( ( iOpcode >= I_OPCODE__COMPARE_FIRST )  &&  
                 ( iOpcode <= I_OPCODE__COMPARE_LAST  ) ) {
                stGroupFunctionIconFileName = "compare-icon.jpg";
                stGroupFunctionDescription = "COMPARE\r& BRANCH";
            }
            else if ( ( iOpcode >= I_OPCODE__BRANCH_FIRST )  &&  
                      ( iOpcode <= I_OPCODE__BRANCH_LAST  ) ) {
                stGroupFunctionIconFileName = "compare_branch-icon.jpg";
                stGroupFunctionDescription = "COMPARE\r& BRANCH";
            }

            switch ( iOpcode ) {
                case I_OPCODE__COMPARE_LESS_THAN:
                case I_OPCODE__BRANCH_LESS_THAN:
                    stThisFunctionIconFileName = "less-than-icon.jpg";
                    stThisFunctionDescription = "Less Than";
                    break;

                case I_OPCODE__COMPARE_LESS_THAN_OR_EQUAL:
                case I_OPCODE__BRANCH_LESS_THAN_OR_EQUAL:                        
                    stThisFunctionIconFileName = "less-than-equal-icon.jpg";
                    stThisFunctionDescription = "Less Than or Equal To";
                    break;

                case I_OPCODE__COMPARE_EQUAL:
                case I_OPCODE__BRANCH_EQUAL:
                    stThisFunctionIconFileName = "equal-icon.jpg";
                    stThisFunctionDescription = "Equal To";
                    break;

                case I_OPCODE__COMPARE_GREATER_THAN:
                case I_OPCODE__BRANCH_GREATER_THAN:
                    stThisFunctionIconFileName = "greater-than-icon.jpg";
                    stThisFunctionDescription = "Greater Than";
                    break;

                case I_OPCODE__COMPARE_GREATER_THAN_OR_EQUAL:
                case I_OPCODE__BRANCH_GREATER_THAN_OR_EQUAL:
                    stThisFunctionIconFileName = "greater-than-equal-icon.jpg";
                    stThisFunctionDescription = "Greater Than or Equal To";
                    break;

                case I_OPCODE__COMPARE_NOT_EQUAL:
                case I_OPCODE__BRANCH_NOT_EQUAL:
                    stThisFunctionIconFileName = "not-equal-icon.jpg";
                    stThisFunctionDescription = "Not Equal To";
                    break;
                    
                case I_OPCODE__BRANCH_ALWAYS:
                    stThisFunctionIconFileName = "always-branch-icon.jpg";
                    stThisFunctionDescription = "Branch Always";
                    break;                    
            }
        }
        else {
            System.out.println( "Last chance..." );
            stThisFunctionIconFileName = "";
            switch ( iOpcode ) {
                case I_OPCODE__MOVE_ALL:
                    stGroupFunctionIconFileName = "move-icon.jpg";
                    stGroupFunctionDescription = "MOVE";
                    break;

                case I_OPCODE__MOVE_PARTS:
                    stGroupFunctionIconFileName = "move_parts-icon.jpg";
                    stGroupFunctionDescription = "MOVE\rCHARACTERS";
                    break;

                case I_OPCODE__COMMENTS:
                    stGroupFunctionIconFileName = "section_comments-icon.jpg";
                    stGroupFunctionDescription = "SECTION\rCOMMENTS";
                    break;
                    
                case I_OPCODE__IGNORE:
                    stGroupFunctionIconFileName = "";
                    stGroupFunctionDescription = "";
                    break;

                default:
                    bValid = false;
                    break;
            }
        }

        System.out.println( "FOUND..." + stGroupFunctionDescription );
        System.out.println( "Valid = " + bValid );
        if ( bValid == true ) {
            iiThisFunctionIcon = 
                new ImageIcon( stHomeDirectory + stThisFunctionIconFileName,
                    stGroupFunctionDescription );
            
            iiGroupFunctionIcon = 
                new ImageIcon( stHomeDirectory + stGroupFunctionIconFileName, 
                    stThisFunctionDescription );

            statInformation = new Status( I_OK );
            iOpcodeNumber = iOpcode;   
        }
        else {
            stMessage = "The specified opcode is invalid.";
            statInformation = new Status( I_ILLEGAL_OPCODE, stMessage );            
        }
        return statInformation;
    }
    
    public int getOpcode() {
        return iOpcodeNumber;
    }
    
    public ImageIcon getGroupFunctionIcon() {
        return new ImageIcon( new String( stHomeDirectory + stGroupFunctionIconFileName ),
            new String( stGroupFunctionDescription ) );
    }
    
    public ImageIcon getThisFunctionIcon() {
        return new ImageIcon( new String( stHomeDirectory + stThisFunctionIconFileName ),
            new String( stThisFunctionDescription ) );
    }    

    // operands cannot change the properties of the DataObject; thus, when an
    // object from an array is used, it will contain a valid starting index value;
    // no differentiation will be given to integer single or integer array;
    // system types will have their structure ignored unless it is not prudent to do so
    public Status validateOperands( Operand operLeft, Operand operRight,
        Operand operLabel ) {        
        int iLeftType, iRightType, iLeftRestriction, iRightRestriction,
            iLeftStructure, iRightStructure, iLeftArraySize, iRightArraySize,
            iOtherType, iLeftOperandArrayIndex, iRightOperandArrayIndex;
        String stMessage;
        Status statInformation;
        boolean bValidOperands, bIllegalLeftArrayIndex, bIllegalRightArrayIndex;

        bValidOperands = false;
        stMessage = "";
        System.out.println( "-1-" );
        // left is destination, right is source
        iLeftType = operLeft.getOperandType();
        iRightType = operRight.getOperandType();
        iLeftRestriction = operLeft.getOperandRestriction();
        iRightRestriction = operRight.getOperandRestriction();
        iLeftStructure = operLeft.getOperandStructure();
        iRightStructure = operRight.getOperandStructure();
        iLeftOperandArrayIndex = operLeft.getArrayElementIndexSetting();
        iRightOperandArrayIndex = operRight.getArrayElementIndexSetting();
        bIllegalLeftArrayIndex = operLeft.getIllegalArrayIndexFlag();
        bIllegalRightArrayIndex = operRight.getIllegalArrayIndexFlag();
        System.out.println( "-2-" );
        System.out.println( "Left Structure = " + DataObjectPropertyTextView.getStructureName( iLeftStructure ) );
        System.out.println( "Left valid array index = " + bIllegalLeftArrayIndex );
        System.out.println( "Right Structure = " + DataObjectPropertyTextView.getStructureName( iRightStructure ) );
        System.out.println( "Right valid array index = " + bIllegalRightArrayIndex );
        
        if ( iOpcodeNumber == I_OPCODE__IGNORE ) {
            bValidOperands = true;
            System.out.println( "IGNORE...so valid operands." );
        }  
        else if ( ( ( bIllegalLeftArrayIndex == true )  && 
                    ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) || 
                  ( ( bIllegalRightArrayIndex == true ) && 
                    ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) ) {
            System.out.println( "-3-" );
            if ( bIllegalLeftArrayIndex == true ) {
                System.out.println( "-4-" );
                stMessage = operLeft.getFailedOperandInformation();
                System.out.println( "-5-" );
            }
            else if ( bIllegalRightArrayIndex == true ) {
                System.out.println( "-6-" );
                stMessage = operRight.getFailedOperandInformation();
                System.out.println( "-7-" );
            }
            else {
                System.out.println( "-8-" );
                stMessage = "???";
                System.out.println( "-9-" );
            }
            System.out.println( "-10-" );
            bValidOperands = false; 
            System.out.println( "-11-" );
        }
        // should work for integer array elements
        else if ( ( iOpcodeNumber >= I_OPCODE__MATH_FIRST )  &&
                  ( iOpcodeNumber <= I_OPCODE__MATH_LAST ) ) {
            if ( ( ( iLeftType == DataObject.I_TYPE_INTEGER )  &&
                   ( isValidInteger( iLeftStructure, iLeftOperandArrayIndex ) ) )  ||
                 ( iLeftType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER ) ) {
                if ( ( ( iRightType == DataObject.I_TYPE_INTEGER )  &&
                       ( isValidInteger( iRightStructure, iRightOperandArrayIndex ) ) ) ||
                     ( iRightType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER ) ) {
                    //if ( iLeftRestriction != DataObject.I_RESTRICTION_CONSTANT ) {
                    if ( iLeftRestriction == DataObject.I_RESTRICTION_VARIABLE ) {
                        bValidOperands = true;
                    }
                    else {
                        stMessage = "The destination operand cannot be constant.";
                    }
                }
                else {
                    stMessage = "The source operand must be an single integer "
                        + "or register.";
                }
            }
            else {
                stMessage = "The destination operand must be an single "
                    + "integer or register.";
            }
            
            if ( bValidOperands == false ) 
                System.out.println( "ERROR VALIDATING MATH INST..." + stMessage );
        }                                 
        /*else if ( ( iOpcodeNumber >= I_OPCODE__COMPARE_FIRST )  &&
                  ( iOpcodeNumber <= I_OPCODE__COMPARE_LAST ) ) {*/
        else if ( ( iOpcodeNumber >= I_OPCODE__BRANCH_FIRST )  &&
                  ( iOpcodeNumber <= I_OPCODE__BRANCH_LAST ) ) {
            if ( iOpcodeNumber != I_OPCODE__BRANCH_ALWAYS ) {
                // should work for integer array elements
                if ( ( ( iLeftType == DataObject.I_TYPE_INTEGER )  &&
                       ( isValidInteger( iLeftStructure, iLeftOperandArrayIndex ) ) ) || 
                     ( iLeftType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER ) ) {
                    if ( ( ( iRightType == DataObject.I_TYPE_INTEGER )  &&
                           ( isValidInteger( iRightStructure, iRightOperandArrayIndex ) ) )  ||
                         ( iRightType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER ) ) {
                        bValidOperands = true;
                    }
                    else {
                        stMessage = "The right operand must be an single "
                            + "integer or register.";
                    }    
                }
                else if ( ( ( iLeftType == DataObject.I_TYPE_CHARACTER )  &&
                            ( iLeftStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) )  ||
                          ( ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY )  &&
                            ( iLeftOperandArrayIndex != Operand.I_UNDEFINED )  &&
                            ( iLeftType == DataObject.I_TYPE_CHARACTER ) ) ) {
                                
                    if ( ( ( iRightType == DataObject.I_TYPE_CHARACTER )  &&
                            ( iRightStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) )  ||
                          ( ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY )  &&
                            ( iRightOperandArrayIndex != Operand.I_UNDEFINED )  &&
                            ( iRightType == DataObject.I_TYPE_CHARACTER ) ) ) { 
                        bValidOperands = true;
                    }
                    else {
                        stMessage = "The right operand must be a single character "
                            + "or a character array element.";
                    }                                                
                }                
                else if ( ( ( iLeftType == DataObject.I_TYPE_CHARACTER )  ||
                            ( iLeftType == DataObject.I_SYSTEM_TYPE_DISPLAY )  || 
                            ( iLeftType == DataObject.I_SYSTEM_TYPE_KEYBOARD ) ) && 
                          ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) {
                    if ( ( ( iRightType == DataObject.I_TYPE_CHARACTER )  ||
                           ( iRightType == DataObject.I_SYSTEM_TYPE_DISPLAY )  || 
                           ( iRightType == DataObject.I_SYSTEM_TYPE_KEYBOARD ) ) && 
                         ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) {
                        bValidOperands = true;
                    }
                    else {
                        stMessage = "The right operand must be a display, keyboard " 
                            + " or a character array.";
                    }
                }
                else {
                    stMessage = "Please reselect the operands for this operation.";
                }
            }
            else {
                bValidOperands = true;
            }
            
            if ( bValidOperands == true ) {
                iOtherType = operLabel.getOperandType();
                System.out.println( "OPCODE: Validating branch/compare label with type = " + iOtherType );
                
                if ( iOtherType == DataObject.I_TYPE_LABEL ) {
                    bValidOperands = true;
                    System.out.println( "VALID label." );
                }
                else {
                    bValidOperands = false;
                    stMessage = "A label operand must appear for this operation.";
                    System.out.println( "***NOT VALID label." );
                }
            }
        }   // end of branch/compare instruction
        else if ( iOpcodeNumber == I_OPCODE__MOVE_ALL ) {
            //if ( iLeftRestriction != DataObject.I_RESTRICTION_CONSTANT ) {
            if ( iLeftRestriction == DataObject.I_RESTRICTION_VARIABLE ) {
                
                // no DISPLAY on right side
                if ( ( ( iRightType == DataObject.I_TYPE_CHARACTER )  &&
                       ( iRightStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) )  ||
                     ( ( ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY )  &&
                         ( iRightOperandArrayIndex != Operand.I_UNDEFINED ) )  &&
                       ( iRightType == DataObject.I_SYSTEM_TYPE_KEYBOARD )  ||
                       ( iRightType == DataObject.I_TYPE_CHARACTER ) ) ) { 
                        
                    if ( ( iRightType == DataObject.I_TYPE_CHARACTER )  &&
                         ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY ) && 
                         ( iRightOperandArrayIndex == Operand.I_UNDEFINED ) )  {
                            
                        if ( ( iLeftType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  ||
                             ( ( iLeftType == DataObject.I_TYPE_INTEGER )  &&
                               ( isValidInteger( iLeftStructure, iLeftOperandArrayIndex ) ) ) ||
                             ( ( iLeftType == DataObject.I_SYSTEM_TYPE_DISPLAY )  &&
                               ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) ) {
                            bValidOperands = true;
                        }
                        else {
                            stMessage = "For this source operand, the destination operand "
                                + "should be a display, single integer, or register.";
                        }
                    }
                    else if ( ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY )  && 
                              ( ( iLeftType == DataObject.I_TYPE_CHARACTER )  ||
                                ( iLeftType == DataObject.I_SYSTEM_TYPE_DISPLAY ) ) ) {
                        bValidOperands = true;
                    }
                    // no KEYBOARD on left side
                    else if ( ( ( iLeftType == DataObject.I_TYPE_CHARACTER )  &&
                                ( iLeftStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) )  ||
                              ( ( ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY )  &&
                                  ( iLeftOperandArrayIndex != Operand.I_UNDEFINED ) )  &&
                                ( iLeftType == DataObject.I_SYSTEM_TYPE_DISPLAY )  ||
                                ( iLeftType == DataObject.I_TYPE_CHARACTER ) ) ) {
                        bValidOperands = true;
                    }
                    else {   // ** CHANGE MESSAGE **
                        stMessage = "If the source operand is a single character, then "
                            + "the destination operand must have a character type.";
                    }
                }
                else if ( ( iRightType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  ||
                          ( ( iRightType == DataObject.I_TYPE_INTEGER )  &&
                            ( isValidInteger( iRightStructure, iRightOperandArrayIndex ) ) ) ) { 
                    if ( ( iLeftType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  ||
                         ( ( iLeftType == DataObject.I_TYPE_INTEGER )  &&
                           ( isValidInteger( iLeftStructure, iLeftOperandArrayIndex ) ) ) ||
                         ( ( iLeftType == DataObject.I_TYPE_CHARACTER )  &&
                           ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY ) )  ||
                         ( ( iLeftType == DataObject.I_SYSTEM_TYPE_DISPLAY )  &&
                           ( iLeftStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) ) {                          
                            bValidOperands = true;
                    }
                    else {
                        stMessage = "For this source operand, the destination can be "
                            + "anything except a single character or keyboard.";
                    }
                }
                else if ( ( iRightType == DataObject.I_SYSTEM_TYPE_KEYBOARD )  &&
                          ( iRightStructure == DataObject.I_STRUCTURE_1D_ARRAY ) ) { 
                    if ( iLeftType != DataObject.I_SYSTEM_TYPE_DISPLAY ) {
                        bValidOperands = true;
                    }
                    else {
                        stMessage = "For this source operand, the destination operand "
                            + "cannot be a display type.";
                    }
                }
                else {
                    stMessage = "Please reselect the operands for this operation.";
                }              
            }  // restriction condition
            else {
                stMessage = "The destination operand cannot be constant.";
            }
        }
        else if ( iOpcodeNumber == I_OPCODE__MOVE_PARTS ) {
            System.out.println( "-12-" );
            // only allow character arrays and single characters
            //if ( iLeftRestriction != DataObject.I_RESTRICTION_CONSTANT ) {
            if ( iLeftRestriction == DataObject.I_RESTRICTION_VARIABLE ) {
                System.out.println( "-13-" );
                if ( ( iRightType == DataObject.I_TYPE_CHARACTER )  ||
                     ( iRightType == DataObject.I_SYSTEM_TYPE_KEYBOARD ) ) {
                        System.out.println( "-14-" );
                    if ( iLeftType == DataObject.I_TYPE_CHARACTER ) {
                        System.out.println( "-15-" );
                        iLeftArraySize = operLeft.getArrayLength();
                        System.out.println( "-16-" );
                        iRightArraySize = operRight.getArrayLength();
                        System.out.println( "-17-" );

                        if ( iLeftArraySize == iRightArraySize ) {
                            System.out.println( "-18-" );
                            bValidOperands = true;
                            System.out.println( "-19-" );
                        }
                        else {
                            System.out.println( "-20-" );
                            stMessage = "An equal number of characters must be "
                                + "moved between operands.";
                            System.out.println( "-21-" );
                        }
                    }
                    else {
                        System.out.println( "-22-" );
                        stMessage = "The destination operand must be a character type.";
                        System.out.println( "-23-" );
                    }
                }
                else {
                    System.out.println( "-24-" );
                    stMessage = "The source operand may only be a character type.";
                    System.out.println( "-25-" );
                }
            }
            else {
                System.out.println( "-26-" );
                stMessage = "The destination operand cannot be constant.";
                System.out.println( "-27-" );
            }
        }
        else if ( iOpcodeNumber == I_OPCODE__COMMENTS ) {
            bValidOperands = true;
        }
        else {
            stMessage = "No valid opcode was provided.";
        }

        if ( bValidOperands == true ) {
            statInformation = new Status( I_OK );
        }
        else {
            statInformation = new Status( I_ILLEGAL_OPERANDS, stMessage );
        }
        System.out.println( "validateOperands: message = " + statInformation.getStatusMessage() );
        return statInformation;        
    }
    
    private boolean isValidInteger( int iStructure, int iArraySetting ) {
        if ( iStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) {
            return true;
        }
        else if ( iStructure == DataObject.I_STRUCTURE_1D_ARRAY ) {
            if ( iArraySetting != Operand.I_UNDEFINED ) {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }

    
    // instance variables
    private int iOpcodeNumber;
    private ImageIcon iiGroupFunctionIcon, iiThisFunctionIcon;
    private String stGroupFunctionIconFileName, stThisFunctionIconFileName,
        stGroupFunctionDescription, stThisFunctionDescription;

    // class constants
    private final static String stHomeDirectory;

    //////////////////// ERROR CODES \\\\\\\\\\\\\\\\\\\\
    public static final int I_OK = 0;
    public static final int I_ILLEGAL_OPCODE = -1;
    public static final int I_ILLEGAL_OPERANDS = -2;
    public static final int I_UNDEFINED_OPCODE = -3;
    
    //////////////////// OPCODE CONSTANTS \\\\\\\\\\\\\\\\\\\\
    public static final int I_OPCODE__UNDEFINED = -99999;
    
    public static final int I_OPCODE__FIRST = 1;
    public static final int I_OPCODE__MATH_FIRST = 1;
    public static final int I_OPCODE__MATH_ADD = 1;
    public static final int I_OPCODE__MATH_SUBTRACT = 2;
    public static final int I_OPCODE__MATH_MULTIPLY = 3;
    public static final int I_OPCODE__MATH_DIVIDE = 4;
    public static final int I_OPCODE__MATH_MODULUS = 5;
    public static final int I_OPCODE__MATH_LAST = 5;
    
    public static final int I_OPCODE__IGNORE = 6;
    
    public static final int I_OPCODE__COMPARE_FIRST = 7;
    public static final int I_OPCODE__COMPARE_LESS_THAN = 7;
    public static final int I_OPCODE__COMPARE_LESS_THAN_OR_EQUAL = 8;
    public static final int I_OPCODE__COMPARE_EQUAL = 9;
    public static final int I_OPCODE__COMPARE_GREATER_THAN = 10;
    public static final int I_OPCODE__COMPARE_GREATER_THAN_OR_EQUAL = 11;
    public static final int I_OPCODE__COMPARE_NOT_EQUAL = 12;
    public static final int I_OPCODE__COMPARE_LAST = 12;

    public static final int I_OPCODE__BRANCH_FIRST = 13;
    public static final int I_OPCODE__BRANCH_LESS_THAN = 13;
    public static final int I_OPCODE__BRANCH_LESS_THAN_OR_EQUAL = 14;
    public static final int I_OPCODE__BRANCH_EQUAL = 15;
    public static final int I_OPCODE__BRANCH_GREATER_THAN = 16;
    public static final int I_OPCODE__BRANCH_GREATER_THAN_OR_EQUAL = 17;
    public static final int I_OPCODE__BRANCH_NOT_EQUAL = 18;
    public static final int I_OPCODE__BRANCH_ALWAYS = 19;
    public static final int I_OPCODE__BRANCH_LAST = 19;
        
    public static final int I_OPCODE__MOVE_ALL = 20;
    public static final int I_OPCODE__MOVE_PARTS = 21;
    public static final int I_OPCODE__COMMENTS = 22;
    public static final int I_OPCODE__LAST = 23;
    
    static {
        stHomeDirectory = "";/*"D:\\forte4j\\Development\\panelsAndTools\\";*/
    }
}