/*
 * OpcodeAndOperandsWrapper.java
 *
 * Created on August 1, 2002, 3:26 PM
 */

import java.io.*;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */
public class OpcodeAndOperandsWrapper implements Cloneable, Serializable {
    public OpcodeAndOperandsWrapper( int iOpcode, Operand operThisLeft, 
        Operand operThisRight, Operand operThisResult ) {
            
        intOpcodeID = new Integer( iOpcode );
        operLeft = (Operand)operThisLeft.clone();
        operRight = (Operand)operThisRight.clone();
        operResult = (Operand)operThisResult.clone();
    }
    
    protected Object clone() {
        // strucutre based on Sun's online Java tutorial for
        // the Object.clone() method and pp.235-6 C of Core Java 2: ISBN 0-13-081933-6        
        try {
            OpcodeAndOperandsWrapper oaowObject = 
                (OpcodeAndOperandsWrapper)super.clone();
            oaowObject.intOpcodeID = new Integer( this.intOpcodeID.intValue() );
            oaowObject.operLeft = (Operand)this.operLeft.clone();
            oaowObject.operRight = (Operand)this.operRight.clone();
            oaowObject.operResult = (Operand)this.operResult.clone();
            
            return oaowObject;
        }
        catch ( CloneNotSupportedException cnseException ) {
            System.out.println( "Clone of OpcodeAndOperandsWrapper is not supported." );
            return null;
        }
    }
    
    public int getOpcodeID() {
        return intOpcodeID.intValue() ;
    }
    
    public Operand getLeftOperand() {
        return  (Operand)operLeft.clone();
    }

    public Operand getRightOperand() {
        return (Operand)operRight.clone();
    }

    public Operand getResultOperand() {
        return (Operand)operResult.clone();
    }
    
    
    // instance variables
    private Integer intOpcodeID;
    private Operand operLeft, operRight, operResult;
}