/*
 * PTVHelpDialog.java
 *
 * Created on May 21, 2002, 5:00 PM
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.html.*;


/**
 *
 * @author  _
 * @version 
 */
public class PTVHelpDialog extends JDialog implements ActionListener {
    public PTVHelpDialog( JFrame jfParentFrame, String stHelpTitle ) {
        super( jfParentFrame, stHelpTitle, B_NON_MODAL );
        
        Container conContainer;
        Image imIcon;

        conContainer = this.getContentPane();
        jpHelpPanel = new JPanel();        
        conContainer.add( jpHelpPanel );
        
        this.toFront();
        this.setBounds( 101, 94, 603, 431 );
        this.setResizable( false );

        // get an information/help (?) icon
        imIcon = Toolkit.getDefaultToolkit().getImage( 
           "question-mark.jpg" );
        jfParentFrame.setIconImage( imIcon );
        initComponents();  
        
        this.addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent weEvent ) {
                hide();
                dispose();              
            }
        } );
        
    }

    public void setTitle( String stTitle ) {
        super.setTitle( stTitle );
    }
    
    public Status setHelpFile( String stHelpFileName ) {
        String stMessage;
        FileInputStream fisHelpFile;
        
        try {
            fisHelpFile = new FileInputStream( stHelpFileName );
//            System.out.println( "fisHelpFile: " + fisHelpFile );
//            System.out.println( "jepHelpArea: " + jepHelpArea );
            jepHelpArea.read( fisHelpFile, new HTMLDocument() );
            return new Status( I_OK );
        }
        catch ( FileNotFoundException fneException ) {
            stMessage = stHelpFileName + " is not valid.";
            return new Status( I_FILE_NOT_FOUND, stMessage );
        }
        catch ( IOException ioeException ) {
            stMessage = "The help file named " + stHelpFileName + " cannot be "
                + "displayed properly.";
            return new Status( I_HELP_FILE_ERROR, stMessage );
        }        
    }
    
    //------------- ActionListener Implementation -----------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objThisButtonPressed;
        
        objThisButtonPressed = aeEvent.getSource();
        
        if ( objThisButtonPressed == jbOKButton ) {
            this.hide();
        }
    }
    
    //////////////////// PRIVATE METHOD \\\\\\\\\\\\\\\\\\\\\\\
    private void initComponents() {
        jepHelpArea = new JEditorPane();
        jepHelpArea.setContentType( "text/html" );

        jspViewingArea = new JScrollPane( jepHelpArea );
        jepHelpArea.setEditable( false );
        jspViewingArea.setBounds( 8, 6, 580, 343 );
        jspViewingArea.setPreferredSize( new Dimension( 580, 363 ) );
        jpHelpPanel.add( jspViewingArea );
        
        jbOKButton = new JButton( "OK" );
        jbOKButton.setBounds( 273, 354, 55, 23 );
        jbOKButton.addActionListener( this );
        jpHelpPanel.add( jbOKButton );
    }
    
    // instance variables
    private JEditorPane jepHelpArea;
    private JButton jbOKButton;
    private JPanel jpHelpPanel;
    private JScrollPane jspViewingArea;
    
        // error codes
        public static final int I_OK = 0;
        public static final int I_HELP_FILE_ERROR = -1;
        public static final int I_FILE_NOT_FOUND = -2;
        
    private static final boolean B_NON_MODAL = false;
}