/*
 * PTVPanel.java
 *
 * Created on May 19, 2002, 6:31 PM
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;

/**
 *
 * @author  _
 * @version 
 */
public class PTVPanel extends JDialog implements ActionListener, MouseListener {
    
    public PTVPanel( JFrame jfFrame, String stTitle, Dimension diPanelSize,
        Program progUserProgram, SortableDeclarationsTableModel sdtmModel ) {
            
        super( jfFrame, stTitle, B_NON_MODAL );
        
        Container cPane;
                
        bEnableOperands = true;
        iExceptionOperand = I_UNDEFINED;
        
        jfParentFrame = jfFrame;        
        sdtmDataObjects = sdtmModel;
        
        progThisProgram = progUserProgram;
        //progThisProgram.setParentFrame( jfFrame );
        deDeclarations = progThisProgram.getDeclarations();
        vctCodeTable = progThisProgram.getVisualCodeTable();
        codeThisCode = progThisProgram.getCode();
        
        ldLiteralDialog = new LiteralDialog( jfParentFrame );
        
        apmPanelMenu = new AllPurposeMenu( this );
        apmPanelMenu.setCodeObject( codeThisCode );
        apmPanelMenu.setSortableDeclarationsModel( sdtmDataObjects );        
                        
        iDataObjectAreaClickedID = I_UNDEFINED;
        bLabelAreaClicked = false;
        
        iPanelWidth = (int)diPanelSize.getWidth();
        iPanelHeight = (int)diPanelSize.getHeight();
        
        cPane = this.getContentPane();
        jpPanel = new JPanel();       
        jpPanel.setLayout( null );
        jpPanel.addMouseListener( this );
        cPane.add( jpPanel );
        
        this.toFront();
        this.setSize( diPanelSize );
        this.setResizable( false );

        alDataObjectAreas = new ArrayList();
        iDataObjectCount = 0;
        jtbClearAll = new JToggleButton();

        this.addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent weEvent ) {
                hide();
            }
        } );
        
        initComponents();
    }
    
    public void showDialog( int iXLocation, int iYLocation ) {
        this.setBounds( 0, 0, this.getWidth(), this.getHeight() );
        this.show();
    }
    
    public Status isLabelUsed( String stThisLabel ) {
        /*boolean bUsedLabel;
        Status statInformation;
        String stMessage;
        
        bUsedLabel = apmPanelMenu.isLabelUsed( stThisLabel );
        
        if ( bUsedLabel == true ) {
            stMessage = "The label named " + stThisLabel + " is already used "
                + "in the code.";
            statInformation = new Status( I_DUPLICATE_LABEL, stMessage );
        }
        else {
            statInformation = new Status( I_OK );
        }*/
        Status statInformation = new Status( I_OK );
        return statInformation;
    }
    
    //------------------ Drawing Methods -------------------\\
    public void drawLine( Rectangle rLineArea ) {
        JLabel jlLine;
        
        jlLine = new JLabel();
        jlLine.setOpaque( true );
        jlLine.setBackground( Color.black );
        jlLine.setBounds( rLineArea );
        jpPanel.add( jlLine );
    }
    
    public void drawRectangle( Rectangle rArea ) {
        JLabel jlRectangle;
        
        jlRectangle = new JLabel();
        jlRectangle.setOpaque( true );
        jlRectangle.setBackground( Color.black );
        jlRectangle.setBounds( rArea );
        jpPanel.add( jlRectangle );
    }
    
    public Status drawArrowhead( Rectangle rArrowheadArea, int iTriangleType ) {
        JLabel jlArrowhead;
        Status statInformation;
        boolean bError;
        String stMessage;
        
        bError = false;

        if ( iTriangleType == I_UP_TRIANGLE ) {
            jlArrowhead = new JLabel( iiUpTriangle );
        }
        else if ( iTriangleType == I_RIGHT_TRIANGLE ) {
            jlArrowhead = new JLabel( iiRightTriangle );
        }
        else {
            jlArrowhead = new JLabel();
            bError = true;
        }
        
        if ( bError == true ) {
            stMessage = "The triangle can only be right or up.";
            statInformation = new Status( I_ILLEGAL_TRIANGLE_ID, stMessage );            
        }
        else {
            statInformation = new Status( I_OK );
            jlArrowhead.setOpaque( true );
            jpPanel.add( jlArrowhead );
            jlArrowhead.setBounds( (int)rArrowheadArea.getX(), 
                (int)rArrowheadArea.getY(), (int)rArrowheadArea.getWidth(),
                (int)rArrowheadArea.getHeight() );
        }
        return statInformation;
    }
    
    public void drawLabelAndCommentsAndActionButtons() {
        drawCustomLabelArea( new Point( iPanelWidth - 138 - 2 -10 - 27 - I_BORDER, 
            I_BORDER ) );
        
        drawCustomCommentsArea( new Rectangle( iPanelWidth - 138 -10 - 2 - 27 - I_BORDER,
            I_BORDER + 35, 27, 26 ), 
                                new Rectangle( iPanelWidth - 138 -10 - I_BORDER,
            I_BORDER + 35, 143, 26 ), 
                                new Rectangle( iPanelWidth - 138 -10 - 2 - 27 - I_BORDER, 
            I_BORDER + 35 + 28, 172, 37 ) );
                
        drawActionButtons( new Point( iPanelWidth - 167 -10 - I_BORDER, 
            iPanelHeight - 55 - I_BORDER ) );      
    }
    
    public void drawCustomLabelArea( Point poLocation ) { 
        int iXLocation, iYLocation;
        
        iXLocation = (int)poLocation.getX();
        iYLocation = (int)poLocation.getY();
        jlLabelIcon.setBounds( iXLocation, iYLocation, 27, 26 );
        jlLabelText.setBounds( iXLocation + 29, iYLocation, 143, 26 );
        //jlLabelIcon.addMouseListener( this );
        jlLabelText.addMouseListener( this );
        jpPanel.add( jlLabelText );
    }

    public void drawCustomCommentsArea( Rectangle rCommentsIcon, 
        Rectangle rCommentsLabel, Rectangle rCommentsText ) {

        jlCommentsIcon.setBounds( (int)rCommentsIcon.getX(), (int)rCommentsIcon.getY(),
            (int)rCommentsIcon.getWidth(), (int)rCommentsIcon.getHeight() );
        jlCommentsLabel.setBounds( (int)rCommentsLabel.getX(), (int)rCommentsLabel.getY(),
            (int)rCommentsLabel.getWidth(), (int)rCommentsLabel.getHeight() );
        jtaComments.setBounds( (int)rCommentsText.getX(), (int)rCommentsText.getY(),
            (int)rCommentsText.getWidth(), (int)rCommentsText.getHeight() );        
        jtaComments.setOpaque( true );
        
        jpPanel.add( jlCommentsIcon );
        jpPanel.add( jtaComments );
        jpPanel.add( jlCommentsLabel );
    }

    public void drawActionButtons( Point poLocation ) {
        int iXLocation, iYLocation;
        
        iXLocation = (int)poLocation.getX();
        iYLocation = (int)poLocation.getY();

        jbApply.setBounds( iXLocation, iYLocation, 55, 23 );
        jbClear.setBounds( iXLocation + 59, iYLocation, 55, 23 );
        jbHelp.setBounds( iXLocation + 118, iYLocation, 55, 23 );        
    }
    
    public int drawDataObjectArea( Point poLocation, Operand operData ) {            
        DataObjectArea doaDataObject;
        int iReturnID;
                
        doaDataObject = new DataObjectArea();
        doaDataObject.iXLocation = (int)poLocation.getX();
        doaDataObject.iYLocation = (int)poLocation.getY();
        
        doaDataObject.plBorder = new PaintableLabel( doaDataObject.iXLocation,
            doaDataObject.iYLocation, 144, 90 );
        doaDataObject.plBorder.setGraphicsType( PaintableLabel.I_SOLID_BORDER ); 
        doaDataObject.plBorder.addMouseListener( this );
        jpPanel.add( doaDataObject.plBorder );
        
        doaDataObject.jlNothing = new JLabel();
        jpPanel.add( doaDataObject.jlNothing );
        
        doaDataObject.jlDataObjectIcon = new JLabel();
        doaDataObject.jlDataObjectIcon.setBounds( doaDataObject.iXLocation + 56,/* was 53 */
            doaDataObject.iYLocation + 14, 33, 33 ); 
        //doaDataObject.jlDataObjectIcon.setOpaque( true );
        jpPanel.add( doaDataObject.jlDataObjectIcon );
        
        // add width of 20 to array text x-10 width+10
        doaDataObject.jlDataObjectText = new JLabel( "", SwingConstants.CENTER );
        doaDataObject.jlDataObjectText.setFont( foMidObjectFont );
        doaDataObject.jlDataObjectText.setBounds( doaDataObject.iXLocation + 26, /* was 29 */
            doaDataObject.iYLocation + 47, 92, 18 );     /* was 49, 82 */   
        doaDataObject.jlDataObjectText.setOpaque( true );
        jpPanel.add( doaDataObject.jlDataObjectText );

        doaDataObject.jlDataObjectArrayIndex = new JLabel( "", SwingConstants.CENTER );
        doaDataObject.jlDataObjectArrayIndex.setFont( foMidObjectFont );
        doaDataObject.jlDataObjectArrayIndex.setBounds( doaDataObject.iXLocation + 26, /* was 29 */
            doaDataObject.iYLocation + 63, 92, 20 );        /* was 68, 82 */
        doaDataObject.jlDataObjectArrayIndex.setOpaque( true );
        jpPanel.add( doaDataObject.jlDataObjectArrayIndex );
        
/*
                    System.out.println( "PTVPanel.drawDataObjectArea: " 
                        + "Label(X) = " + doaDataObject.jlDataObjectText.getX()
                        + "   (Y) = " + doaDataObject.jlDataObjectText.getY() 
                        + "   (H) = " + doaDataObject.jlDataObjectText.getHeight()
                        + "   (W) = " + doaDataObject.jlDataObjectText.getWidth() );
*/        
        
        doaDataObject.plNothing = new PaintableLabel( 0, 0, 0, 0 );
                        
        DataObjectRenderer.renderOperand( Opcode.I_OPCODE__UNDEFINED, new Operand(), 
            doaDataObject.jlDataObjectIcon, doaDataObject.jlDataObjectText,
            doaDataObject.jlDataObjectArrayIndex, doaDataObject.plNothing, 
            doaDataObject.iXLocation, doaDataObject.iYLocation, 
            DataObjectRenderer.B_PANEL, new JTextArea() );
        
        doaDataObject.jlDataObjectText.setBackground( jpPanel.getBackground() );
        doaDataObject.jlDataObjectArrayIndex.setBackground( jpPanel.getBackground() );
        
        alDataObjectAreas.add( iDataObjectCount, doaDataObject );
        iReturnID = iDataObjectCount;
        iDataObjectCount++;       
        System.out.println("Added DOA with ID of " + iReturnID + ".  Array size=" + alDataObjectAreas.size() );
        
        return iReturnID;
    }

    public void drawButtonPanel( Point poLocation, ArrayList alButtonGroup ) {
            
        // subclass will handle responding to button presses
        int iButtonNumber, iButtonXLocation, iButtonYLocation;
        JLabel jlButtonArea;
        JToggleButton jtbThisButton;
        
        bgInstructionGroup = new ButtonGroup();
        jlButtonArea = new JLabel();
        jlButtonArea.setOpaque( true );
        jlButtonArea.setBackground( Color.gray );
        jlButtonArea.setBorder( BorderFactory.createLineBorder( Color.black ) );
        //System.out.println( "jlButtonArea = " +jlButtonArea );
        
        if ( alButtonGroup.size() < 7 ) {
            jlButtonArea.setBounds( (int)poLocation.getX(), (int)poLocation.getY(),
                65, 82 );
        }
        else {
            jlButtonArea.setBounds( (int)poLocation.getX(), (int)poLocation.getY(),
                65, 109 );
        }
        
        iButtonNumber = 0;
        iButtonYLocation = -22;
        
        do {
            if ( ( iButtonNumber % 2 ) == 0 ) {
                iButtonXLocation = 5;
                iButtonYLocation += 25;
            }
            else {
                iButtonXLocation = 34;
            }
            jtbThisButton = (JToggleButton)alButtonGroup.get( iButtonNumber );            
            jtbThisButton.setBounds( iButtonXLocation, iButtonYLocation, 26, 23 );
            jtbThisButton.addActionListener( alButtonListener );
            //System.out.println( "jtbThisButton = " + jtbThisButton );
            jlButtonArea.add( jtbThisButton );
            bgInstructionGroup.add( jtbThisButton );
            
            iButtonNumber++;
        }
        while ( iButtonNumber < alButtonGroup.size() );

        bgInstructionGroup.add( jtbClearAll );  // used for clearing all buttons
        jpPanel.add( jlButtonArea );
    }
    
    public void addPaintableLabel( PaintableLabel plThisLabel ) {
        jpPanel.add( plThisLabel );
    }
            
    public void enableLeftAndRightOperands( boolean bFlag ) {
        bEnableOperands = bFlag;
        System.out.println( "PTV: Enable operands = " + bEnableOperands );
    }
    
    public void setExceptionOperand( int iID ) {
        iExceptionOperand = iID;
    }
    
    //------------------- Panel Methods -------------------\\
    public void setHelpDialog( PTVHelpDialog ptvhdHelp ) {
       ptvhdHelpDialog = ptvhdHelp;
    }
    
    public JLabel getLabel() {
        return jlLabelText;
    }
    
    public JTextArea getComments() {
        return jtaComments;
    }
    
    public JButton getApplyInstructionButton() {
        return jbApply;
    }
            
    public void addScrollbarsToCommentsArea() {
        JScrollPane jsp;
        Rectangle rBoundedArea;
        
        jpPanel.remove( jtaComments );
        rBoundedArea = jtaComments.getBounds();        
        jsp = new JScrollPane( jtaComments );  
        jsp.setBounds( rBoundedArea );
        jsp.setPreferredSize( new Dimension( (int)rBoundedArea.getWidth(),
            (int)rBoundedArea.getHeight() ) );
        jpPanel.add( jsp );
    }

    //---------------- Listener set methods --------------------\\
    public void setActionListener( ActionListener alThisListener ) {
        alButtonListener = alThisListener;
    }
    
    public void setDataObjectAreaListener( DataObjectAreaListener doalListener ) {
        doalDataObjectAreaListener = doalListener;
    }    
                    
    //------------------ DataObjectArea Methods -----------------------\\
    public Status setDataObjectAreaRestrictionList( int iID, BitSet bsRestrictions ) {
        String stMessage;
        DataObjectArea doaThisDataObjectArea;
        
        if ( ( iID >= 0 )  &&  ( iID < iDataObjectCount ) ) {
            doaThisDataObjectArea = (DataObjectArea)alDataObjectAreas.get( iID );
            doaThisDataObjectArea.bsAcutalRestrictionFlags = bsRestrictions;
            doaThisDataObjectArea.bsRestrictionFlags = bsRestrictions;
            System.out.println( "Restriction list received." );
            return new Status( I_OK );
        }
        else {
            stMessage = "There is no DataObject ID with the number " + iID;
            return new Status( I_ILLEGAL_ID_NUMBER, stMessage );
        }        
    }
        
    public BitSet getNewDataObjectAreaRestrictionList() {
        return new BitSet( AllPurposeMenu.I_NUMBER_OF_FLAGS );
    }
        
    public Object getOperandData( int iID ) {
        DataObjectArea doaThisDataObjectArea;
        String stMessage;
        
        if ( ( iID >= 0 )  &&  ( iID < iDataObjectCount ) ) {
            doaThisDataObjectArea = (DataObjectArea)alDataObjectAreas.get( iID );
            return doaThisDataObjectArea.operData;
        }
        else {
            stMessage = "There is no DataObject ID with the number " + iID;
            return new Status( I_ILLEGAL_ID_NUMBER, stMessage );
        }            
    }

    public void clearForm() {
        for ( int iDataObjectIndex = 0; iDataObjectIndex < iDataObjectCount; 
            iDataObjectIndex++ ) {
            updateDataObjectArea( iDataObjectIndex, new Operand() );
        }
        enableLeftAndRightOperands( true );

        // clears selected button in button panel
        if ( bgInstructionGroup != null ) {
            jtbClearAll.setSelected( true );
        }

        jtaComments.setText( "" );
        jlLabelText.setText( "" );
    }
                
//  May not be necessary since updateDataObjectArea calls DOAL.dataObjectAreaChanged
//            doalDataObjectAreaListener.dataObjectAreaChanged(
//                DataObjectAreaListener.I_ID_CHANGE_ALL, null );
    

    //------------- ActionListener Implementation ----------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objThisButtonPressed, objThisObject;
        JToggleButton jtbButton;
        DataObject doThisDataObject;
        DataObjectArea doaThisDataObjectArea;
        String stSelection, stObjectText;  
        Operand operThisOperand;
        boolean bValid;
        int iArrayIndex, iThisStructure, iThisType;
        NameAndDataObjectWrapper nadowCurrentObject;
        Status statInformation;
        
        objThisButtonPressed = aeEvent.getSource();
        stSelection = aeEvent.getActionCommand();
        operThisOperand = new Operand();
        doThisDataObject = new DataObject();
        
        System.out.println( "PTVPanel: ActionPerformed." );
        if ( objThisButtonPressed == jbClear ) {            
            System.out.println( "Clear button pressed." );
            clearForm();
        }
        else if ( objThisButtonPressed == jbHelp ) {
            System.out.println( "Help button pressed." );
            ptvhdHelpDialog.show();
        }
        // odd construct...
        // actually checks the available AllPurposeMenu commands in the Program object;
        // if a menu item is performed, function will return true, else false...
        // then this will make the conditional true and checks will be made for other
        // menu selections
        else {
        //else if ( progThisProgram.actionPerformedInProgram( stSelection ) == false ) {
            // check for menu items                                    
            System.out.println( "PTVPanel (actionPerf): ELSE" );
/*EDIT*/    if ( stSelection.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_CUT ) ) {
                if ( iDataObjectAreaClickedID != I_UNDEFINED ) {
                    doaThisDataObjectArea = (DataObjectArea)
                        alDataObjectAreas.get( iDataObjectAreaClickedID );
                    operThisOperand = doaThisDataObjectArea.operData;
                    apmPanelMenu.setOperandIntoClipboard( operThisOperand );
                    operThisOperand = new Operand();
                    updateDataObjectArea( iDataObjectAreaClickedID, operThisOperand );
                    alDataObjectAreas.set( iDataObjectAreaClickedID, 
                        doaThisDataObjectArea ); 
                    doalDataObjectAreaListener.dataObjectAreaChanged( 
                        iDataObjectAreaClickedID, operThisOperand );
                }
                else if ( bLabelAreaClicked == true ) {
                    jlLabelText.setText( "" );
                    System.out.println( "Label = " + jlLabelText.getText() );
                }
            }
            else if ( stSelection.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_COPY ) ) {
                if ( iDataObjectAreaClickedID != I_UNDEFINED ) {
                    doaThisDataObjectArea = (DataObjectArea)
                        alDataObjectAreas.get( iDataObjectAreaClickedID );
                    operThisOperand = doaThisDataObjectArea.operData;
                    apmPanelMenu.setOperandIntoClipboard( operThisOperand );
                }
            }
            else if ( stSelection.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_PASTE ) ) {
                if ( iDataObjectAreaClickedID != I_UNDEFINED ) {
                    operThisOperand = apmPanelMenu.getOperandFromClipboard();
                    doaThisDataObjectArea = (DataObjectArea)
                        alDataObjectAreas.get( iDataObjectAreaClickedID );

                    //////////
                    statInformation = validatePaste( operThisOperand, 
                        doaThisDataObjectArea );
                    //////////
                    
                    if ( statInformation.getStatusNumber() == I_OK ) {
                        updateDataObjectArea( iDataObjectAreaClickedID, operThisOperand );
                        alDataObjectAreas.set( iDataObjectAreaClickedID, 
                            doaThisDataObjectArea ); 
                        doalDataObjectAreaListener.dataObjectAreaChanged( 
                            iDataObjectAreaClickedID, operThisOperand );
                    }
                    else {
                        JOptionPane.showMessageDialog( this, 
                            statInformation.getStatusMessage(), 
                            ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
                    }
                }
            }
            else if ( stSelection.equals( 
                AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_CODE_INSERT ) ) {
                    codeThisCode.setEditingMode( Code.B_MODE_INSERT );
            }
            else if ( stSelection.equals( 
                AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_CODE_OVERWRITE ) ) {
                    codeThisCode.setEditingMode( Code.B_MODE_OVERWRITE );
            }

            // FILE...implemented in this conditional
/*OPERAND*/ else {  // operand check...this is the last possibility...otherwise ignore
                System.out.println( "PTVPanel (actPerf): SECOND ELSE" );
                System.out.println( "PTVPanel (actPerf): bgInstructionGroup = " + bgInstructionGroup
                    + "   iDataObjectAreaClick = " + iDataObjectAreaClickedID );
                
                if ( iDataObjectAreaClickedID != I_UNDEFINED ) {
                    System.out.println( "PTVPanel (actPerf): Inside last else" );
                        
                    doaThisDataObjectArea = (DataObjectArea)
                        alDataObjectAreas.get( iDataObjectAreaClickedID );                
                    bValid = true;

                    if ( stSelection.equals( AllPurposeMenu.ST_MENUITEM__USEROBJ_LITERAL ) ) {
                        // show the literal dialog                        
                        System.out.println( "LITERAL!" );
                        ldLiteralDialog.setRestrictionFlags( 
                            doaThisDataObjectArea.bsRestrictionFlags );
                        objThisObject = ldLiteralDialog.displayDialog();

                        if ( objThisObject instanceof DataObject ) {                            
                            doThisDataObject = (DataObject)objThisObject;
                            stObjectText = (String)doThisDataObject.getValue();
                            System.out.println( "PTV [Literal]: Return value of " + stObjectText );
                            nadowCurrentObject = new NameAndDataObjectWrapper( 
                                stObjectText, doThisDataObject );
                            operThisOperand.setOperandData( nadowCurrentObject );
                            doalDataObjectAreaListener.dataObjectAreaChanged( 
                                iDataObjectAreaClickedID, operThisOperand );                        
                        }
                        //  else, error appears visually
                        else {
                            bValid = false;
                        }
                    }
                    else {
                        // check system objects first                    
                        objThisObject = SystemDeclarations.getDeclaration( stSelection );

                        if ( objThisObject instanceof DataObject ) {
                            // name is a system object
                            doThisDataObject = (DataObject)objThisObject;
                            iThisStructure = doThisDataObject.getStructure();
                            iThisType = doThisDataObject.getType();
                            
                            nadowCurrentObject = new NameAndDataObjectWrapper( 
                                stSelection, doThisDataObject );
                            operThisOperand.setOperandData( nadowCurrentObject );
                            
                            // system objects will not be permitted to have 
                            // KEYBOARD and DISPLAY array elements isolated
                            // check for 1-d structure 

                            doalDataObjectAreaListener.dataObjectAreaChanged( 
                                iDataObjectAreaClickedID, operThisOperand );
                            bValid = true;
                        }
                        else if ( objThisObject instanceof Status ) {
                            // try user objects
                            objThisObject = deDeclarations.getDeclaration( stSelection );

                            if ( objThisObject instanceof DataObject ) {
                                doThisDataObject = (DataObject)objThisObject;
                                iThisStructure = doThisDataObject.getStructure();
                                iThisType = doThisDataObject.getType();
                                nadowCurrentObject = new NameAndDataObjectWrapper( 
                                    stSelection, doThisDataObject );
                                operThisOperand.setOperandData( nadowCurrentObject );
                                
                                // check for 1-d structure 
                                if ( doThisDataObject.getStructure() == 
                                       DataObject.I_STRUCTURE_1D_ARRAY ) {                            
                                    bValid = processArrayDataObject( operThisOperand,
                                        doaThisDataObjectArea.bsRestrictionFlags, iThisType );
                                    
                                }
                                else {  // non-array object
//                                    doaThisDataObjectArea.jlDataObjectText.setText( stSelection );
                                    doalDataObjectAreaListener.dataObjectAreaChanged( 
                                        iDataObjectAreaClickedID, operThisOperand );
                                    bValid = true;
                                }                    
                            }
                            else {  // error
                                bValid = false;                        
                            }
                        }
                        else {  // internal error 
                            bValid = false;
                        }    
                    }
                }
                else if ( bLabelAreaClicked == true ) {
                    bValid = false;
                    doaThisDataObjectArea = new DataObjectArea();
                    jlLabelText.setText( stSelection );     
                    System.out.println( "PTVPanel exiting...Label = " + jlLabelText.getText() );
                }
                else {
                    bValid = false;
                    doaThisDataObjectArea = new DataObjectArea();
                }
                
                if ( bValid == true ) {
                    System.out.println ( "UPDATING DOA IN PTV_PANEL" );
                    
                    doaThisDataObjectArea.jlDataObjectIcon.setIcon( 
                        doThisDataObject.getIcon() );
                    
                    if ( doThisDataObject.getRestriction()
                         == DataObject.I_RESTRICTION_VARIABLE ) {
                        doaThisDataObjectArea.plBorder.setGraphicsType( 
                            PaintableLabel.I_DOTTED_BORDER );
                    }
                    else {
                        doaThisDataObjectArea.plBorder.setGraphicsType( 
                            PaintableLabel.I_SOLID_BORDER );
                    }
/*                    
                    System.out.println( "PTVPanel.actionPerformed: " 
                        + "Label(X) = " + doaThisDataObjectArea.jlDataObjectText.getX()
                        + "   (Y) = " + doaThisDataObjectArea.jlDataObjectText.getY() 
                        + "   (H) = " + doaThisDataObjectArea.jlDataObjectText.getHeight()
                        + "   (W) = " + doaThisDataObjectArea.jlDataObjectText.getWidth() );
*/
                    operThisOperand.setOperandData( new NameAndDataObjectWrapper( 
                        stSelection, doThisDataObject ) );
                                        
                    // adjust restriction flags
                    doalDataObjectAreaListener.dataObjectAreaChanged( 
                        iDataObjectAreaClickedID, operThisOperand );
                    
                    // redraw operand area
                    updateDataObjectArea( iDataObjectAreaClickedID, operThisOperand );
                }                                    
            }
            // end of checking for menu items            
        }  
        // reset what was clicked
        iDataObjectAreaClickedID = I_UNDEFINED;  
        bLabelAreaClicked = false;
    }
    
    //--------------- MouseListener Implementation ---------------\\    
    public void mouseReleased( MouseEvent meEvent ) {
        int iCurrentXLocation, iCurrentYLocation, iDataObjectAreaID;
        Object objThisClickedObject;
        boolean bFound, bValidClick;
        DataObjectArea doaThisDataObjectArea;
        
        System.out.println( "MOUSE RELEASED" );        
        bValidClick = true;
        
        if ( meEvent.isPopupTrigger() ) {
            apmPanelMenu.updateCodeEditingMode();            
            objThisClickedObject = meEvent.getSource();

            System.out.println( "iDataObjectAreaClickedID = " + iDataObjectAreaClickedID );
            
            if ( objThisClickedObject == jpPanel ) {
                System.out.println( "PANEL AREA CLICKED" );
                apmPanelMenu.setMenuForEmptyPanelArea();
            }
            else if ( objThisClickedObject == jlLabelText ) {
                System.out.println( "LABEL TEXT CLICKED" );
                apmPanelMenu.setMenuForLabelArea();
                apmPanelMenu.updateDeclarationsMenus( 
                    AllPurposeMenu.B_USE_PARTIAL_LABEL_LIST );
                bLabelAreaClicked = true;
            }
            else {
                // need to see if any of the DOAs were clicked...this is not 
                // being checked correctly which is why DOAs must be clicked
                // twice in order to get the correct restriction list in the menu
                
                setDataObjectAreaClicked( objThisClickedObject );
                System.out.println( "DOA Clicked...iDataObjectAreaClickedID = " + iDataObjectAreaClickedID );                
                
                if ( iDataObjectAreaClickedID != I_UNDEFINED ) {
                    for ( int iIndex = 0; iIndex < iDataObjectCount; iIndex++ ) {
                        doaThisDataObjectArea = 
                            (DataObjectArea)alDataObjectAreas.get( iDataObjectAreaClickedID );

                        if ( objThisClickedObject == doaThisDataObjectArea.plBorder ) {                        
                            System.out.println( "FOUND ITEM!" );
                            apmPanelMenu.setDataObjectMenuRestricitions( 
                                doaThisDataObjectArea.bsAcutalRestrictionFlags );
                            
                            if ( ( bEnableOperands == false )  &&
                                 ( iExceptionOperand != iDataObjectAreaClickedID ) ) {
                                apmPanelMenu.setMenuForEmptyPanelArea();
                            }
                            else {
                                apmPanelMenu.setMenuForDataObjectArea( 
                                    AllPurposeMenu.I_INSTRUCTION_PANEL );
                                apmPanelMenu.updateDeclarationsMenus(
                                    doaThisDataObjectArea.bsAcutalRestrictionFlags.get( 
                                        AllPurposeMenu.I_FLAG_ALL_LABELS ) );
                            }
                        }
                    }
                }
                else {
                    bValidClick = false; 
                }
            }            
            

            // display menu
            if ( bValidClick == true ) {
                iCurrentXLocation = meEvent.getX();
                iCurrentYLocation = meEvent.getY();                
                apmPanelMenu.show( meEvent.getComponent(), iCurrentXLocation, 
                    iCurrentYLocation );
            }
            //  else no menu displayed
        }
    }

    // unused methods
    public void mouseEntered( MouseEvent meEvent ) {}
    public void mouseExited( MouseEvent meEvent ) {}
    public void mouseClicked( MouseEvent meEvent ) {}
    public void mousePressed( MouseEvent meEvent ) {}
    
    /////////////////PROTECTED AND PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\\\\\\
    protected void updateDataObjectArea( int iID, Operand operThisData ) {
            
        DataObjectArea doaDataObject;
        Color coPanelBackground;
        int iRestriction;
        
        System.out.println( "Update DOA: ID=" + iID + "    Array Size = " + alDataObjectAreas.size() );
        doaDataObject = (DataObjectArea)alDataObjectAreas.get( iID );
        System.out.println( "Update DOA: Retrieved DOA = " + doaDataObject );

        doaDataObject.operData = operThisData;
        
/*
        System.out.println( "PTVPanel.updateDataObjectArea: " 
                        + "Label(X) = " + doaDataObject.jlDataObjectText.getX()
                        + "   (Y) = " + doaDataObject.jlDataObjectText.getY() 
                        + "   (H) = " + doaDataObject.jlDataObjectText.getHeight()
                        + "   (W) = " + doaDataObject.jlDataObjectText.getWidth() );
*/
        DataObjectRenderer.renderOperand( Opcode.I_OPCODE__UNDEFINED, 
            doaDataObject.operData, doaDataObject.jlDataObjectIcon, 
            doaDataObject.jlDataObjectText, doaDataObject.jlDataObjectArrayIndex,
            doaDataObject.plNothing, doaDataObject.iXLocation, 
            doaDataObject.iYLocation, DataObjectRenderer.B_PANEL, new JTextArea() );

        if ( operThisData.getOperandType() == DataObject.I_UNDEFINED ) {
            System.out.println( "Undefined operand." );
            coPanelBackground = jpPanel.getBackground();
            doaDataObject.plBorder.setGraphicsType( PaintableLabel.I_SOLID_BORDER );
            doaDataObject.jlDataObjectText.setBackground( coPanelBackground );
            doaDataObject.jlDataObjectText.setBorder( null ); 
            
            doaDataObject.bsRestrictionFlags.clear( AllPurposeMenu.I_FLAG_OBJECT );
            doaDataObject.bsAcutalRestrictionFlags.clear( AllPurposeMenu.I_FLAG_OBJECT );
        }
        else {
            doaDataObject.bsRestrictionFlags.set( AllPurposeMenu.I_FLAG_OBJECT );
            doaDataObject.bsAcutalRestrictionFlags.set( AllPurposeMenu.I_FLAG_OBJECT );
        }            

        iRestriction = operThisData.getOperandRestriction();
        
        if ( ( iRestriction == DataObject.I_RESTRICTION_CONSTANT )  || 
             ( iRestriction == DataObject.I_UNDEFINED ) ) {
            doaDataObject.plBorder.setGraphicsType( PaintableLabel.I_SOLID_BORDER );            
        }
        else {
            doaDataObject.plBorder.setGraphicsType( PaintableLabel.I_DOTTED_BORDER );
        }
        
        if ( operThisData.getOperandRestriction() == DataObject.I_RESTRICTION_LITERAL ) {
            doaDataObject.plBorder.setToolTipText( doaDataObject.jlDataObjectText.getText() );
        }
        else {
            doaDataObject.plBorder.setToolTipText( null );
        }
        
        System.out.println( "Update DOA: Changed DOA = " + doaDataObject );
        alDataObjectAreas.set( iID, doaDataObject );
        doalDataObjectAreaListener.dataObjectAreaChanged( iID, doaDataObject.operData );
    }
            
    private void initComponents() {         
        jlLabelIcon = new JLabel( iiLabel );
        jlLabelIcon.setBorder( BorderFactory.createLineBorder( Color.black, 1 ) );
        jlLabelIcon.addMouseListener( this );
        jpPanel.add( jlLabelIcon );
        
        jlLabelText = new JLabel( "", SwingConstants.CENTER );
        jlLabelText.setFont( foMidObjectFont );
        jlLabelText.setForeground( Color.white );
        jlLabelText.setBackground( colorDarkBlue );
        jlLabelText.setOpaque( true );
        jlLabelText.addMouseListener( this );
        jpPanel.add( jlLabelText );
                
        jlCommentsIcon = new JLabel( iiComments );
        jlCommentsIcon.setBorder( BorderFactory.createLineBorder( Color.black, 1 ) );        
        jpPanel.add( jlCommentsIcon );

        jtaComments = new JTextArea();
        jtaComments.setForeground( Color.white );
        jtaComments.setBackground( colorDarkBlue );
        jtaComments.setCaretColor( Color.white );
        jtaComments.setRows( 2 );
        jtaComments.setLineWrap( true );
        jtaComments.setWrapStyleWord( true );
        jtaComments.setFont( foCommentsFont );
        jpPanel.add( jtaComments ); 
        
        jlCommentsLabel = new JLabel( "Comments", SwingConstants.CENTER );
        jlCommentsLabel.setBackground( Color.white );
        jlCommentsLabel.setForeground( Color.black );
        jlCommentsLabel.setOpaque( true );
        jlCommentsLabel.setFont( foBiggerObjectFont );
        jlCommentsLabel.setBorder( BorderFactory.createLineBorder( Color.black ) );
        jpPanel.add( jlCommentsLabel );
        
        // subclass handles action response
        jbApply = new JButton( (Icon)iiApplyIcon );
        jbApply.setPressedIcon( (Icon)iiInverseApplyIcon );
        jpPanel.add( jbApply );
        jbApply.addActionListener( alButtonListener );
        
        // PTVPanel handles action response
        jbClear = new JButton( (Icon)iiClearIcon );
        jbClear.setPressedIcon( (Icon)iiInverseClearIcon );
        jpPanel.add( jbClear );
        jbClear.addActionListener( this );

        // PTVPanel handles action response
        jbHelp = new JButton( (Icon)iiHelpIcon );
        jbHelp.setPressedIcon( (Icon)iiInverseHelpIcon );
        jpPanel.add( jbHelp );
        jbHelp.addActionListener( this );           
    }
    
    private void setDataObjectAreaClicked( Object objClickedObject ) {
        DataObjectArea doaThisDataObjectArea;
        PaintableLabel plDataObjectAreaBorder;
        Object objTemp;
        int iIndex;
        boolean bFound;
        
        bFound = false;
        System.out.println( "(DOAClicked): obj = " + objClickedObject );
        for ( iIndex = 0; 
              ( iIndex < iDataObjectCount )  &&  ( bFound == false ); iIndex++ ) {

            objTemp = alDataObjectAreas.get( iIndex );
            System.out.println( "Found object of " + objTemp.getClass().getName()
                + " at index " + iIndex );
            doaThisDataObjectArea = (DataObjectArea)alDataObjectAreas.get( iIndex );
            plDataObjectAreaBorder = doaThisDataObjectArea.plBorder;
            
            if ( objClickedObject == plDataObjectAreaBorder ) {
                bFound = true;
                System.out.println( "FOUND AT INDEX = " + iIndex );
                iDataObjectAreaClickedID = iIndex;
                //apmPanelMenu.setMenuForDataObjectArea( 
                //    AllPurposeMenu.I_INSTRUCTION_PANEL );
                
            }
        }
        
        if ( bFound == false ) {
            iDataObjectAreaClickedID = I_UNDEFINED;
        }
    }
    
    private boolean processArrayDataObject( Operand operAnOperand,
        BitSet bsRestrictionFlags, int iType ) {
            
        int iChoice, iArrayIndex;
        boolean bUseEntireArray, bValid;
        Object objThisObject;
        String stObjectText;
        DataObject doArrayObject;
        Status statInformation;
/*
*/
        // either choose array element or entire array
        if ( ( iType == DataObject.I_TYPE_CHARACTER )  &&
             ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHARACTER_ARRAY )  == true )  &&
             ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT ) == true ) ) {
            iChoice = JOptionPane.showConfirmDialog( jfParentFrame, 
                "Select an array element?", ST_APPLICATION_NAME, 
                JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE );
            
            if ( iChoice == I_OPTION_YES ) {
                bUseEntireArray = false;
            }
            else {
                bUseEntireArray = true;
            }
        }
        else if ( ( iType != DataObject.I_TYPE_CHARACTER )  &&
                  ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT ) 
                      == true )  ||
                    ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_INT_SINGLE ) 
                      == true ) ) )  {
            bUseEntireArray = false;
        }
        else if ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT ) == true ) {
            bUseEntireArray = false;
        }
        else {
            bUseEntireArray = true;
        }
        
        if ( bUseEntireArray == false ) {
            objThisObject = new ArrayIndexDialog( jfParentFrame,
                operAnOperand, sdtmDataObjects ).displayDialog();

            if ( objThisObject instanceof Integer ) {
                // numerical array index
                iArrayIndex = ((Integer)objThisObject).intValue();
                operAnOperand.setArrayElementIndex( iArrayIndex );
                bValid = true;
            }
            else if ( objThisObject instanceof String ) {
                // DataObject name as array index
                stObjectText = (String)objThisObject;
                objThisObject = deDeclarations.getDeclaration( stObjectText );
                
                // try user objects
                if ( objThisObject instanceof DataObject ) {
                    doArrayObject = (DataObject)objThisObject;
                    statInformation = operAnOperand.setArrayElementDataObject( 
                        stObjectText, doArrayObject.getType(), 
                        doArrayObject.getStructure() );
                    
                    if ( statInformation.getStatusNumber() == Operand.I_OK ) {
                        bValid = true;
                    }
                    else {
                        bValid = false;
                    }
                }
                // try system objects
                else if ( objThisObject instanceof Status ) {
                    objThisObject = SystemDeclarations.getDeclaration( stObjectText );

                    if ( objThisObject instanceof DataObject ) {
                        doArrayObject = (DataObject)objThisObject;
                        statInformation = operAnOperand.setArrayElementDataObject( 
                            stObjectText, doArrayObject.getType(), 
                            doArrayObject.getStructure() );

                        if ( statInformation.getStatusNumber() == Operand.I_OK ) {
                            bValid = true;
                        }
                        else {
                            bValid = false;
                        }
                    }
                    else {
                        bValid = false;
                    }
                }
                else {
                    bValid = false;
                }
            }
            else {  // illegal array index                                
                bValid = false;
            }            
        }
        else {  // allow array usage only if flag set to character array AND
                // object is character array...if enter here, structure is 1D-array
            if ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHARACTER_ARRAY ) 
                        == true )  &&
                 ( iType == DataObject.I_TYPE_CHARACTER ) ) {
                bValid = true;
                System.out.println( "bvalid is TRUE" );
            }
            else {
                bValid = false;
                System.out.println( "bvalid is ***FALSE***" );
            }
        }
        return bValid;
    }
    
    private Status validatePaste( Operand operThisOperand, 
        DataObjectArea doaThisDataObjectArea ) {
     
        int iType, iStructure, iRestriction, iIndexSetting;
        boolean bValid;
        BitSet bsRestrictionFlags;
        Status statInformation;
        String stMessage, stType, stStructure, stRestriction, stName;
        Object objThisObject;
        
        iType = operThisOperand.getOperandType();
        iStructure = operThisOperand.getOperandStructure();
        iRestriction = operThisOperand.getOperandRestriction();
        bsRestrictionFlags = doaThisDataObjectArea.bsRestrictionFlags;
        bValid = false;
        
        // see if matches with restriction flags
        if ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CONSTANT ) == true )  &&
             ( iRestriction == DataObject.I_RESTRICTION_CONSTANT ) ) {
            bValid = true;
        }
        else if ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_VARIABLE ) == true )  &&
                  ( iRestriction == DataObject.I_RESTRICTION_VARIABLE ) ) {
            bValid = true;
        }
        else if ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_LITERAL ) == true )  &&
                  ( iRestriction == DataObject.I_RESTRICTION_LITERAL ) == true ) {
            bValid = true;
        }
                
        if ( bValid == true ) {
            // only single character and integer array elements are supported            
            if ( ( iType == DataObject.I_TYPE_INTEGER )  &&
                 ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_INT_ARRAY_ELEMENT ) 
                       == true )  ||
                   ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_INT_SINGLE ) 
                       == true ) ) ) {
                bValid = true;
            }
            else if ( ( iType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER )  &&
                      ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_INT_SINGLE ) 
                          == true ) ) {
                bValid = true;
            }            
            else if ( ( ( iType == DataObject.I_TYPE_CHARACTER )  &&
                        ( iStructure == DataObject.I_STRUCTURE_SINGLE_VALUE ) )  &&
                      ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHARACTER_SINGLE ) 
                            == true )  ||
                        ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT ) 
                            == true ) ) ) {
                bValid = true;
            }
            else if ( ( ( iType == DataObject.I_TYPE_CHARACTER )  &&
                        ( iStructure == DataObject.I_STRUCTURE_1D_ARRAY ) )  &&
                      ( ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHARACTER_ARRAY ) 
                            == true )  ||
                        ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_CHAR_ARRAY_ELEMENT ) 
                            == true ) ) ) {
                bValid = true;
            }
            else if ( ( iType == DataObject.I_SYSTEM_TYPE_KEYBOARD )  &&
                      ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_KEYBOARD_INPUT ) 
                          == true ) ) {
                bValid = true;
            }
            else if ( ( iType == DataObject.I_SYSTEM_TYPE_DISPLAY )  &&
                      ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_DISPLAY_OUTPUT ) 
                          == true ) ) {
                bValid = true;
            }
            else if ( ( iType == DataObject.I_TYPE_LABEL )  &&
                      ( bsRestrictionFlags.get( AllPurposeMenu.I_FLAG_LABEL ) 
                          == true ) ) {
                bValid = true;
            }
            else {
                bValid = false;
            }
        }
        
        if ( bValid == true ) {
            statInformation = new Status( I_OK );
        }
        else {
            stName = operThisOperand.getOperandName();
            
            stRestriction = DataObjectPropertyTextView.getRestrictionName( 
                operThisOperand.getOperandRestriction() );
            if ( stRestriction.equals( "None" ) ) {
                stRestriction = "";
            }
            else {
                stRestriction = stRestriction + ",";
            }
                        
            stType = DataObjectPropertyTextView.getTypeName( 
                operThisOperand.getOperandType() );
            if ( stType.equals( "None" ) ) {
                stType = "";
            }            
            else {
                stType = stType + ",";
            }

            stStructure = DataObjectPropertyTextView.getStructureName( 
                operThisOperand.getOperandStructure() );
            if ( stStructure.equals( "None" ) ) {
                stStructure = "";
            }
            else if ( stStructure.equals( "1-D Array" ) ) {
                iIndexSetting = operThisOperand.getArrayElementIndexSetting();
                if ( iIndexSetting != Operand.I_UNDEFINED ) {
                    stStructure = "Array Element";

                    if ( iIndexSetting == Operand.I_ARRAY_INDEX_NUMBER ) {
                        stName = stName + '[' + Integer.toString( 
                            operThisOperand.getArrayElementIndex() ) + ']';
                    }
                    else if ( ( iIndexSetting == Operand.I_ARRAY_INDEX_DATA_OBJECT )  ||
                              ( iIndexSetting == Operand.I_ARRAY_INDEX_REGISTER ) ) {
                        stName = stName + '[' + 
                            operThisOperand.getArrayElementDataObject() + ']';
                    }
                }
                else {
                    stStructure = "Array";
                }
            }

            if ( ( iType == DataObject.I_SYSTEM_TYPE_DISPLAY )  ||
                 ( iType == DataObject.I_SYSTEM_TYPE_KEYBOARD ) ) {
                stType = "data object";
                stRestriction = "";
                stStructure = "";
            }
            else if ( iRestriction == DataObject.I_RESTRICTION_LITERAL ) {
                objThisObject = operThisOperand.getOperandValue();
                
                if ( objThisObject instanceof String ) {
                    stName = (String)objThisObject;

                    if ( stName.length() > 18 ) {
                        stName = '"' + stName.substring( 0, 18 ) + "..." + '"';
                    }
                    else {
                        stName = '"' + stName + '"';
                    }
                }
            }
            else if ( ( iType == DataObject.I_TYPE_LABEL )  ||
                      ( iType == DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER ) ) {                        
                stType = stType.substring( 0, stType.length() - 1 );
                stRestriction = "";
                stStructure = "";
            }
            
            stMessage = "The " + stRestriction + " " + stType + " " + stStructure
                + " named " + stName + " cannot be pasted here.";
            statInformation = new Status( I_ILLEGAL_PASTE, stMessage );
        }
        
        return statInformation;
    }
        
    // instance variables
    protected JFrame jfParentFrame;
    protected JLabel jlLabelText;
    protected JTextArea jtaComments;
    protected ButtonGroup bgInstructionGroup;
    protected VisualCodeTable vctCodeTable;
    protected Code codeThisCode;
    protected Declarations deDeclarations;
    protected JButton jbClear;
    
    private JLabel jlCommentsIcon, jlLabelIcon, jlCommentsLabel;
    private Program progThisProgram;
    private ActionListener alButtonListener;
    private AllPurposeMenu apmPanelMenu;
    private JButton jbApply, jbHelp;
    private JToggleButton jtbClearAll;
    private int iPanelWidth, iPanelHeight, iDataObjectCount, iDataObjectAreaClickedID,
        iExceptionOperand;
    private ArrayList alDataObjectAreas;
    private PTVHelpDialog ptvhdHelpDialog;
    private JPanel jpPanel;
    private DataObjectAreaListener doalDataObjectAreaListener;
    private boolean bLabelAreaClicked, bEnableOperands;
    private SortableDeclarationsTableModel sdtmDataObjects;
    private LiteralDialog ldLiteralDialog;
    
        // class variables
        public static Color colorDarkBlue, colorBrightWhite;
    
        private static Font foButtonFont, foObjectFont, foCommentsFont, 
            foBiggerObjectFont, foMidObjectFont;        
        private static ImageIcon iiApplyIcon, iiClearIcon, iiHelpIcon,
            iiInverseApplyIcon, iiInverseClearIcon, iiInverseHelpIcon, iiComments,
            iiLabel, iiUpTriangle, iiRightTriangle;
        private static Operand operNothing;
        
        // class constants        
        public static final int I_UP_TRIANGLE = 1;
        public static final int I_RIGHT_TRIANGLE = 2;

        private final static int I_OPTION_YES = 0;
        private final static int I_OPTION_NO = 1;        
        
        private static final boolean B_NON_MODAL = false;        
        private static final int I_BORDER = 5;        // was 15
        private static final int I_BUTTON_NOT_PRESSED_FLAG = 0;

        protected static final int I_UNDEFINED = -888888;        
        protected static final String ST_APPLICATION_NAME = "Panels :: Tools :: Views";
        protected static final String ST_HOME_DIRECTORY = "";
            /*"D:\\forte4j\\Development\\panelsAndTools\\";*/
        
        // error values
        public static final int I_OK = 0;
        public static final int I_ILLEGAL_ID_NUMBER = -1;
        public static final int I_ILLEGAL_TRIANGLE_ID = -2;
        public static final int I_DUPLICATE_LABEL = -3;
        
        private static final int I_ILLEGAL_PASTE = -4;
        
        static {
            foButtonFont = new Font( "SansSerif", Font.BOLD, 12 );
            foObjectFont = new Font( "Monospaced", Font.BOLD, 12 );
            foCommentsFont = new Font( "SansSerif", Font.BOLD, 12 );
            foBiggerObjectFont = new Font( "SansSerif", Font.BOLD, 16 );
            foMidObjectFont = new Font( "Monospaced", Font.BOLD, 15 );

            colorDarkBlue = new Color( 0, 0, 128 );
            colorBrightWhite = new Color( 255, 255, 255 );

            iiLabel = new ImageIcon( ST_HOME_DIRECTORY + "label-icon.jpg" );
            iiComments = new ImageIcon( ST_HOME_DIRECTORY + "section_comments-icon.jpg" );
            
            iiApplyIcon = new ImageIcon( ST_HOME_DIRECTORY + "apply-icon.jpg" );
            iiClearIcon = new ImageIcon( ST_HOME_DIRECTORY + "clear-icon.jpg" );
            iiHelpIcon = new ImageIcon( ST_HOME_DIRECTORY + "help-icon.jpg" );     
            iiInverseApplyIcon = new ImageIcon( ST_HOME_DIRECTORY + "inv-apply-icon.jpg" );
            iiInverseClearIcon = new ImageIcon( ST_HOME_DIRECTORY + "inv-clear-icon.jpg" );
            iiInverseHelpIcon = new ImageIcon( ST_HOME_DIRECTORY + "inv-help-icon.jpg" );
            
            iiUpTriangle = new ImageIcon( ST_HOME_DIRECTORY + "up-arrow.jpg" );
            iiRightTriangle= new ImageIcon( ST_HOME_DIRECTORY + "right-arrow.jpg" );
            
            operNothing = new Operand();            
        }
}