/*
 * ProgramNameDialog.java
 *
 * Created on May 24, 2002, 5:19 PM
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author  _
 * @version 
 */
public class ProgramNameDialog extends JDialog implements ActionListener {

    public ProgramNameDialog( JFrame jfParentFrame, String stTitle, 
        ProgramListener plThisProgramListener ) {
            
        super( jfParentFrame, stTitle, B_MODAL );
        
        Container cPane;
        GridBagLayout gblLayoutGrid;
        
        jfParentFrame.setTitle( "LIVE...from Program Name Dialog!" );
        plProgramListener = plThisProgramListener;
        gblLayoutGrid = new GridBagLayout();
        cPane = this.getContentPane();
        jpDialogPanel = new JPanel();       
        cPane.add( jpDialogPanel );
        jpDialogPanel.setLayout( gblLayoutGrid );
        
        jbOK = new JButton( "OK" );
        jbOK.addActionListener( this );
        
        jbCancel = new JButton( "Cancel" );
        jbCancel.addActionListener( this );
        
        jlProgramNameLabel = new JLabel( "Program Name" );
        jlProgramNameLabel.setFont( fontLabel );
        jlProgramNameLabel.setForeground( Color.black );
        
        jtfProgramNameText = new JTextField( 8 );
        jtfProgramNameText.setFont( fontField );
        
        this.setSize( 234, 146 );
        createPanel();
        
        this.addWindowListener( new WindowAdapter() {
            public void windowClosing( WindowEvent weEvent ) {
                hide();
                dispose();
            }
        } );
        
    }
    
    public Status showDialog() {
        this.show();
        return statReturnObject;
    }
    
    //------------------ ActionListener Implementation -----------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objEventSource;
        String stProgramName;
        Status statInformation;
        
        objEventSource = aeEvent.getSource();
        
        if ( objEventSource == jbOK ) {
            stProgramName = jtfProgramNameText.getText();
            statInformation = RecordObject.validateObjectName( stProgramName );
            
            if ( statInformation.getStatusNumber() == RecordObject.I_OK ) {
                plProgramListener.programNameChanged( stProgramName );
                statReturnObject = new Status( Program.I_OK );

                this.hide();
                this.dispose();                
            }
            else {
                JOptionPane.showMessageDialog( this, 
                    statInformation.getStatusMessage(),
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
            }                
        }
        else if ( objEventSource == jbCancel ) {
            statReturnObject = 
                new Status( I_CANCELLED_OPERATION, "Cancelled operation." );
            this.hide();
            this.dispose();
        }
    }
        
    /////////////////// PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\\\\
    private void createPanel() {
        addComponentToPanel( 0, 0, 2, 1, jlProgramNameLabel );
        addComponentToPanel( 2, 0, 2, 1, new JLabel( "     " ) );
        addComponentToPanel( 0, 1, 4, 1, jtfProgramNameText );
        addComponentToPanel( 0, 2, 4, 1, new JLabel( "     " ) );
        addComponentToPanel( 0, 3, 1, 1, new JLabel( "     " ) );
        addComponentToPanel( 1, 3, 1, 1, jbOK );
        addComponentToPanel( 2, 3, 1, 1, jbCancel );
        addComponentToPanel( 3, 3, 1, 1, new JLabel( "     " ) );
    }
    
    private void addComponentToPanel( int iGridXPos, int iGridYPos, int iGridWidth,
                                      int iGridHeight, Component coComponent ) {
        
        GridBagConstraints gbcLayoutConstraints;

        gbcLayoutConstraints = new GridBagConstraints();
        gbcLayoutConstraints.weightx = 100;
        gbcLayoutConstraints.weighty = 100;
        gbcLayoutConstraints.gridx = iGridXPos;
        gbcLayoutConstraints.gridy = iGridYPos;
        gbcLayoutConstraints.gridwidth = iGridWidth;
        gbcLayoutConstraints.gridheight = iGridHeight;
        gbcLayoutConstraints.anchor = GridBagConstraints.SOUTHWEST;
        gbcLayoutConstraints.insets = new Insets( 2, 5, 2, 3 );
        gbcLayoutConstraints.fill =  GridBagConstraints.HORIZONTAL;
        jpDialogPanel.add( coComponent, gbcLayoutConstraints );
    }
    
    // instance variables
    private String stProgramName;
    private JButton jbOK, jbCancel;
    private JLabel jlProgramNameLabel;
    private JTextField jtfProgramNameText;
    private JPanel jpDialogPanel;
    private Status statReturnObject;
    private ProgramListener plProgramListener;    
    
    // class constants
    public static final int I_CANCELLED_OPERATION = -1;    
    private static final boolean B_MODAL = true;
    private static final String ST_APPLICATION_NAME = "Panels :: Tools :: Views";
    private static final Font fontLabel = new Font( "SansSerif", Font.BOLD, 14 );
    private static final Font fontField = new Font( "monospaced", Font.PLAIN, 14 );    
}