/*
 * RecordObjectTable.java
 *
 * Created on March 5, 2002, 5:41 PM
 */

//package panelsAndTools;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;


/**
 *
 * @author  _
 * @version 
 */


public class RecordObjectTable extends JTable
    implements ListSelectionListener {
        
    public RecordObjectTable( Declarations deDataObjects,
        SortableDeclarationsTableModel sdtmThisModel ) {                                
        
        jthTableHeader = new JTableHeader();
        sdtmTableData = sdtmThisModel;
        //sdtmTableData = new SortableDeclarationsTableModel();        
        sdtmTableData.setDeclarationsModel( deDataObjects );

        sdtmTableData.setModelNumber( Declarations.I_ALL_OBJECTS );
        sdtmTableData.setColumnToTrack( DeclarationsTableModel.I_COLUMN_ICON );
                        
        setupObjectTable();        
        addListeners();        
    }
    
    public MouseAdapter getMouseListener() {
        return maMouseAdapter;
    }
    
    /*public ListSelectionListener getListSelectionListener() {
        return lslListener;
    }*/
    
    public int getCurrentTableRow() {
        return iCurrentTableRow;
    }
    
    /*public Object getDataObjectAtCurrentTableRow() {
        return objCurrentDataObject;
    }*/
    
    public void setRecordTableListener( RecordObjectTableListener rotlFormListener ) {
        rotlTableListener = rotlFormListener;
    }
    
    public ListSelectionModel getTableSelectionModel() {
        return lsmListModel;
    }
                    
    //////////////////// INTERNAL FUNCTIONS \\\\\\\\\\\\\\\\\\\\\    
    private void setupObjectTable() {        
        JScrollPane jspTableScrollPane;
        Dimension diTableSize;
        TableColumn tcTableColumn;        
//154
        diTableSize = new Dimension( 548, 94 );
        
        setModel( sdtmTableData );
        jthTableHeader = getTableHeader();
        setPreferredScrollableViewportSize( diTableSize );
        jspTableScrollPane = new JScrollPane( this );
        
        setRowMargin( 3 );
        setRowHeight( 16 );
        
        setFont( new Font( "monospaced", Font.PLAIN, 14 ) );
        setColumnSelectionAllowed( false );
        setRowSelectionAllowed( true );
        setSelectionMode( ListSelectionModel.SINGLE_SELECTION );

        jthTableHeader.setFont( new Font( "SansSerif", Font.BOLD, 14 ) );
        
        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_ICON );
        tcTableColumn.setPreferredWidth( 55 );

        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_NAME );
        tcTableColumn.setPreferredWidth( 77 );
        
        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_TYPE );
        tcTableColumn.setPreferredWidth( 96 );
        
        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_RESTRICTION );
        tcTableColumn.setPreferredWidth( 97 );
        
        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_STRUCTURE );
        tcTableColumn.setPreferredWidth( 157 );
        
        tcTableColumn = 
            getColumnModel().getColumn( DeclarationsTableModel.I_COLUMN_SIZE );
        tcTableColumn.setPreferredWidth( 50 );
        
    }
    
    private void addListeners() {        
        KeyStroke ks;        
        
        // Adapted from code described in the Java Tutorial 12-19-2001
        // for the lesson "How to Use Tables"
        
        maMouseAdapter = new MouseAdapter() {
            public void mouseClicked( MouseEvent meEvent ) {
                int iColumnInView, iTableXCoordinate, iActualColumn;
                TableColumnModel tcmModel;
                Object objEventObject;
                                
                if ( meEvent.getSource() == jthTableHeader ) { 
                    System.out.println( "Pressed TABLE HEADER." );
                    tcmModel = getColumnModel();
                    iTableXCoordinate = meEvent.getX();
                    iColumnInView = tcmModel.getColumnIndexAtX( iTableXCoordinate ); 
                    iActualColumn = convertColumnIndexToModel( iColumnInView );
                    sdtmTableData.setColumnToTrack( iActualColumn );                                                   
                    System.out.println( "Current row = "+iCurrentTableRow);
                }                    
            }   
        };

        jthTableHeader.addMouseListener( maMouseAdapter );   
        addMouseListener( maMouseAdapter );

        
        lslListener = new ListSelectionListener() {
            public void valueChanged( ListSelectionEvent lseEvent ) {
                ListSelectionModel lsmCurrentListModel;

//                System.out.println( "VALUE CHANGED!!!!" );
                lsmCurrentListModel = 
                    (ListSelectionModel)lseEvent.getSource();
                iCurrentTableRow = lsmCurrentListModel.getMinSelectionIndex();
                objCurrentDataObject = 
                    sdtmTableData.getDataFromRow( iCurrentTableRow );
                rotlTableListener.updatedDataObjectAtCurrentRow( objCurrentDataObject );
            }
        };

        lsmListModel = getSelectionModel();
        lsmListModel.addListSelectionListener( lslListener );                           
        
        // end of adaption        
    }
    
    public void printTableCells() {
        int iColumn, iRow;
        Object objThisObject;
        String stThisString;
        
        for ( iRow = 0; iRow < sdtmTableData.getRowCount(); iRow++ ) {
            for ( iColumn = 0; iColumn < sdtmTableData.getColumnCount(); iColumn++ ) {
                objThisObject = sdtmTableData.getValueAt( iRow, iColumn );
                
                System.out.print( "row = " + iRow + ", column = " + iColumn + ": " );
                if ( objThisObject instanceof String ) {
                    stThisString = (String)objThisObject;
                    System.out.println( stThisString );
                }
                else {
                    System.out.println( objThisObject );
                }
            }
        }
    }
    
    
    // instance variables
    private SortableDeclarationsTableModel sdtmTableData;
    private MouseAdapter maMouseAdapter;
    private KeyAdapter kaListener;
    private ActionListener alListener;
    private ListSelectionListener lslListener;
    private ListSelectionModel lsmListModel;    
    private int iCurrentTableRow;
    private JTableHeader jthTableHeader;
    private Object objCurrentDataObject;
    private RecordObjectTableListener rotlTableListener;    
}