/*
 * SectionCommentsPanel.java
 *
 * Created on June 13, 2002, 11:42 AM
 */

import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.awt.*;

/**
 *
 * @author  _
 * @version 
 */
public class SectionCommentsPanel extends PTVPanel implements ActionListener {

    public SectionCommentsPanel( JFrame jfParentFrame, String stDialogTitle, 
        Dimension diPanelSize, Program progThisProgram, 
        SortableDeclarationsTableModel sdtmModel ) {

        super( jfParentFrame, stDialogTitle, diPanelSize, progThisProgram, sdtmModel );

        super.setActionListener( this );
                        
        createObjects();
        drawPanel();
    }
    
    public void setInstruction( Instruction instInstruction ) {
        instThisInstruction = (Instruction)instInstruction.clone();        

        // set up the panel appropriately
        jlLabelText.setText( instThisInstruction.getLabel().getName() );
        jtaComments.setText( instThisInstruction.getComments() );
    }
    
    //---------------ActionListener Implementation------------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        Object objActionSource, objTemp;
        int iCurrentLine;
        String stTemp;
        DataObject doThisDataObject;
        Status statInformation;
                
        objActionSource = aeEvent.getSource();
        
        if ( objActionSource == jbApply ) {
            // since the Instruction parts were likely defined legally, it is
            // not necessary to do error checking...unless in "debugging mode"            
            System.out.println( "SCP actionPerformed: OPCODE = " + instThisInstruction.getOpcode().getOpcode() );        
            stTemp = this.getLabel().getText();

            if ( stTemp.equals( "" ) == false ) {                
                objTemp = deDeclarations.getDeclaration( stTemp );
                
                if ( objTemp instanceof DataObject ) {                    
                    doThisDataObject = (DataObject)objTemp;
                    instThisInstruction.setLabel( 
                        new NameAndDataObjectWrapper( stTemp, doThisDataObject ) );
                }
            }
            else {
                System.out.println( "NO LABEL" );
            }
            //  else, ignore

            // this is the key section here...comments appear in the comments
            // section and not in an operand
            stTemp = this.getComments().getText();

            if ( stTemp.equals( "" ) == false ) {
                instThisInstruction.setComments( stTemp );
            }
            else {
                System.out.println( "NO COMMENTS" );
            }
            //  else, ignore

            statInformation = instThisInstruction.validateInstruction();
            
            if ( statInformation.getStatusNumber() == Instruction.I_OK ) {                
                iCurrentLine = vctCodeTable.getCurrentRow();
                System.out.println( "Section comments...current line = " + iCurrentLine );

                if ( codeThisCode.getEditingMode() == Code.B_MODE_INSERT ) {
                    statInformation = codeThisCode.insertSingleLine( 
                        iCurrentLine, instThisInstruction );
                }
                else {  // overwrite
                    statInformation = codeThisCode.changeSingleLine( 
                        iCurrentLine, instThisInstruction );
                }

                if ( statInformation.getStatusNumber() != Instruction.I_OK ) {
                    JOptionPane.showMessageDialog( this, 
                        statInformation.getStatusMessage(), 
                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
                }
                else {
                    clearAll();
                }
            }
            else {
                System.out.println( "INVALID INST" );
                JOptionPane.showMessageDialog( this, 
                    statInformation.getStatusMessage(),
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                    
            }                           
            
        }
        else {  // try superclass
            super.actionPerformed( aeEvent );
        
            if ( objActionSource == super.jbClear ) {
                clearAll();
            }        
        }
    }
        
    //////////////////////// PRIVATE METHODS \\\\\\\\\\\\\\\\\\\\\\\\\\
    private void createObjects() {        
        // no operands...comments stored in their usual location
        ptvhdHelp = new PTVHelpDialog( jfParentFrame, "Help >> Panel >> Section Comments" );
        ptvhdHelp.setHelpFile( "help_panel_comments.html" );
        super.setHelpDialog( ptvhdHelp );
        
        jbApply = super.getApplyInstructionButton();
        jbApply.addActionListener( this );
        
        instThisInstruction = new Instruction();
        opSectionOpcode = new Opcode();
        opSectionOpcode.setOpcode( Opcode.I_OPCODE__COMMENTS );        
        instThisInstruction.setOpcode( opSectionOpcode );
        System.out.println( "createObjects: OPCODE = " + instThisInstruction.getOpcode().getOpcode() );        
    }
    
    private void drawPanel() {
/*        super.drawCustomLabelArea( new Point( 72, 6 ) );
        super.drawCustomCommentsArea( new Rectangle( 8, 40, 28, 28 ),
            new Rectangle( 38, 40, 251, 28 ), new Rectangle( 9, 69, 280, 72 ) );
        super.drawActionButtons( new Point( 73, 156 ) );*/

        super.drawCustomCommentsArea( new Rectangle( 8, 6, 28, 28 ),
            new Rectangle( 38, 6, 251, 28 ), new Rectangle( 9, 35, 280, 72 ) );
        super.drawActionButtons( new Point( 73, 122 ) );
        
        super.addScrollbarsToCommentsArea();
    }
    
    private void clearAll() {
        instThisInstruction = new Instruction();
        instThisInstruction.setOpcode( opSectionOpcode );        
        super.clearForm();
    }

    
    // instance variables
    private Instruction instThisInstruction;
    private JButton jbApply;
    private PTVHelpDialog ptvhdHelp;
    private Opcode opSectionOpcode;
}