/* DO NOT use Declarations in SystemDeclarations because it is a static class
 and because Declarations uses ProgramListener and DeclarationsListener.  Instead
 keep a HashMap of DataObjects using their names as the keys (just like in 
 RecordObject) and retrieve them in a simple fashion. 

FORGET THAT...just use RecordObject instead of Declarations...all of the stuff
needed is right there...I think. */

/*
 * SystemDeclarations.java
 *
 * Created on May 12, 2002, 9:39 PM
 */

//package panelsAndTools;

import java.util.*;
import java.lang.*;
import java.io.*;

/**
 *
 * @author  _
 * @version 
 */
public class SystemDeclarations {
    
    public static Object getDeclaration( String stDeclarationName ) {
        return roSystemDataObjects.getField( stDeclarationName );
    }
    
    public static boolean isObjectDeclaredAsASystemObject( String stName ) {
        int iIndex;
        boolean bFound;
        
        iIndex = 0;
        bFound = false;
        
        for ( ; ( iIndex < I_SYSTEM_OBJECT_COUNT )  &&  ( bFound == false ); iIndex++ ) {
            if ( stName.equals( st1dDataObjectNames[ iIndex ] ) == true ) {
                bFound = true;
            }
        }
        return bFound;
    }
    
    public static boolean isObjectDeclaredAsARegister( String stName ) {
        int iIndex;
        boolean bFound;
        
        iIndex = I_SINGLE_REGISTER_START;
        bFound = false;
        
        for ( ; ( iIndex <= I_SINGLE_REGISTER_END )  &&  ( bFound == false ); iIndex++ ) {
            if ( stName.equals( st1dDataObjectNames[ iIndex ] ) == true ) {
                bFound = true;
            }
        }
        return bFound;
    }
    
    public static final int I_SYSTEM_OBJECT_COUNT = 19;
    
    public static final String[] st1dDataObjectNames = { "INTSIZE", "CHARSIZE",
        "SREG02", "SREG03", "SREG04", "SREG05", "SREG06", "SREG07", "SREG08", 
        "SREG09", "SREG10", "SREG11", "SREG12", "SREG13", "SREG14", "SREG15",
        "ONE", "DISPLAY", "KEYBOARD" };
    
    public static final int I_SINGLE_REGISTER_START = 2;
    public static final int I_SINGLE_REGISTER_END = 8;
    
    public static final int I_DO_NAME_INTSIZE = 0;
    public static final int I_DO_NAME_CHARSIZE = 1;
    public static final int I_DO_NAME_SREG02 = 2;
    public static final int I_DO_NAME_SREG03 = 3;
    public static final int I_DO_NAME_SREG04 = 4;
    public static final int I_DO_NAME_SREG05 = 5;
    public static final int I_DO_NAME_SREG06 = 6;
    public static final int I_DO_NAME_SREG07 = 7;
    public static final int I_DO_NAME_SREG08 = 8;
    public static final int I_DO_NAME_SREG09 = 9;
    public static final int I_DO_NAME_SREG10 = 10;
    public static final int I_DO_NAME_SREG11 = 11;
    public static final int I_DO_NAME_SREG12 = 12;
    public static final int I_DO_NAME_SREG13 = 13;
    public static final int I_DO_NAME_SREG14 = 14;
    public static final int I_DO_NAME_SREG15 = 15;
    public static final int I_DO_NAME_ONE = 16;
    public static final int I_DO_NAME_DISPLAY = 17;
    public static final int I_DO_NAME_KEYBOARD = 18;

    /*public static final int I_DO_NAME_DREG0203 = 19;
    public static final int I_DO_NAME_DREG0405 = 20;
    public static final int I_DO_NAME_DREG0607 = 21;
    public static final int I_DO_NAME_DREG0809 = 22;
    public static final int I_DO_NAME_DREG1011 = 23;
    public static final int I_DO_NAME_DREG1213 = 24;*/
    
    private static RecordObject roSystemDataObjects;
    
    static {
        DataObject doThisObject;
        int iIndex;
        
        roSystemDataObjects = new RecordObject();
        
        // INTSIZE 
        doThisObject = new DataObject();
        doThisObject.setType( DataObject.I_TYPE_INTEGER );
        doThisObject.setStructure( DataObject.I_STRUCTURE_SINGLE_VALUE );
        doThisObject.setRestriction( DataObject.I_RESTRICTION_CONSTANT );
        doThisObject.setValue( "4" );
        doThisObject.validateValue();
        roSystemDataObjects.addField( 
            st1dDataObjectNames[ I_DO_NAME_INTSIZE ], doThisObject );
                
        // CHARSIZE 
        doThisObject = (DataObject)doThisObject.clone();
        doThisObject.setValue( "1" );
        doThisObject.validateValue();
        roSystemDataObjects.addField( 
            st1dDataObjectNames[ I_DO_NAME_CHARSIZE ], doThisObject );

        // ONE
        doThisObject = (DataObject)doThisObject.clone();
        doThisObject.setValue( "1" );
        doThisObject.validateValue();
        roSystemDataObjects.addField( 
            st1dDataObjectNames[ I_DO_NAME_ONE ], doThisObject );
        
        // These system types must have structure declared before type since type
        // determines array size...strucutre setting RESETS array size.        
        // display output
        doThisObject = new DataObject();
        doThisObject.setStructure( DataObject.I_STRUCTURE_1D_ARRAY );    
        doThisObject.setType( DataObject.I_SYSTEM_TYPE_DISPLAY );        
        doThisObject.setRestriction( DataObject.I_RESTRICTION_VARIABLE );        
        roSystemDataObjects.addField( st1dDataObjectNames[ I_DO_NAME_DISPLAY ], 
            doThisObject );

        // keyboard input
        doThisObject = new DataObject();
        doThisObject.setStructure( DataObject.I_STRUCTURE_1D_ARRAY );    
        doThisObject.setType( DataObject.I_SYSTEM_TYPE_KEYBOARD );        
        doThisObject.setRestriction( DataObject.I_RESTRICTION_VARIABLE );
        roSystemDataObjects.addField( st1dDataObjectNames[ I_DO_NAME_KEYBOARD ], 
            doThisObject );
                
        // single registers
        for ( iIndex = I_DO_NAME_SREG02; iIndex <= I_DO_NAME_SREG15; iIndex++ ) {
            doThisObject = new DataObject();
            doThisObject.setType( DataObject.I_SYSTEM_TYPE_SINGLE_REGISTER );
            doThisObject.setStructure( DataObject.I_STRUCTURE_SINGLE_VALUE );
            doThisObject.setRestriction( DataObject.I_RESTRICTION_VARIABLE );
            roSystemDataObjects.addField( st1dDataObjectNames[ iIndex ], 
                doThisObject );
        }
/*
        // double registers
        for ( iIndex = I_DO_NAME_DREG0203; iIndex < I_SYSTEM_OBJECT_COUNT; iIndex++ ) {
            doThisObject = new DataObject();
            doThisObject.setType( DataObject.I_SYSTEM_TYPE_DOUBLE_REGISTER );
            doThisObject.setStructure( DataObject.I_STRUCTURE_SINGLE_VALUE );
            doThisObject.setRestriction( DataObject.I_RESTRICTION_VARIABLE );
            roSystemDataObjects.addField( st1dDataObjectNames[ iIndex ], 
                doThisObject );
        }*/
    }
}
        
    /* Use static DataObjects and not Declarations object.  During
    the initialization of the program, add these static DataObjects
    to the Declarations object.  Rename this class to SystemDataObjects.
    Add this initialization stuff to the Declarations constructor.  Make
    these DataObjects public static. */