/*
 * VisualCodeTable.java
 *
 * Created on April 27, 2002, 10:50 AM
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.util.*;

/**
 *
 * @author  _
 * @version 
 */

public class VisualCodeTable extends JTable 
    implements MouseListener, ActionListener, MouseMotionListener {

    public VisualCodeTable( Code codeObject, VisualCodeTableModel vctm ) {     
        codeData = codeObject;
        vctmTableData = vctm;
        vctmTableData.setCodeModel( codeData );
        setupObjectTable();
        addListener();
    }
        
    public int getFirstSelectedTableRow() {
        System.out.println( "First Row = " + iFirstSelectedRow );
        return iFirstSelectedRow;
    }

    public int getLastSelectedTableRow() {
        System.out.println( "Last Row = " + iLastSelectedRow );
        return iLastSelectedRow;
    }    
    
    public void setCodeTableListener( CodeTableListener ctlCursorListener ) {
        ctlCodeCursorListener = ctlCursorListener;
    }
    
    public ListSelectionModel getTableSelectionModel() {
        return lsmListModel;
    }
    
    public void updateTableCursor() {
        bEditingMode = codeData.getEditingMode();
        itcrCellRenderer.setEditingMode( bEditingMode );
        vctmTableData.changeSingleLineOfCode( this.getSelectedRow() );
    }
    
    public void moveCursor( int iMagnitude ) {
        int iThisRow;
        
        if ( iMagnitude == 0 ) {  // special case to move cursor to the top of code
            lsmListModel.setSelectionInterval( 0, 0 );
            itcrCellRenderer.setCurrentRow( 0 );
        }            
        else if ( bEditingMode == Code.B_MODE_INSERT ) {
            iThisRow = iCurrentRow;
            System.out.println( "before move cursor...TABLE ROW = " + iCurrentRow + "   DISTANCE = " + iMagnitude );
            iCurrentRow = iThisRow + iMagnitude;
            lsmListModel.setSelectionInterval( iCurrentRow, iCurrentRow );
            itcrCellRenderer.setCurrentRow( iCurrentRow );
            System.out.println( "AFTER move cursor...TABLE ROW = " + iCurrentRow );
        }
        // else, do not move cursor
    }
            
    public int getCurrentRow() {
        //return this.getEditingRow();
        //return iFirstSelectedRow;
        System.out.println( "get current row... " + iCurrentRow );        
        //return lsmListModel.getAnchorSelectionIndex();
        return iCurrentRow;
    }
    
    public Code getCode() {
        return codeData;
    }

    //---------------- ActionListener Implementation --------------\\
    public void actionPerformed( ActionEvent aeEvent ) {
        int iSegmentLines, iFirstHighlightedRow, iLastHighlightedRow, 
            iPreviousLineCount, iLastRowBeforeHighlightedRows, iHighlightedRows;
        String stMessage, stSelectedMenuItem;
        Object objThisObject;
        Code codeSegment;
        Vector vInstructionSegment;
        Status statInformation;
        boolean bEditingMode;
        Instruction instInstructionToMove, instCurrentInstruction;;

        statInformation = new Status( Code.I_OK );
        stSelectedMenuItem = aeEvent.getActionCommand();

        if ( stSelectedMenuItem.equals( 
            AllPurposeMenu.ST_MENUITEM__PANEL_FOR_INSTRUCTION ) ) {

            if ( iFirstSelectedRow == iLastSelectedRow ) {
                objThisObject = vctmTableData.getValueAt( iFirstSelectedRow, 0 );

                if ( objThisObject instanceof Instruction ) {
                    instCurrentInstruction = (Instruction)objThisObject;
                    System.out.println( "Sending Instruction..." + instCurrentInstruction );
                    ctlCodeCursorListener.showPanelForLineOfCode( instCurrentInstruction );
                }
                // else, nothing
            }
            else {
                JOptionPane.showMessageDialog( this, "Only one line of code may " 
                    + " have its panel displayed at a time.", ST_APPLICATION_NAME
                    , JOptionPane.ERROR_MESSAGE );
            }
        }
        else if ( stSelectedMenuItem.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_CUT ) ) {
            objThisObject = codeData.getLines( iFirstSelectedRow, iLastSelectedRow );

            if ( objThisObject instanceof java.util.List ) {
                vInstructionSegment = new Vector( (java.util.List)objThisObject );
                codeSegment = new Code( vInstructionSegment );
                AllPurposeMenu.setCodeIntoClipboard( codeSegment );
                statInformation = 
                    codeData.deleteLines( iFirstSelectedRow, iLastSelectedRow );

                if ( statInformation.getStatusNumber() != Code.I_OK ) {                    
                    JOptionPane.showMessageDialog( this, statInformation.getStatusMessage(),
                        ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
                }
            }
            else if ( objThisObject instanceof Status ) {
                statInformation = (Status)objThisObject;

                JOptionPane.showMessageDialog( this, statInformation.getStatusMessage(),
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
            }
            else {
                stMessage = "An internal error occurred when cutting lines.";
                JOptionPane.showMessageDialog( this, stMessage, 
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
            }
        }
        else if ( stSelectedMenuItem.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_COPY ) ) {
            objThisObject = codeData.getLines( iFirstSelectedRow, iLastSelectedRow );

            if ( objThisObject instanceof java.util.List ) {
                vInstructionSegment = new Vector( (java.util.List)objThisObject );
                codeSegment = new Code( vInstructionSegment );
                AllPurposeMenu.setCodeIntoClipboard( codeSegment );
            }
            else if ( objThisObject instanceof Status ) {
                statInformation = (Status)objThisObject;
                JOptionPane.showMessageDialog( this, statInformation.getStatusMessage(), 
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
            }
            else {
                stMessage = "An internal error occurred when copying lines.";
                JOptionPane.showMessageDialog( this, stMessage,
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );
            }                
        }
        else if ( stSelectedMenuItem.equals( AllPurposeMenu.ST_MENUITEM__MAIN_EDIT_PASTE ) ) {
            //  PASTE RULE: Editing mode is irrelevant.  If nothing is
            //  highlighted, then plainly insert all of the rows at the 
            //  cursor location.  If rows are highlighted, overwrite the 
            //  existing instructions with the pasted instructions.  If the
            //  number of pasted instructions is greater than the number of
            //  highlighted instructions, insert the remaining instructions
            //  in the row after the last highlighted row (if the end of file
            //  is the last highlighted row, append the remaining rows).  
            //  If less, delete the remaining highlighted rows.

            codeSegment = AllPurposeMenu.getCodeFromClipboard();

            iHighlightedRows = iLastSelectedRow - iFirstSelectedRow + 1;
            System.out.println( "highlighted rows = " + iHighlightedRows
                + "   first = " + iFirstSelectedRow + "   last = " + iLastSelectedRow );
            
            if ( codeData.getNumberOfLines() == 0 ) {
                statInformation = codeData.insertLines( 0, codeSegment );
            }
            else {                
                iFirstHighlightedRow = iFirstSelectedRow;
                iLastHighlightedRow = iLastSelectedRow;
                iPreviousLineCount = codeData.getNumberOfLines();
                
                if ( iFirstHighlightedRow != iLastHighlightedRow ) {
                    codeData.deleteLines( iFirstHighlightedRow, iLastHighlightedRow );
                }

                    statInformation = codeData.insertLines( 
                        iFirstHighlightedRow, codeSegment );
                
                /*if ( iFirstHighlightedRow == 0 ) {  // left side                   
                    statInformation = codeData.insertLines( 0, codeSegment );
                }
                else if ( iLastHighlightedRow == ( iPreviousLineCount - 1 ) ) {
                    // right side
                    // insertion increases existing objects' indices
                    iLastRowBeforeHighlightedRows = iFirstHighlightedRow - 1;
                    instInstructionToMove = (Instruction) // should be Instruction
                        codeData.getSingleLine( iLastRowBeforeHighlightedRows );

                    statInformation = codeData.insertLines( 
                        iLastRowBeforeHighlightedRows, codeSegment );

                    if ( statInformation.getStatusNumber() == Code.I_OK ) {
                        codeData.deleteSingleLine( codeData.getNumberOfLines() - 1 );
                        codeData.insertSingleLine( iLastRowBeforeHighlightedRows,                         
                            instInstructionToMove );
                    }
                }
                else {  // middle-rows paste or single line paste
                    statInformation = codeData.insertLines( 
                        iFirstHighlightedRow, codeSegment );
                }*/
            }  // end of insertion instructions

            if ( statInformation.getStatusNumber() != Code.I_OK ) {
                stMessage = statInformation.getStatusMessage();
                JOptionPane.showMessageDialog( this, stMessage,
                    ST_APPLICATION_NAME, JOptionPane.ERROR_MESSAGE );                        
            }
            else {
                // successful operation, un-highlight rows
                lsmListModel.clearSelection();
            }
        }            
    }
    
    //------------- MouseMotionListener Implementation -------\\
    public void mouseMoved( MouseEvent meEvent ) {
        int iX, iY;
        Object objTemp, objInstruction;
        //String stComments, stPseudocode;
        Instruction instThisInstruction;
        
        objTemp = meEvent.getComponent();
        
        if ( objTemp instanceof JComponent ) {
            iX = meEvent.getX();
            iY = meEvent.getY();
            objInstruction = vctmTableData.getValueAt( 
                ( iY / I_CELL_HEIGHT ), 0 );
            
            if ( objInstruction instanceof Instruction ) {
                instThisInstruction = (Instruction)objInstruction;
                //stComments = instThisInstruction.getComments();
                //stPseudocode = instThisInstruction.getPseudocode();
                itcrCellRenderer.setComponentToolTip( (JComponent)objTemp, 
                    new Point( iX, ( iY % I_CELL_HEIGHT ) ), instThisInstruction
                    /*stComments,
                    stPseudocode*/ );
            }
        }
    }
    
    public void mouseDragged( MouseEvent meEvent ) {} 
    
    //------------ MouseListener Implementation ---------------\\
    public void mouseReleased( MouseEvent meEvent ) { 
        int iCurrentXLocation, iCurrentYLocation, iLastRow, iModifiers;

        if ( meEvent.isPopupTrigger() ) {
            iCurrentXLocation = meEvent.getX();
            iCurrentYLocation = meEvent.getY();
            iLastRow = codeData.getNumberOfLines() - 1;

            // only if last row that has nothing should cut, copy be ignored
            System.out.println( "Current row = " + iCurrentRow + "   "
                + "Last Row = " + iLastRow );
            if ( ( iCurrentRow == iLastRow )  || 
                 ( iLastSelectedRow == iLastRow ) ||
                 ( ( bEditingMode == Code.B_MODE_OVERWRITE )  &&
                   ( iCurrentRow == iLastRow ) ) ) {
                bsRestrictionFlags.clear( AllPurposeMenu.I_FLAG_OBJECT );
                apmMenu.setMenuForEmptyPanelArea();
            }
            else {
                bsRestrictionFlags.set( AllPurposeMenu.I_FLAG_OBJECT );
                apmMenu.setMenuForVisualCodeTable( AllPurposeMenu.I_CODE_PANEL );                
            }
            apmMenu.setMenuForVisualCodeTable( AllPurposeMenu.I_CODE_PANEL );
            apmMenu.setDataObjectMenuRestricitions( bsRestrictionFlags );
            apmMenu.updateCodeEditingMode();            
            apmMenu.show( meEvent.getComponent(), iCurrentXLocation, 
                iCurrentYLocation );
        }                    
    }

    public void mouseEntered( MouseEvent meEvent ) {}
    public void mouseClicked( MouseEvent meEvent ) {}
    public void mousePressed( MouseEvent meEvent ) {}
    public void mouseExited( MouseEvent meEvent ) {}    
        
    //////////////////// INTERNAL FUNCTIONS \\\\\\\\\\\\\\\\\\\\\
    private void setupObjectTable() {
        JScrollPane jspTableScrollPane;
        Dimension diTableSize;

        //diTableSize = new Dimension( 700, 375 );
        
        this.setModel( vctmTableData );
        //this.setPreferredScrollableViewportSize( diTableSize );
        //jspTableScrollPane = new JScrollPane( this );
        //this.add( jspTableScrollPane, BorderLayout.CENTER);

        itcrCellRenderer = new InstructionTableCellRenderer();
        //itcrCellRenderer.setCurrentRow( 0 );
        this.setDefaultRenderer( Instruction.class, itcrCellRenderer );
        //this.setDefaultRenderer( Instruction.class, new SomeRenderer() );
                
        this.setRowMargin( 3 );
        this.setRowHeight( I_CELL_HEIGHT );
        
        this.setColumnSelectionAllowed( false );
        this.setRowSelectionAllowed( true );
        this.setSelectionMode( ListSelectionModel.SINGLE_INTERVAL_SELECTION );
        this.setTableHeader( null ); // THIS IS LEGAL
  
        apmMenu = new AllPurposeMenu( this );  
        apmMenu.setCodeObject( codeData );
        
        // not needed because this will be disabled anyway
        apmMenu.setSortableDeclarationsModel( new SortableDeclarationsTableModel() );
        bsRestrictionFlags = new BitSet( AllPurposeMenu.I_NUMBER_OF_FLAGS );        
        
        updateTableCursor();
    }
    
    private void addListener() {                
        this.addMouseMotionListener( this );
        this.addMouseListener( this );
        
        lslListener = new ListSelectionListener() {
            public void valueChanged( ListSelectionEvent lseEvent ) {
                Object objTemp;
                ListSelectionModel lsmCurrentListModel;

                lsmCurrentListModel = 
                    (ListSelectionModel)lseEvent.getSource();
                
                iFirstSelectedRow = lsmCurrentListModel.getMinSelectionIndex();
                System.out.println( "FIRST SELECTED ROW = " + iFirstSelectedRow );
                iLastSelectedRow = lsmCurrentListModel.getMaxSelectionIndex();
                System.out.println( "LAST SELECTED ROW = " + iLastSelectedRow );
                    
                iCurrentRow = lsmCurrentListModel.getLeadSelectionIndex();
                itcrCellRenderer.setCurrentRow( iCurrentRow );
            }
        };
        lsmListModel = getSelectionModel();
        lsmListModel.addListSelectionListener( lslListener );        
        // end of adaption                
        
        lsmListModel.setSelectionInterval( 0, 0 );
    }
    
    
    // instance variables
    private VisualCodeTableModel vctmTableData;
    private ListSelectionListener lslListener;
    private ListSelectionModel lsmListModel;    
    private int iFirstSelectedRow, iLastSelectedRow, iCurrentRow;
    private Instruction instCurrentInstruction;
    private CodeTableListener ctlCodeCursorListener;
    private Code codeData;
    private InstructionTableCellRenderer itcrCellRenderer;
    private boolean bEditingMode; 
    private AllPurposeMenu apmMenu;
    private BitSet bsRestrictionFlags;
    
    private static final String ST_APPLICATION_NAME = "Panels :: Tools :: Views";     
    private static final int I_CELL_HEIGHT = 91;  //was 97
}  